=== modified file 'debian/build/mozbuild.mk'
--- debian/build/mozbuild.mk	2012-11-14 20:42:50 +0000
+++ debian/build/mozbuild.mk	2013-02-20 09:17:36 +0000
@@ -32,6 +32,11 @@
 MOZ_OBJDIR		:= $(DEB_BUILDDIR)/obj-$(DEB_HOST_GNU_TYPE)
 MOZ_DISTDIR		:= $(MOZ_OBJDIR)/$(MOZ_MOZDIR)/dist
 
+# The package name
+MOZ_PKG_NAME		:= $(shell dpkg-parsechangelog | sed -n 's/^Source: *\(.*\)$$/\1/ p')
+# The binary name to use (derived from the package name by default)
+MOZ_APP_NAME		?= $(MOZ_PKG_NAME)
+
 # Define other variables used throughout the build
 # The value of "Name" to use in application.ini, which the profile location is based on.
 # Derived from the desired MOZ_APP_NAME, but can be overridden
@@ -58,6 +63,8 @@
 $(error "Need to set MOZ_PKG_NAME")
 endif
 
+MOZ_PKG_NAMES = $(shell sed -n 's/Package\: \(.*\)/\1/ p' < debian/control)
+
 DEB_MAKE_MAKEFILE	:= client.mk
 # Without this, CDBS passes CFLAGS and CXXFLAGS options to client.mk, which breaks the build
 DEB_MAKE_EXTRA_ARGS	:=
@@ -68,6 +75,8 @@
 DEB_DH_STRIP_ARGS	:= --dbg-package=$(MOZ_PKG_NAME)-dbg
 # We don't want build-tree/mozilla/README to be shipped as a doc
 DEB_INSTALL_DOCS_ALL 	:= $(NULL)
+# scour breaks the testsuite
+DEB_DH_SCOUR_ARGS := -N$(MOZ_PKG_NAME)-testsuite
 
 MOZ_VERSION		:= $(shell cat $(DEB_SRCDIR)/$(MOZ_APP)/config/version.txt)
 MOZ_LIBDIR		:= usr/lib/$(MOZ_APP_NAME)
@@ -75,6 +84,7 @@
 MOZ_IDLDIR		:= usr/share/idl/$(MOZ_APP_NAME)
 MOZ_SDKDIR		:= usr/lib/$(MOZ_APP_NAME)-devel
 MOZ_ADDONDIR		:= usr/lib/$(MOZ_APP_NAME)-addons
+MOZ_TESTDIR		:= usr/lib/$(MOZ_APP_NAME)-testsuite
 
 # The profile directory is determined from the Vendor and Name fields of
 # the application.ini
@@ -83,8 +93,8 @@
 else
 PROFILE_BASE = $(shell echo $(MOZ_VENDOR) | tr A-Z a-z)/
 endif
-MOZ_PROFILEDIR		= .$(PROFILE_BASE)$(MOZ_APP_BASENAME_L)
-MOZ_DEFAULT_PROFILEDIR	= .$(PROFILE_BASE)$(MOZ_DEFAULT_APP_BASENAME_L)
+MOZ_PROFILEDIR		:= .$(PROFILE_BASE)$(MOZ_APP_BASENAME_L)
+MOZ_DEFAULT_PROFILEDIR	:= .$(PROFILE_BASE)$(MOZ_DEFAULT_APP_BASENAME_L)
 
 DEB_AUTO_UPDATE_DEBIAN_CONTROL	= no
 
@@ -162,6 +172,7 @@
 endif
 endif
 
+export NO_PNG_PKG_MANGLE=1
 export LDFLAGS
 export DEB_BUILD_HARDENING=1
 export MOZCONFIG=$(CURDIR)/debian/config/mozconfig
@@ -182,54 +193,10 @@
 LANGPACK_DIR := $(DEB_HOST_GNU_SYSTEM)-$(DEB_HOST_GNU_CPU)/xpi
 endif
 
-ifneq ($(MOZ_PKG_NAME),$(MOZ_APP_NAME))
-$(foreach pkg, APP GM GS DEV DBG MS, $(foreach rel, CONFLICTS PROVIDES, $(ifneq ,$(PKG_$(pkg)_$(rel)_ARGS), eval $(PKG_$(pkg)_$(rel)_ARGS) += ", ")))
-PKG_APP_CONFLICTS_ARGS += "$(MOZ_APP_NAME)"
-PKG_APP_PROVIDES_ARGS += "$(MOZ_APP_NAME)"
-PKG_GM_CONFLICTS_ARGS += "$(MOZ_APP_NAME)-globalmenu"
-PKG_GM_PROVIDES_ARGS += "$(MOZ_APP_NAME)-globalmenu"
-PKG_GS_CONFLICTS_ARGS += "$(MOZ_APP_NAME)-gnome-support"
-PKG_GS_PROVIDES_ARGS += "$(MOZ_APP_NAME)-gnome-support"
-PKG_DEV_CONFLICTS_ARGS += "$(MOZ_APP_NAME)-dev"
-PKG_DEV_PROVIDES_ARGS += "$(MOZ_APP_NAME)-dev"
-PKG_DBG_CONFLICTS_ARGS += "$(MOZ_APP_NAME)-dbg"
-PKG_DBG_PROVIDES_ARGS += "$(MOZ_APP_NAME)-dbg"
-PKG_MS_CONFLICTS_ARGS += "$(MOZ_APP_NAME)-mozsymbols"
-PKG_MS_PROVIDES_ARGS += "$(MOZ_APP_NAME)-mozsymbols"
-endif
-
-ifneq (,$(filter lucid maverick natty, $(DISTRIB_CODENAME)))
-GCONF_DEPENDS := libgconf2-4
-endif
-
 ifeq (1,$(MOZ_ENABLE_GLOBALMENU))
-ifneq (,$(PKG_SUPPORT_RECOMMENDS))
-PKG_SUPPORT_RECOMMENDS += ", "
-endif
-PKG_SUPPORT_RECOMMENDS += $(MOZ_PKG_NAME)-globalmenu
-endif
-
-DEB_DH_GENCONTROL_ARGS_$(MOZ_PKG_NAME) := -- -Vapp:Replaces="$(PKG_APP_REPLACES_ARGS)" -Vapp:Breaks="$(PKG_APP_BREAKS_ARGS)" -Vapp:Conflicts="$(PKG_APP_CONFLICTS_ARGS)" \
-					     -Vapp:Provides="$(PKG_APP_PROVIDES_ARGS)" $(PKG_APP_EXTRA_ARGS) -Vsupport:Suggests="$(PKG_SUPPORT_SUGGESTS)" \
-					     -Vsupport:Recommends="$(PKG_SUPPORT_RECOMMENDS)"
-DEB_DH_GENCONTROL_ARGS_$(MOZ_PKG_NAME)-globalmenu := -- -Vgm:Replaces="$(PKG_GM_REPLACES_ARGS)" -Vgm:Breaks="$(PKG_GM_BREAKS_ARGS)" -Vgm:Conflicts="$(PKG_GM_CONFLICTS_ARGS)" \
-							-Vgm:Provides="$(PKG_GM_PROVIDES_ARGS)" $(PKG_GM_EXTRA_ARGS)
-DEB_DH_GENCONTROL_ARGS_$(MOZ_PKG_NAME)-gnome-support := -- -Vgs:Replaces="$(PKG_GS_REPLACES_ARGS)" -Vgs:Breaks="$(PKG_GS_BREAKS_ARGS)" -Vgs:Conflicts="$(PKG_GS_CONFLICTS_ARGS)" \
-							   -Vgs:Provides="$(PKG_GS_PROVIDES_ARGS)" -Vgconf:Depends="$(GCONF_DEPENDS)" $(PKG_GS_EXTRA_ARGS)
-DEB_DH_GENCONTROL_ARGS_$(MOZ_PKG_NAME)-dev := -- -Vdev:Replaces="$(PKG_DEV_REPLACES_ARGS)" -Vdev:Breaks="$(PKG_DEV_BREAKS_ARGS)" -Vdev:Conflicts="$(PKG_DEV_CONFLICTS_ARGS)" \
-						 -Vdev:Provides="$(PKG_DEV_PROVIDES_ARGS)" $(PKG_DEV_EXTRA_ARGS)
-DEB_DH_GENCONTROL_ARGS_$(MOZ_PKG_NAME)-dbg := -- -Vdbg:Replaces="$(PKG_DBG_REPLACES_ARGS)" -Vdbg:Breaks="$(PKG_DBG_BREAKS_ARGS)" -Vdbg:Conflicts="$(PKG_DBG_CONFLICTS_ARGS)" \
-						 -Vdbg:Provides="$(PKG_DBG_PROVIDES_ARGS)" $(PKG_DBG_EXTRA_ARGS)
-DEB_DH_GENCONTROL_ARGS_$(MOZ_PKG_NAME)-mozsymbols := -- -Vms:Replaces="$(PKG_MS_REPLACES_ARGS)" -Vms:Breaks="$(PKG_MS_BREAKS_ARGS)" -Vms:Conflicts="$(PKG_MS_CONFLICTS_ARGS)" \
-							-Vms:Provides="$(PKG_MS_PROVIDES_ARGS)" $(PKG_MS_EXTRA_ARGS)
-LOCALE_PACKAGES := $(shell cat $(CURDIR)/debian/control | grep "^Package:[[:space:]]*$(MOZ_PKG_NAME)-locale\-" | sed -n -e 's/^Package\:[[:space:]]*\([^[:space:]]*\)/\1/ p')
-ifneq ($(MOZ_PKG_NAME),$(MOZ_APP_NAME))
-$(foreach locale_package, $(LOCALE_PACKAGES), $(eval PKG_$(locale_package)_CONFLICTS_ARGS := $(subst $(MOZ_PKG_NAME),$(MOZ_APP_NAME),$(locale_package))))
-$(foreach locale_package, $(LOCALE_PACKAGES), $(eval PKG_$(locale_package)_PROVIDES_ARGS := $(subst $(MOZ_PKG_NAME),$(MOZ_APP_NAME),$(locale_package))))
-endif
-$(foreach locale_package, $(LOCALE_PACKAGES), $(eval DEB_DH_GENCONTROL_ARGS_$(locale_package) := -- -Vlp:Conflicts="$(PKG_$(locale_package)_PROVIDES_ARGS)" \
-												    -Vlp:Provides="$(PKG_$(locale_package)_PROVIDES_ARGS)" \
-												    $(PKG_$(locale_package)_EXTRA_ARGS)))
+MOZ_PKG_SUPPORT_RECOMMENDS ?= $(MOZ_PKG_NAME)-globalmenu
+endif
+MOZ_PKG_SUPPORT_SUGGESTS ?= $(MOZ_PKG_NAME)-gnome-support
 
 # Defines used for the Mozilla text preprocessor
 MOZ_DEFINES += 	-DMOZ_LIBDIR="$(MOZ_LIBDIR)" -DMOZ_APP_NAME="$(MOZ_APP_NAME)" -DMOZ_APP_BASENAME="$(MOZ_APP_BASENAME)" \
@@ -240,7 +207,7 @@
 		-DMOZ_OBJDIR="$(MOZ_OBJDIR)" -DDEB_BUILDDIR="$(DEB_BUILDDIR)" -DMOZ_PYTHON="$(MOZ_PYTHON)" -DMOZ_PROFILEDIR="$(MOZ_PROFILEDIR)" \
 		-DMOZ_PKG_BASENAME="$(MOZ_PKG_BASENAME)" -DMOZ_DEFAULT_PROFILEDIR="$(MOZ_DEFAULT_PROFILEDIR)" \
 		-DMOZ_DEFAULT_APP_NAME="$(MOZ_DEFAULT_APP_NAME)" -DMOZ_DEFAULT_APP_BASENAME="$(MOZ_DEFAULT_APP_BASENAME)" \
-		-DDISTRIB_VERSION="$(DISTRIB_VERSION_MAJOR)$(DISTRIB_VERSION_MINOR)"
+		-DDISTRIB_VERSION="$(DISTRIB_VERSION_MAJOR)$(DISTRIB_VERSION_MINOR)" -DMOZ_TESTDIR="$(MOZ_TESTDIR)"
 
 ifeq (1, $(MOZ_ENABLE_BREAKPAD))
 MOZ_DEFINES += -DMOZ_ENABLE_BREAKPAD
@@ -273,15 +240,15 @@
 MOZ_DEFINES += -DDEB_PARALLEL_JOBS=$(DEB_PARALLEL_JOBS)
 endif
 
-DEBIAN_EXECUTABLES = $(MOZ_PKG_NAME)/$(MOZ_LIBDIR)/$(MOZ_PKG_BASENAME).sh \
-		     $(NULL)
+MOZ_EXECUTABLES_$(MOZ_PKG_NAME) +=	$(MOZ_LIBDIR)/$(MOZ_PKG_BASENAME).sh \
+					$(NULL)
 
 pkgname_subst_files = \
 	debian/config/mozconfig \
 	$(MOZ_PKGNAME_SUBST_FILES) \
 	$(NULL)
 
-$(foreach pkg, $(MOZ_PKG_NAME) $(MOZ_PKG_NAME)-gnome-support $(MOZ_PKG_NAME)-globalmenu $(MOZ_PKG_NAME)-dev $(MOZ_PKG_NAME)-dbg $(MOZ_PKG_NAME)-mozsymbols, \
+$(foreach pkg,$(MOZ_PKG_NAMES), \
 	$(foreach dhfile, install dirs links manpages postinst preinst postrm prerm lintian-overrides, $(eval pkgname_subst_files += \
 	$(shell if [ -f $(CURDIR)/$(subst $(MOZ_PKG_NAME),$(MOZ_PKG_BASENAME),debian/$(pkg).$(dhfile).in) ]; then \
 		echo debian/$(pkg).$(dhfile); fi))))
@@ -319,34 +286,51 @@
 make-buildsymbols: debian/stamp-makebuildsymbols
 debian/stamp-makebuildsymbols: debian/stamp-makefile-build
 ifeq (1, $(MOZ_ENABLE_BREAKPAD))
-	# create build symbols
-	cd $(MOZ_OBJDIR); \
-	        $(MAKE) buildsymbols MOZ_SYMBOLS_EXTRA_BUILDID=$(shell date -d "`dpkg-parsechangelog | grep Date: | sed -e 's/^Date: //'`" +%y%m%d%H%M%S)-$(DEB_HOST_GNU_CPU)
+        $(MAKE) -C $(MOZ_OBJDIR) buildsymbols MOZ_SYMBOLS_EXTRA_BUILDID=$(shell date -d "`dpkg-parsechangelog | grep Date: | sed -e 's/^Date: //'`" +%y%m%d%H%M%S)-$(DEB_HOST_GNU_CPU)
 endif
-	touch $@
-
-LANGPACK_TARGETS = $(shell cat $(CURDIR)/debian/config/locales.shipped | sed -n 's/\#.*//;/^$$/d;s/:/,/ p')
-
-make-langpack-xpis: $(foreach target, $(LANGPACK_TARGETS), debian/stamp-make-langpack-xpi-$(target))
-debian/stamp-make-langpack-xpi-%: LANGUAGE = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\1/')
+	@touch $@
+
+make-testsuite: debian/stamp-maketestsuite
+debian/stamp-maketestsuite: debian/stamp-makefile-build
+	$(MAKE) -C $(MOZ_OBJDIR) package-tests
+	@touch $@
+
+make-langpack-xpis: $(foreach target,$(shell sed -n 's/\#.*//;/^$$/d;s/\([^\:]*\)\:\?.*/\1/ p' < $(CURDIR)/debian/config/locales.shipped),debian/stamp-make-langpack-xpi-$(target))
 debian/stamp-make-langpack-xpi-%:
 	@echo ""
 	@echo ""
-	@echo "* Building language pack xpi for $(LANGUAGE)"
+	@echo "* Building language pack xpi for $*"
 	@echo ""
 
-	rm -rf $(CURDIR)/debian/l10n-mergedirs/$(LANGUAGE)
-	mkdir -p $(CURDIR)/debian/l10n-mergedirs/$(LANGUAGE)
+	rm -rf $(CURDIR)/debian/l10n-mergedirs/$*
+	mkdir -p $(CURDIR)/debian/l10n-mergedirs/$*
 
 	@export PATH=$(CURDIR)/compare-locales/scripts/:$$PATH ; \
 	export PYTHONPATH=$(CURDIR)/compare-locales/lib ; \
 	cd $(MOZ_OBJDIR)/$(MOZ_APP)/locales ; \
-		$(MAKE) merge-$(LANGUAGE) LOCALE_MERGEDIR=$(CURDIR)/debian/l10n-mergedirs/$(LANGUAGE) || exit 1 ; \
-		$(MAKE) langpack-$(LANGUAGE) LOCALE_MERGEDIR=$(CURDIR)/debian/l10n-mergedirs/$(LANGUAGE) || exit 1; \
-
-	touch $@
-
-common-build-arch:: run-tests $(pkgconfig_files) make-langpack-xpis
+		$(MAKE) merge-$* LOCALE_MERGEDIR=$(CURDIR)/debian/l10n-mergedirs/$* || exit 1 ; \
+		$(MAKE) langpack-$* LOCALE_MERGEDIR=$(CURDIR)/debian/l10n-mergedirs/$* || exit 1;
+	@touch $@
+
+common-build-arch:: make-langpack-xpis $(pkgconfig_files) make-buildsymbols make-testsuite run-tests
+
+install/$(MOZ_PKG_NAME)::
+	@echo "Adding suggests / recommends on support packages"
+	@echo "$(MOZ_PKG_SUPPORT_SUGGESTS)" | perl -0 -ne 's/[ \t\n]+/ /g; /\w/ and print "support:Suggests=$$_\n"' >> debian/$(MOZ_PKG_NAME).substvars
+	@echo "$(MOZ_PKG_SUPPORT_RECOMMENDS)" | perl -0 -ne 's/[ \t\n]+/ /g; /\w/ and print "support:Recommends=$$_\n"' >> debian/$(MOZ_PKG_NAME).substvars
+
+install/$(MOZ_PKG_NAME)-gnome-support::
+ifneq (,$(filter lucid maverick natty, $(DISTRIB_CODENAME)))
+	@echo "Adding libgconf2-4 dependency"
+	@echo "gconf:Depends=libgconf2-4" >> debian/$(MOZ_PKG_NAME)-gnome-support.substvars
+endif
+
+ifneq ($(MOZ_PKG_NAME),$(MOZ_APP_NAME))
+install/%::
+	@echo "Adding conflicts / provides for renamed package"
+	@echo "app:Conflicts=$(subst $(subst $(MOZ_APP_NAME),,$(MOZ_PKG_NAME)),,$*)" >> debian/$*.substvars
+	@echo "app:Provides=$(subst $(subst $(MOZ_APP_NAME),,$(MOZ_PKG_NAME)),,$*)" >> debian/$*.substvars
+endif
 
 common-install-arch common-install-indep::
 	$(foreach dir,$(MOZ_LIBDIR) $(MOZ_INCDIR) $(MOZ_IDLDIR) $(MOZ_SDKDIR), \
@@ -355,8 +339,6 @@
 			mv debian/tmp/$(dir)-$(MOZ_VERSION) debian/tmp/$(dir); \
 		fi; )
 
-common-binary-arch:: make-buildsymbols
-
 binary-install/$(MOZ_PKG_NAME)::
 	install -m 0644 $(CURDIR)/debian/apport/blacklist $(CURDIR)/debian/$(MOZ_PKG_NAME)/etc/apport/blacklist.d/$(MOZ_PKG_NAME)
 	install -m 0644 $(CURDIR)/debian/apport/native-origins $(CURDIR)/debian/$(MOZ_PKG_NAME)/etc/apport/native-origins.d/$(MOZ_PKG_NAME)
@@ -364,14 +346,15 @@
 ifeq (1, $(MOZ_ENABLE_GLOBALMENU))
 binary-install/$(MOZ_PKG_NAME)-globalmenu::
 	unzip -o -d debian/$(MOZ_PKG_NAME)-globalmenu/$(MOZ_ADDONDIR)/extensions/globalmenu@ubuntu.com/ $(MOZ_DISTDIR)/xpi-stage/globalmenu.xpi
-	find debian/$(MOZ_PKG_NAME)-globalmenu/$(MOZ_ADDONDIR)/extensions/globalmenu@ubuntu.com/ -type f -executable | xargs chmod -x
 endif
 
 GNOME_SUPPORT_FILES = libmozgnome.so
-
-binary-post-install/$(MOZ_PKG_NAME)::
+binary-post-install/$(MOZ_PKG_NAME):: install-searchplugins-,$(MOZ_PKG_NAME)
 	$(foreach file,$(GNOME_SUPPORT_FILES),rm -fv debian/$(MOZ_PKG_NAME)/$(MOZ_LIBDIR)/components/$(file);) true
 
+MOZ_LANGPACK_TARGETS := $(shell sed -n 's/[^\:]*\:\?\(.*\)/\1/ p' < debian/config/locales.shipped | uniq)
+$(patsubst %,binary-post-install/$(MOZ_PKG_NAME)-locale-%,$(MOZ_LANGPACK_TARGETS)):: binary-post-install/$(MOZ_PKG_NAME)-locale-%: install-langpack-xpis-% install-searchplugins-%
+
 binary-post-install/$(MOZ_PKG_NAME)-dev::
 	rm -f debian/$(MOZ_PKG_NAME)-dev/$(MOZ_INCDIR)/nspr/md/_linux.cfg
 	dh_link -p$(MOZ_PKG_NAME)-dev $(MOZ_INCDIR)/nspr/prcpucfg.h $(MOZ_INCDIR)/nspr/md/_linux.cfg
@@ -379,46 +362,82 @@
 binary-post-install/%::
 	find debian/$* -name .mkdir.done -delete
 
-install-langpack-xpis: $(foreach target, $(LANGPACK_TARGETS), install-langpack-xpi-$(target))
-install-langpack-xpi-%: LANGUAGE = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\1/')
-install-langpack-xpi-%: PKGNAME = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\2/')
-install-langpack-xpi-%: XPI_ID = $(shell python $(CURDIR)/debian/build/get-xpi-id.py $(CURDIR)/$(MOZ_DISTDIR)/$(LANGPACK_DIR)/$(MOZ_APP_NAME)-$(MOZ_VERSION).$(LANGUAGE).langpack.xpi 2>/dev/null;)
-install-langpack-xpi-%:
+install-langpack-xpis-%:
 	@echo ""
-	@echo "Installing $(MOZ_APP_NAME)-$(MOZ_VERSION).$(LANGUAGE).langpack.xpi to $(XPI_ID).xpi in to $(MOZ_PKG_NAME)-locale-$(PKGNAME)"
-	dh_installdirs -p$(MOZ_PKG_NAME)-locale-$(PKGNAME) $(MOZ_ADDONDIR)/extensions
-	cp $(CURDIR)/$(MOZ_DISTDIR)/$(LANGPACK_DIR)/$(MOZ_APP_NAME)-$(MOZ_VERSION).$(LANGUAGE).langpack.xpi \
-		$(CURDIR)/debian/$(MOZ_PKG_NAME)-locale-$(PKGNAME)/$(MOZ_ADDONDIR)/extensions/$(XPI_ID).xpi
-
-install-searchplugins:: install-searchplugins-en-US $(if $(wildcard debian/searchplugins), customize-searchplugins-en-US)
-install-searchplugins:: $(foreach target, $(LANGPACK_TARGETS), install-searchplugins-$(target) $(if $(wildcard debian/searchplugins), customize-searchplugins-$(target)))
-install-searchplugins-%: LANGUAGE = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\1/')
-install-searchplugins-%: PKGLANG = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\2/')
-install-searchplugins-%: PKGNAME = $(if $(PKGLANG),$(MOZ_PKG_NAME)-locale-$(PKGLANG),$(MOZ_PKG_NAME))
-install-searchplugins-%: SOURCE = $(if $(PKGLANG),$(MOZ_DISTDIR)/xpi-stage/locale-$(LANGUAGE),$(MOZ_LIBDIR))
+	@echo "Installing language pack xpis for $(MOZ_PKG_NAME)-locale-$*"
+	dh_installdirs -p$(MOZ_PKG_NAME)-locale-$* $(MOZ_ADDONDIR)/extensions
+	@for lang in $(shell grep $*$$ debian/config/locales.shipped | sed -n 's/\([^\:]*\)\:\?.*/\1/ p' | tr '\n' ' '); \
+	do \
+		id=`python $(CURDIR)/debian/build/get-xpi-id.py $(CURDIR)/$(MOZ_DISTDIR)/$(LANGPACK_DIR)/$(MOZ_APP_NAME)-$(MOZ_VERSION).$$lang.langpack.xpi 2>/dev/null`; \
+		echo "Installing $(MOZ_APP_NAME)-$(MOZ_VERSION).$$lang.langpack.xpi to $$id.xpi in to $(MOZ_PKG_NAME)-locale-$*"; \
+		install -m 0644 $(CURDIR)/$(MOZ_DISTDIR)/$(LANGPACK_DIR)/$(MOZ_APP_NAME)-$(MOZ_VERSION).$$lang.langpack.xpi \
+			$(CURDIR)/debian/$(MOZ_PKG_NAME)-locale-$*/$(MOZ_ADDONDIR)/extensions/$$id.xpi; \
+	done
+
+CUSTOMIZE_SEARCHPLUGINS = \
+	echo ""; \
+	echo "Applying search customizations for $(2)"; \
+	for lang in $(1); do \
+		echo "Applying customizations to $$lang"; \
+		list=debian/searchplugins/$$lang/list.txt; \
+		if [ ! -f $$list ]; then \
+			list=debian/searchplugins/list.txt; \
+		fi; \
+		overrides=`sed -n '/^\[Overrides\]/,/^\[/{/^\[/d;/^$$/d; p}' < $$list`; \
+		additions=`sed -n '/^\[Additions\]/,/^\[/{/^\[/d;/^$$/d; p}' < $$list`; \
+		for o in $$overrides; do \
+			f=`ls -1 debian/searchplugins/$$lang/$$o.xml 2>/dev/null | head -n1`; \
+			if [ -z $$f ]; then \
+				f=`ls -1 debian/searchplugins/en-US/$$o.xml 2>/dev/null | head -n1`; \
+			fi; \
+			if [ -z $$f ]; then \
+				echo "Cannot find source plugin for $$o"; \
+				exit 1; \
+			fi; \
+			if [ ! -f debian/$(2)/$(MOZ_SEARCHPLUGIN_DIR)/locale/$$lang/`basename $$f` ]; then \
+				echo "No plugin `basename $$f` to override"; \
+				exit 1; \
+			fi; \
+			echo "Overriding `basename $$f`"; \
+			dh_install -p$(2) $$f $(MOZ_SEARCHPLUGIN_DIR)/locale/$$lang; \
+		done; \
+		for a in $$additions; do \
+			f=`ls -1 debian/searchplugins/$$lang/$$a.xml 2>/dev/null | head -n1`; \
+			if [ -z $$f ]; then \
+				f=`ls -1 debian/searchplugins/en-US/$$a.xml 2>/dev/null | head -n1`; \
+			fi; \
+			if [ -z $$f ]; then \
+				echo "Cannot find source plugin for $$a"; \
+				exit 1; \
+			fi; \
+			if [ -f debian/$(2)/$(MOZ_SEARCHPLUGIN_DIR)/locale/$$lang/`basename $$f` ]; then \
+				echo "Plugin `basename $$f` already exists"; \
+				exit 1; \
+			fi; \
+			echo "Adding `basename $$f`"; \
+			dh_install -p$(2) $$f $(MOZ_SEARCHPLUGIN_DIR)/locale/$$lang; \
+		done; \
+	done
+
+install-searchplugins-%: P1 = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\1/')
+install-searchplugins-%: P2 = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\2/')
+install-searchplugins-%: LANGUAGES = $(if $(P1),$(shell grep $(P1)$$ debian/config/locales.shipped | sed -n 's/\([^\:]*\)\:\?.*/\1/ p' | tr '\n' ' '),en-US)
+install-searchplugins-%: PKGNAME = $(if $(P2),$(P2),$(MOZ_PKG_NAME)-locale-$(P1))
 install-searchplugins-%:
 	@echo ""
-	@echo "Installing $(LANGUAGE) searchplugins in to $(PKGNAME)"
-	rm -rf $(CURDIR)/debian/$(PKGNAME)/$(MOZ_SEARCHPLUGIN_DIR)/locale/$(LANGUAGE)
-	dh_installdirs -p$(PKGNAME) $(MOZ_SEARCHPLUGIN_DIR)/locale/$(LANGUAGE)
-	dh_install -p$(PKGNAME) $(SOURCE)/searchplugins/*.xml $(MOZ_SEARCHPLUGIN_DIR)/locale/$(LANGUAGE)
-
-customize-searchplugins-%: LANGUAGE = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\1/')
-customize-searchplugins-%: PKGLANG = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\2/')
-customize-searchplugins-%: PKGNAME = $(if $(PKGLANG),$(MOZ_PKG_NAME)-locale-$(PKGLANG),$(MOZ_PKG_NAME))
-customize-searchplugins-%: OVERRIDES = $(shell cat debian/config/search-mods.list | sed -n '/^\[Overrides\]/,/^\[/{/^\[/d;/^$$/d; p}' | \
-					 grep ^$(LANGUAGE): | cut -d ':' -f 2 | sed -e 's/,/ /g')
-customize-searchplugins-%: ADDITIONS = $(shell cat debian/config/search-mods.list | sed -n '/^\[Additions\]/,/^\[/{/^\[/d;/^$$/d; p}' | \
-					 grep ^$(LANGUAGE): | cut -d ':' -f 2 | sed -e 's/,/ /g')
-customize-searchplugins-%:
+	@echo "Installing searchplugins for $(PKGNAME)"
+	@for lang in $(LANGUAGES); do \
+		echo "Installing searchplugins for $$lang"; \
+		rm -rf debian/$(PKGNAME)/$(MOZ_SEARCHPLUGIN_DIR)/locale/$$lang; \
+		src=$(MOZ_DISTDIR)/xpi-stage/locale-$$lang; \
+		if [ ! -d $$src ]; then \
+			src=debian/tmp/$(MOZ_LIBDIR); \
+		fi; \
+		dh_installdirs -p$(PKGNAME) $(MOZ_SEARCHPLUGIN_DIR)/locale/$$lang; \
+		dh_install -p$(PKGNAME) $$src/searchplugins/*.xml $(MOZ_SEARCHPLUGIN_DIR)/locale/$$lang; \
+	done
+	@$(if $(wildcard debian/searchplugins),$(call CUSTOMIZE_SEARCHPLUGINS,$(LANGUAGES),$(PKGNAME)))
 	@echo ""
-	@echo "Applying search customizations to $(PKGNAME)"
-	@$(foreach override, $(OVERRIDES), echo "Overriding $(notdir $(override))"; \
-		dh_install -p$(PKGNAME) debian/searchplugins/$(override) $(MOZ_SEARCHPLUGIN_DIR)/locale/$(LANGUAGE);)
-	@$(foreach addition, $(ADDITIONS), echo "Adding $(notdir $(addition))"; \
-		dh_install -p$(PKGNAME) debian/searchplugins/$(addition) $(MOZ_SEARCHPLUGIN_DIR)/locale/$(LANGUAGE);)
-
-common-binary-post-install-arch:: install-langpack-xpis install-searchplugins
 
 binary-predeb/$(MOZ_PKG_NAME)::
 	$(foreach lib,libsoftokn3.so libfreebl3.so libnssdbm3.so, \
@@ -426,7 +445,7 @@
 	        $(MOZ_DISTDIR)/bin/shlibsign -v -i debian/$(MOZ_PKG_NAME)/$(MOZ_LIBDIR)/$(lib);)
 
 common-binary-predeb-arch::
-	$(foreach file,$(DEBIAN_EXECUTABLES),chmod a+x debian/$(file);)
+	$(foreach pkg,$(MOZ_PKG_NAMES),$(foreach file,$(MOZ_EXECUTABLES_$(pkg)),chmod a+x debian/$(pkg)/$(file);))
 	# we want the gnome dependencies not to be in the main package at shlibdeps runtime, hence we dont
 	# install them at binary-install/* stage, but copy them over _after_ the shlibdeps had been generated
 	$(foreach file,$(GNOME_SUPPORT_FILES),mv debian/$(MOZ_PKG_NAME)-gnome-support/$(MOZ_LIBDIR)/components/$(file) debian/$(MOZ_PKG_NAME)/$(MOZ_LIBDIR)/components/;) true
@@ -447,64 +466,13 @@
 	$(error "Need to set MOZ_BRANDING_DIR")
 endif
 
-GET_FILE_CONTENTS_CMD=$(if $(wildcard $(1)),`cat $(1)`,$(if $(wildcard .tarball/$(MOZ_PKG_NAME)/$(1)),`cat .tarball/$(MOZ_PKG_NAME)/$(1)`,$(if $(TARBALL),`mkdir -p $(CURDIR)/.tarball; tar -jxf $(TARBALL) -C $(CURDIR)/.tarball > /dev/null 2>&1; mv .tarball/$(MOZ_PKG_NAME)-* .tarball/$(MOZ_PKG_NAME); cat .tarball/$(MOZ_PKG_NAME)/$(1)`,$(error File $(1) not found))))
-
-refresh-search-mod-list:: SOURCE = $(if $(wildcard $(MOZ_APP)),$(CURDIR),$(CURDIR)/.tarball/$(MOZ_PKG_NAME))
-refresh-search-mod-list::
-	@echo ""
-	@echo "*******************************************************"
-	@echo "* Refreshing the list of search engine customizations *"
-	@echo "*******************************************************"
-	@echo ""
-
-	$(shell echo "$(call GET_FILE_CONTENTS_CMD,$(MOZ_APP)/config/version.txt)" > /dev/null)
-
-	perl debian/build/refresh-search-modifications.pl -a $(MOZ_APP) -b $(SOURCE) -d searchplugins
-
-refresh-search-mod-list:: $(if $(wildcard debian/searchplugins),verify-search-overrides)
-refresh-search-mod-list::
-	rm -rf $(CURDIR)/.tarball
-
-verify-search-overrides: prepare-searchplugins-en-US $(foreach target, $(LANGPACK_TARGETS), prepare-searchplugins-$(target))
-verify-search-overrides:
-	perl debian/build/verify-search-overrides.pl -d $(CURDIR)/.searchplugins
-	rm -rf $(CURDIR)/.searchplugins
-
-prepare-searchplugins-%: SOURCE = $(if $(wildcard $(MOZ_APP)),$(CURDIR),$(CURDIR)/.tarball/$(MOZ_PKG_NAME))
-prepare-searchplugins-%: LANGUAGE = $(shell echo $* | sed 's/\([^,]*\),\?\([^,]*\)/\1/')
-prepare-searchplugins-%: LIST_FILE = $(firstword $(wildcard $(SOURCE)/l10n/$(LANGUAGE)/$(MOZ_APP)/searchplugins/list.txt) \
-						 $(wildcard $(SOURCE)/$(MOZ_APP)/locales/$(LANGUAGE)/searchplugins/list.txt))
-prepare-searchplugins-%: ENGINE_LIST = $(shell cat $(LIST_FILE))
-prepare-searchplugins-%:
-	@mkdir -p $(CURDIR)/.searchplugins/$(LANGUAGE)
-	@rm -f $(CURDIR)/.searchplugins/$(LANGUAGE)/*.xml
-	@$(foreach engine,$(ENGINE_LIST),$(MOZ_PYTHON) $(CURDIR)/debian/build/Preprocessor.py -Fsubstitution -DMOZ_UPDATE_CHANNEL="$(CHANNEL)" $(firstword $(wildcard $(dir $(LIST_FILE))/$(engine).xml) $(wildcard $(SOURCE)/$(MOZ_APP)/locales/en-US/searchplugins/$(engine).xml)) > $(CURDIR)/.searchplugins/$(LANGUAGE)/$(engine).xml;)
-
-auto-refresh-search-mod-list::
-	cp debian/config/search-mods.list debian/config/search-mods.list.old
-
-auto-refresh-search-mod-list:: refresh-search-mod-list
-auto-refresh-search-mod-list::
-	@if ! cmp -s debian/config/search-mods.list debian/config/search-mods.list.old ; \
-	then \
-		echo "" ; \
-		echo "*******************************************************************************" ; \
-		echo "* List of search engine customizations has changed. This is likely because of *" ; \
-		echo "* a change in the search engine list upstream. Please refresh, check the      *" ; \
-		echo "* differences, and try again. To refresh, run                                 *" ; \
-		echo "* \"debian/rules refresh-search-mod-list\" in the source directory. If you      *" ; \
-		echo "* are in bzr, you will need to pass the location of the upstream tarball,     *" ; \
-		echo "* using \"TARBALL=/path/to/tarball\"                                            *" ; \
-		echo "*******************************************************************************" ; \
-		echo "" ; \
-		mv debian/config/search-mods.list.old debian/config/search-mods.list ; \
-		exit 1 ; \
-	fi
-	rm -f debian/config/search-mods.list.old
+EXTRACT_TARBALL = $(firstword $(shell TMPDIR=`mktemp -d`; tar -jxf $(1) -C $$TMPDIR > /dev/null 2>&1; echo $$TMPDIR/`ls $$TMPDIR/ | head -n1`))
 
 ifdef LANGPACK_O_MATIC
 refresh-supported-locales:: LPOM_OPT = -l $(LANGPACK_O_MATIC)
 endif
+refresh-supported-locales:: EXTRACTED := $(if $(wildcard $(MOZ_APP)/locales/shipped-locales),,$(call EXTRACT_TARBALL,$(TARBALL)))
+refresh-supported-locales:: SHIPPED_LOCALES = $(firstword $(wildcard $(CURDIR)/$(MOZ_APP)/locales/shipped-locales) $(wildcard $(EXTRACTED)/$(MOZ_APP)/locales/shipped-locales))
 refresh-supported-locales::
 	@echo ""
 	@echo "****************************************"
@@ -512,13 +480,10 @@
 	@echo "****************************************"
 	@echo ""
 
-	$(shell echo "$(call GET_FILE_CONTENTS_CMD,$(MOZ_APP)/locales/shipped-locales)" > $(CURDIR)/.upstream-shipped-locales)
-
-	perl debian/build/refresh-supported-locales.pl -s $(CURDIR)/.upstream-shipped-locales $(LPOM_OPT)
-	rm -f $(CURDIR)/.upstream-shipped-locales
+	perl debian/build/refresh-supported-locales.pl -s $(SHIPPED_LOCALES) $(LPOM_OPT)
 
 refresh-supported-locales:: debian/control
-	rm -rf $(CURDIR)/.tarball
+	$(if $(EXTRACTED),rm -rf $(dir $(EXTRACTED)))
 
 auto-refresh-supported-locales::
 	cp debian/config/locales.shipped debian/config/locales.shipped.old
@@ -544,12 +509,6 @@
 
 ifneq (1, $(MOZ_DISABLE_CLEAN_CHECKS))
 clean:: auto-refresh-supported-locales
-ifneq (,$(wildcard debian/searchplugins))
-# Depends on libjson-perl, which is in universe in 10.04
-ifeq (,$(filter lucid,$(DISTRIB_CODENAME)))
-clean:: auto-refresh-search-mod-list
-endif
-endif
 endif
 
 ifdef PATCHES_DIST
@@ -601,5 +560,9 @@
 	rm -rf debian/l10n-mergedirs
 	rm -f debian/$(MOZ_PKG_BASENAME).js
 	rm -rf $(MOZ_OBJDIR)
+	rm -f debian/searchplugin*.list
 	find debian -name *.pyc -delete
 	find compare-locales -name *.pyc -delete
+	rm -rf debian/tests/_results
+
+.PHONY: make-buildsymbols make-testsuite make-langpack-xpis refresh-supported-locales auto-refresh-supported-locales enable-dist-patches get-orig-source

=== modified file 'debian/build/mozvars.mk'
--- debian/build/mozvars.mk	2012-07-23 11:32:05 +0000
+++ debian/build/mozvars.mk	2013-02-20 09:17:36 +0000
@@ -12,7 +12,4 @@
 DISTRIB_VERSION_MINOR 	:= $(shell lsb_release -s -r | cut -d '.' -f 2)
 DISTRIB_CODENAME	:= $(shell lsb_release -s -c)
 
-# The package name
-MOZ_PKG_NAME		:= $(shell dpkg-parsechangelog | sed -n 's/^Source: *\(.*\)$$/\1/ p')
-# The binary name to use (derived from the package name by default)
-MOZ_APP_NAME		:= $(MOZ_PKG_NAME)
+include $(CURDIR)/debian/config/branch.mk

=== removed file 'debian/build/refresh-search-modifications.pl'
--- debian/build/refresh-search-modifications.pl	2012-08-28 10:59:23 +0000
+++ debian/build/refresh-search-modifications.pl	1970-01-01 00:00:00 +0000
@@ -1,177 +0,0 @@
-#!/usr/bin/perl
-
-use strict;
-use warnings;
-use File::Basename;
-
-my $app;
-my $spdir;
-my $basedir;
-
-my %wanted_overrides = (
-    "en-US" => []
-);
-my %wanted_additions = (
-    "en-US" => []
-);
-
-my %overrides;
-my %additions;
-
-while (@ARGV) {
-    my $arg = shift;
-    if ($arg eq '-a') {
-        $app = shift;
-    } elsif ($arg eq '-d') {
-        $spdir = shift;
-    } elsif ($arg eq '-b') {
-        $basedir = shift;
-    }
-}
-
-open(ORIG, "debian/config/search-mods.list") and do {
-    my %map = (
-        "Overrides" => \%overrides,
-        "Additions" => \%additions
-    );
-    my $table;
-    while(<ORIG>) {
-        chomp;
-        $_ =~ s/#.*//; s/\s*$//;
-        if (/^\[([[:alnum:]]*)\]$/) {
-            $table = $map{$1};
-        } elsif (/^([^\:]*)\:(.*)/) {
-            my @l = sort({basename($a) cmp basename($b)} split(',', $2));
-            $table->{$1} = \@l;
-        } elsif (not /^$/) { die "Unexpected line"; }
-    }
-};
-close(ORIG);
-
-sub parse_manifest {
-    my $lang = shift;
-    my $path = shift;
-
-    my %map = (
-        "Overrides" => \%wanted_overrides,
-        "Additions" => \%wanted_additions
-    );
-    my $table;
-    open(FILE, $path) or die "Failed to open manifest $path";
-    while(<FILE>) {
-        chomp;
-        $_ =~ s/#.*//; s/\s*$//;
-        if (/^\[([[:alnum:]]*)\]$/) {
-            $table = $map{$1};
-        } elsif (/^(.+)$/) {
-            if (not exists($table->{$lang})) {
-                $table->{$lang} = [];
-            }
-            push(@{$table->{$lang}}, $1);
-        } elsif (not /^$/) { die "Unexpected line"; }
-    }
-    close(FILE);
-}
-
-opendir(DIR, "debian/searchplugins") and do {
-    my @files = readdir(DIR);
-    foreach my $file (@files) {
-        if (-d "debian/searchplugins/$file" and 
-            -e "debian/searchplugins/$file/list.txt") {
-            parse_manifest($file, "debian/searchplugins/$file/list.txt");
-        } elsif (-f "debian/searchplugins/$file" and $file eq "list.txt") {
-            parse_manifest("en-US", "debian/searchplugins/$file")
-        }
-    }
-};
-closedir(DIR);
-
-sub handle_locale {
-    my $lang = shift;
-    my $path = shift;
-
-    $overrides{$lang} = [];
-    $additions{$lang} = [];
-
-    my $ov = $wanted_overrides{exists($wanted_overrides{$lang}) ? $lang : "en-US"};
-    my $ad = $wanted_additions{exists($wanted_additions{$lang}) ? $lang : "en-US"};
-
-    my @upstream;
-    open(FILE, $path) and do {
-        while(<FILE>) { s/\r\n/\n/; chomp; push(@upstream, $_); }
-    };
-    close(FILE);
-
-    foreach my $override (@{$ov}) {
-        my @files = <debian/searchplugins/$lang/$override.xml>;
-        @files = grep(-f $_, @files);
-        scalar(@files) > 0 or @files = <debian/searchplugins/en-US/$override.xml>;
-        @files = grep(-f $_, @files);
-        scalar(@files) > 0 or die "No source plugin for override $override in $lang";
-
-        foreach my $file (@files) {
-            my $base = basename($file);
-            $base =~ s/\.xml$//;
-            $file =~ s/debian\/searchplugins\///;
-            my ($index) = grep($upstream[$_] eq $base, 0..$#upstream);
-            defined($index) and push(@{$overrides{$lang}}, $file);
-        }
-    }
-
-    foreach my $addition (@{$ad}) {
-        my @files = <debian/searchplugins/$lang/$addition.xml>;
-        @files = grep(-f $_, @files);
-        scalar(@files) > 0 or @files = <debian/searchplugins/en-US/$addition.xml>;
-        @files = grep(-f $_, @files);
-        scalar(@files) > 0 or die "No source plugin for additional plugin $addition in $lang";
-
-        foreach my $file (@files) {
-            my $base = basename($file);
-            $base =~ s/\.xml$//;
-            $file =~ s/debian\/searchplugins\///;
-            my ($index) = grep($upstream[$_] eq $base, 0..$#upstream);
-            defined($index) and die "Cannot add plugin $base for $lang. Destination already exists";
-            push(@{$additions{$lang}}, $file);
-        }
-    }
-
-    @{$overrides{$lang}} = sort({basename($a) cmp basename($b)} @{$overrides{$lang}});
-    @{$additions{$lang}} = sort({basename($a) cmp basename($b)} @{$additions{$lang}});
-
-    if (scalar(@{$overrides{$lang}}) == 0) { delete $overrides{$lang}; }
-    if (scalar(@{$additions{$lang}}) == 0) { delete $additions{$lang}; }
-}
-
-open(SHIPPED_LOCALES, "debian/config/locales.shipped") or die "Cannot open shipped locales";
-while(<SHIPPED_LOCALES>) {
-    $_ =~ s/#.*//; s/\s*$//;
-    /^([^\:]*)\:.*/ and do {
-        handle_locale($1, "$basedir/l10n/$1/$app/$spdir/list.txt");
-    }
-}
-close(SHIPPED_LOCALES);
-
-handle_locale("en-US", "$basedir/$app/locales/en-US/$spdir/list.txt");
-
-scalar(keys(%overrides)) > 0 or scalar(keys(%additions)) > 0 or do {
-    unlink("debian/config/search-mods.list");
-    exit(0);
-};
-
-open(OUTFILE, ">debian/config/search-mods.list");
-scalar(keys(%overrides)) > 0 and do {
-    print OUTFILE "[Overrides]\n";
-    foreach my $key (sort(keys(%overrides))) {
-        my $val = join(",", @{$overrides{$key}});
-        print OUTFILE "$key:$val\n";
-    }
-};
-
-scalar(keys(%additions)) > 0 and do {
-    print OUTFILE "\n[Additions]\n";
-    foreach my $key (sort(keys(%additions))) {
-        my $val = join(",", @{$additions{$key}});
-        print OUTFILE "$key:$val\n";
-    }
-};
-close(OUTFILE);

=== modified file 'debian/build/testsuite.mk'
--- debian/build/testsuite.mk	2012-08-24 21:48:28 +0000
+++ debian/build/testsuite.mk	2013-02-20 09:17:36 +0000
@@ -1,49 +1,70 @@
 #!/usr/bin/make -f
 
-LOCALE		:= en_US.UTF-8
-LOCDIR		= $(CURDIR)/$(MOZ_DISTDIR)/.locales
-
-ifeq (1,$(MOZ_WANT_UNIT_TESTS))
-ifeq (,$(MOZ_TESTS))
-TESTS = check xpcshell-tests jstestbrowser reftest crashtest mochitest
-else
-TESTS = $(MOZ_TESTS)
-endif
-endif
-
-run-tests: $(addprefix debian/stamp-,$(TESTS))
-
-$(addprefix debian/stamp-,$(TESTS)): debian/stamp-makefile-build
-
-# Required for js/src/trace-tests/sunspider/check-date-format-tofte.js
-$(addprefix debian/stamp-,check jstestbrowser): export TZ = :/usr/share/zoneinfo/posix/US/Pacific
-
-$(LOCDIR)/%:
-	mkdir -p $(LOCDIR)
+MOZ_TEST_LOCALE ?= en_US.UTF-8
+
+MOZ_TESTS ?= check xpcshell-tests-build
+MOZ_TEST_FAILURES_FATAL ?= 1
+
+MOZ_TEST_X_WRAPPER ?= xvfb-run -a -s "-screen 0 1024x768x24" dbus-launch --exit-with-session
+MOZ_TESTS_NEED_X ?= xpcshell-tests xpcshell-tests-build jstestbrowser reftest crashtest mochitest
+
+MOZ_TESTS_TZ_ENV ?= TZ=:/usr/share/zoneinfo/posix/US/Pacific
+MOZ_TESTS_NEED_TZ ?= check jstestbrowser
+
+MOZ_TESTS_NEED_LOCALE ?= xpcshell-tests jstestbrowser reftest
+
+TEST_LOCALES = $(CURDIR)/$(MOZ_OBJDIR)/_ubuntu_build_test_tmp/locales
+TEST_HOME = $(CURDIR)/$(MOZ_OBJDIR)/_ubuntu_build_test_tmp/home
+
+GET_WRAPPER = $(if $(filter $(1),$(MOZ_TESTS_NEED_X)),$(MOZ_TEST_X_WRAPPER))
+GET_TZ = $(if $(filter $(1),$(MOZ_TESTS_NEED_TZ)),$(MOZ_TESTS_TZ_ENV))
+
+DOIF_NEEDS_LOCALE = $(if $(filter $(1),$(MOZ_TESTS_NEED_LOCALE)),$(call $(2)))
+MAKE_LOCALE = $(TEST_LOCALES)/$(MOZ_TEST_LOCALE)
+GET_LOCALE_ENV = LOCPATH=$(TEST_LOCALES) LC_ALL=$(MOZ_TEST_LOCALE)
+
+ifneq (1,$(MOZ_TEST_FAILURES_FATAL))
+CMD_APPEND = || true
+endif
+
+ifneq (1,$(MOZ_WANT_UNIT_TESTS))
+MOZ_TESTS =
+endif
+
+$(TEST_LOCALES) $(TEST_HOME)::
+	mkdir -p $@
+
+$(TEST_LOCALES)/$(MOZ_TEST_LOCALE): $(TEST_LOCALES)
 	localedef -f $(shell echo $(notdir $@) | cut -d '.' -f 2) -i $(shell echo $(notdir $@) | cut -d '.' -f 1) $@
 
-# Setup locales for tests which need it
-$(addprefix debian/stamp-,xpcshell-tests jstestbrowser reftest): $(LOCDIR)/$(LOCALE)
-$(addprefix debian/stamp-,xpcshell-tests jstestbrowser reftest): export LOCPATH=$(LOCDIR)
-$(addprefix debian/stamp-,xpcshell-tests jstestbrowser reftest): export LC_ALL=$(LOCALE)
-
-# Disable tests that are known to fail
-$(addprefix debian/stamp-,xpcshell-tests): debian/stamp-xpcshell-tests-disable
-
-# Tests that need a X server
-$(addprefix debian/stamp-,xpcshell-tests jstestbrowser reftest crashtest mochitest): WRAPPER = xvfb-run -a -s "-screen 0 1024x768x24" dbus-launch --exit-with-session
-
-# Run the test!
-$(addprefix debian/stamp-,$(TESTS)):
-	HOME="$(CURDIR)/$(MOZ_DISTDIR)" \
-	$(WRAPPER) $(MAKE) -C $(CURDIR)/$(MOZ_OBJDIR) $(subst debian/stamp-,,$@) || true
-	touch $@
-
-debian/stamp-xpcshell-tests-disable:: debian/stamp-makefile-build
-	# Hangs without network access
-	rm -f $(CURDIR)/$(MOZ_OBJDIR)$(MOZ_MOZDIR)/_tests/xpcshell/toolkit/components/places/tests/unit/test_404630.js
-
-	# Needs GConf to be running. I guess we need to start with dbus-launch to fix this
-	rm -f $(CURDIR)/$(MOZ_OBJDIR)$(MOZ_MOZDIR)/_tests/xpcshell/browser/components/shell/test/unit/test_421977.js
-	rm -f $(CURDIR)/$(MOZ_OBJDIR)$(MOZ_MOZDIR)/_tests/xpcshell/uriloader/exthandler/tests/unit/test_handlerService.js
-	touch $@
+run-tests: $(MOZ_TESTS)
+
+$(MOZ_TESTS):: %: debian/stamp-test-%
+
+$(patsubst %,debian/stamp-test-%,$(MOZ_TESTS)):: TZ=$(call GET_TZ,$*)
+$(patsubst %,debian/stamp-test-%,$(MOZ_TESTS)):: WRAPPER=$(call GET_WRAPPER,$*)
+$(patsubst %,debian/stamp-test-%,$(MOZ_TESTS)):: $(call DOIF_NEEDS_LOCALE,$*,MAKE_LOCALE)
+$(patsubst %,debian/stamp-test-%,$(MOZ_TESTS)):: LOCALE_ENV=$(call DOIF_NEEDS_LOCALE,$*,GET_LOCALE_ENV)
+$(patsubst %,debian/stamp-test-%,$(MOZ_TESTS)):: $(TEST_HOME)
+$(patsubst %,debian/stamp-test-%,$(MOZ_TESTS)):: TEST_CMD=HOME=$(TEST_HOME) $(LOCALE_ENV) $(TZ) $(WRAPPER) $(if $(findstring -build,$*),debian/rules run-$*,$(MAKE) -C $(CURDIR)/$(MOZ_OBJDIR) $*)
+$(patsubst %,debian/stamp-test-%,$(MOZ_TESTS)):: debian/stamp-test-%: debian/stamp-makefile-build
+	@echo "\nRunning $(TEST_CMD)\n"
+	$(TEST_CMD) $(CMD_APPEND)
+	touch $@
+
+$(CURDIR)/$(MOZ_OBJDIR)/$(MOZ_MOZDIR)/_tests/xpcshell/xpcshell-build.ini:
+	cp $(CURDIR)/debian/testing/xpcshell-build.ini $@
+
+run-xpcshell-tests-build: $(CURDIR)/$(MOZ_OBJDIR)/$(MOZ_MOZDIR)/_tests/xpcshell/xpcshell-build.ini
+	$(MOZ_PYTHON) -u $(CURDIR)/$(MOZ_MOZDIR)/config/pythonpath.py \
+	  -I$(CURDIR)/$(MOZ_MOZDIR)/build \
+	  -I$(CURDIR)/$(MOZ_OBJDIR)/$(MOZ_MOZDIR)/_tests/mozbase/mozinfo \
+	  $(CURDIR)/$(MOZ_MOZDIR)/testing/xpcshell/runxpcshelltests.py \
+	  --manifest=$(CURDIR)/$(MOZ_OBJDIR)/$(MOZ_MOZDIR)/_tests/xpcshell/xpcshell-build.ini \
+	  --build-info-json=$(CURDIR)/$(MOZ_OBJDIR)/$(MOZ_MOZDIR)/mozinfo.json \
+	  --no-logfiles \
+	  --tests-root-dir=$(CURDIR)/$(MOZ_OBJDIR)/$(MOZ_MOZDIR)/_tests/xpcshell \
+	  --testing-modules-dir=$(CURDIR)/$(MOZ_OBJDIR)/$(MOZ_MOZDIR)/_tests/modules \
+	  $(CURDIR)/$(MOZ_DISTDIR)/bin/xpcshell
+
+.PHONY: run-tests $(MOZ_TESTS) run-xpcshell-tests-build

=== removed file 'debian/build/verify-search-overrides.pl'
--- debian/build/verify-search-overrides.pl	2012-08-28 10:59:23 +0000
+++ debian/build/verify-search-overrides.pl	1970-01-01 00:00:00 +0000
@@ -1,121 +0,0 @@
-#!/usr/bin/perl
-
-use strict;
-use warnings;
-use XML::Simple;
-use JSON;
-use File::Basename;
-
-sub check_matches {
-    my $plugin = shift;
-    my $conditions = shift;
-    (ref($conditions) eq "HASH") or die "Ah, shit";
-
-    my $matches = 0;
-    if (ref($plugin) eq "ARRAY") {
-        foreach my $subvalue (@{$plugin}) {
-            $matches ||= check_matches($subvalue, $conditions);
-        }
-        return $matches;
-    }
-
-    (ref($plugin) eq "HASH") or return 0;
-    (scalar(keys(%$conditions)) == 0) && return 1;
-
-    foreach my $key (keys(%$conditions)) {
-        $matches = 0;
-        if (ref($conditions->{$key}) eq "HASH") {
-            $matches = check_matches($plugin->{$key}, $conditions->{$key});
-        } elsif (ref($conditions->{$key}) eq "ARRAY") {
-            $matches = 1;
-            foreach my $condition (@{$conditions->{$key}}) {
-                $matches &&= check_matches($plugin->{$key}, $condition);
-            }
-        } else {
-            if (exists($plugin->{$key}) and ref($plugin->{$key}) ne "HASH" and ref($plugin->{$key}) ne "ARRAY") {
-                $matches = $conditions->{$key} =~ /[\+\?\.\*\^\$\(\)\[\]\{\}\|\\]*/ ? 
-                            ($plugin->{$key} =~ /$conditions->{$key}/) :
-                            ($plugin->{$key} eq $conditions->{$key});
-            }
-        }
-        last if not $matches;
-    }
-
-    return $matches;
-}
-
-sub verify_overrides {
-    my $dir = shift;
-    my $lang = shift;
-    my $config = shift;
-    my $overrides = shift;
-
-    my @plugins = sort(<$dir/$lang/*.xml>);
-    foreach my $plugin (@plugins) {
-        my $xml = new XML::Simple;
-        my $data = $xml->XMLin($plugin, keyattr => []);
-
-        my $matches = 0;
-        foreach my $conditions (@{$config->{'matches'}}) {
-            $matches = check_matches($data, $conditions);
-            last if $matches;
-        }
-        foreach my $conditions (@{$config->{'ignore'}}) {
-            $matches &&= not check_matches($data, $conditions);
-            last if not $matches;
-        }
-
-        my $id = basename($plugin);
-        $id =~ s/\.xml$//;
-        my @arr = @{$overrides->{$lang}};
-        my ($index) = grep($arr[$_] eq $id, 0..$#arr);
-        $matches ^ defined($index) and die "Verification failed for $id search plugin in $lang";
-    }
-}
-
-my $dir;
-my %overrides;
-my $config;
-
-while (@ARGV) {
-    my $arg = shift;
-    if ($arg eq '-d') {
-        $dir = shift;
-    }
-}
-
-defined($dir) or die "Missing options";
-
-open(CONFIG, "debian/searchplugins/compute-overrides.json") or die "Cannot open config";
-my $json;
-while (<CONFIG>) { $json .= $_; }
-close(CONFIG);
-$config = JSON::decode_json($json);
-
-open(LIST, "debian/config/search-mods.list") and do {
-    my $parsing = 0;
-    while(<LIST>) {
-        if (/^\[Overrides\]$/) {
-            $parsing = 1;
-        } elsif ($parsing == 1) {
-            if (/^\[/) {
-                $parsing = 0;
-            } elsif (/^([^\:]*)\:(.*)/) {
-                my @l = split(',', $2);
-                map($_ = basename($_), @l);
-                map($_ =~ s/\.xml$//, @l);
-                $overrides{$1} = \@l;
-            }
-        }
-    }
-    close(LIST);
-
-    open(SHIPPED_LOCALES, "debian/config/locales.shipped") or die "Cannot open list of shipped locales";
-    while(<SHIPPED_LOCALES>) {
-        $_ =~ s/#.*//; s/\s*$//;
-        /^([^\:]*)\:.*/ and do {
-            verify_overrides($dir, $1, $config, \%overrides);
-        }
-    }
-    close(SHIPPED_LOCALES);
-}

=== modified file 'debian/changelog'
--- debian/changelog	2013-02-18 00:02:51 +0000
+++ debian/changelog	2013-02-20 09:17:36 +0000
@@ -1,3 +1,195 @@
+firefox (20.0~b1+build1-0ubuntu1) UNRELEASED; urgency=low
+
+  * New upstream release from the beta channel
+
+  * Refresh patches
+    - update debian/patches/mozilla-kde.patch
+  * Drop patches fixed upstream
+    - remove debian/patches/ionmonkey-hardfp-support.patch
+    - update debian/patches/series.in
+  * firefox-gnome-support needs explicit dependency on libnotify
+    - update debian/control{,.in}
+  * Add support for autopkgtest, package the xpcshell, reftest and
+    mochitest testsuites and migrate the xpcshell-tests, reftest, crashtest,
+    jstestbrowser and mochitest targets to this. Note that tests that can't
+    be ran as an autopkgtest (eg, if they require write permissions to the
+    application directory) will still be ran at build time
+    - add firefox-testsuite package in debian/control.in
+    - update debian/control
+    - add debian/firefox-testsuite.install.in
+    - add debian/firefox-testsuite.links.in
+    - update debian/build/mozbuild.mk
+    - update debian/rules
+    - drop xpcshell-tests, reftest, crashtest, jstestbrowser and mochitest
+      targets from debian/build/testsuite.mk, add xpcshell-tests-build
+      and the ability to run xpcshell-tests with our own reduced manifest
+    - add debian/tests/control
+    - add debian/tests/crashtest
+    - add debian/tests/jstestbrowser
+    - add debian/tests/mochitest
+    - add debian/tests/reftest
+    - add debian/tests/xpcshell-tests
+    - add debian/testing/run_mochitest.in
+    - add debian/testing/run_xpcshell_tests.in
+    - add debian/testing/run_reftest.in
+    - add debian/testing/testrunhelper.py
+    - update debian/config/mozconfig.in to always build with --enable-tests
+    - add debian/testing/xpcshell-build.ini
+  * Ensure that the directory provider returns all searchplugin paths during
+    the search service xpcshell tests
+    - add d/p/test-fixes/xpcshell-search-fix-browser-dirprovider.patch
+    - update debian/patches/series.in
+  * Fix various tests that assume that either the application directory or
+    test directory can be written to
+    - add d/p/test-fixes/xpcshell-docshell-no-writes-to-appdir.patch
+    - add d/p/test-fixes/xpcshell-contentprefs-no-writes-to-appdir.patch
+    - add d/p/test-fixes/xpcshell-exthandler-no-writes-to-appdir.patch
+    - add d/p/test-fixes/xpcshell-ctypes-no-writes-to-appdir.patch
+    - add d/p/test-fixes/xpcshell-xpcom-no-writes-to-testdir-or-appdir.patch
+    - add d/p/test-fixes/xpcshell-libpref-no-writes-to-testdir.patch
+    - update debian/patches/series.in
+  * Export NO_PNG_PKG_MANGLE as optipng breaks tests that are dependent
+    on image format / size
+    - update debian/build/mozbuild.mk
+  * Don't test that the addon selection dialog appears in test_bug596343.js,
+    as we disable this
+    - add d/p/test-integration/xpcshell-disable-addon-select-dialog-test-for-adt.patch
+    - update debian/patches/series
+  * Don't write a log file to the script directory from mochitest
+    - add d/p/test-integration/mochitest-optional-websock-log.patch
+    - update debian/patches/series.in
+  * Fix a failure in test_nodb_pluschanges.js due to const redeclaration
+    - add d/p/test-fixes/xpcshell-search-fix-const-redeclaration.patch
+    - update debian/patches/series.in
+  * Don't run the GConf-specific test_421977.js on systems where GSettings
+    is available, as it will fail
+    - add d/p/t-f/xpcshell-shell-disable-gconf-tests-when-using-gsettings.patch
+    - update debian/patches/series.in
+  * Disable test_upgrade.js and test_upgrade_strictcompat.js xpcshell tests
+    for now as they require write access to the application directory
+    - add d/p/test-integration/xpcshell-disable-tests-which-need-appdir-write-access.patch
+    - update debian/patches/series.in
+  * Disable test_browserGlue_distribution.js for now as it requires write
+    access to the application directory
+    - update d/p/test-integration/xpcshell-disable-tests-which-need-appdir-write-access.patch
+  * Reset the "browser" and "embed-app" content prefs after running content
+    mochitests, so that the subsequent DOM browser-element tests don't
+    fail
+    - add d/p/test-fixes/mochitest-content-reset-permissions-when-done.patch
+    - update debian/patches/series.in
+  * Disable various failing mochitests:
+    - add debian/testing/mochitest.json
+    - add debian/testing/mochitest-chrome.json
+    - update debian/firefox-testsuite.install.in
+  * Fix issue where some tests were being added to the mochitest tests.jar
+    using their absolute path in the build tree
+    - add debian/patches/test-fixes/mochitest-tests-jar-fix.patch
+    - update debian/patches/series.in
+  * Don't run the GConf specific browser_420786.js mochitest on systems where
+    GSettings is available, as it will fail
+    - add d/p/t-f/mochitest-shell-disable-gconf-tests-when-using-gsettings.patch
+    - update debian/patches/series.in
+  * Don't ship the browser_bug538331.js mochitest as this isn't relevant
+    when not using the Mozilla AUS
+    - add d/p/test-fixes/mochitest-dont-ship-browser-postupdate-test.patch
+    - update debian/patches/series.in
+  * Make "--test-manifest" work when running chrome, browser-chrome and a11y
+    mochitests so that we can maintain a distro manifest for these
+    - add d/p/test-integration/mochitest-allow-test-manifest-for-chrome.patch
+    - update debian/patches/series.in
+  * Disable failing reftests
+    - add d/p/test-overrides/reftest-disable-failing-tests.patch
+    - update debian/patches/series.in
+  * Add vendor xpcshell tests to verify that the search service loads
+    the expected number of search plugins from each language pack
+    - update debian/build/mozbuild.mk
+    - add debian/firefox-testsuite.dirs.in
+    - update debian/firefox-testsuite.install.in
+    - update debian/rules
+    - add debian/testing/xpcshell-package-tests/head_package_tests.js
+    - add debian/testing/xpcshell-package-tests/test_searchplugins_valid.js
+    - add debian/testing/xpcshell-package-tests/test_searchplugins_valid_real.js
+    - add debian/testing/xpcshell-package-tests/xpcshell.ini
+    - update debian/tests/control
+    - add debian/tests/xpcshell-package-tests
+  * Drop the hacky perl scripts that were being used to make sure the language
+    packs ship the correct plugins. Add a xpcshell test instead
+    - update debian/build/mozbuild.mk
+    - update debian/rules
+    - remove debian/build/refresh-search-modifications.pl
+    - remove debian/build/verify-search-overrides.pl
+    - remove debian/config/search-mods.list
+    - update debian/control.in
+    - remove debian/searchplugins/compute-overrides.json
+    - add debian/testing/xpcshell-package-tests/test_ubuntu_searchplugins.js
+    - add debian/testing/xpcshell-package-tests/test_ubuntu_searchplugins_real.js
+    - update debian/testing/xpcshell-package-tests/xpcshell.ini
+  * Fix a test failure with the Italian Amazon search plugin 
+    - update debian/searchplugins/it/amazon-it.xml
+  * We set intl.locale.matchOS to ensure that Firefox uses the environment
+    locale. Add a test to make sure this works as expected
+    - add debian/testing/xpcshell-package-tests/test_locale_matchOS.js
+    - add debian/testing/xpcshell-package-tests/test_locale_matchOS_real.js
+    - update debian/testing/xpcshell-package-tests/head_package_tests.js
+    - update debian/testing/xpcshell-package-tests/test_searchplugins_valid.js
+    - update debian/testing/xpcshell-package-tests/test_ubuntu_searchplugins.js
+    - update debian/testing/xpcshell-package-tests/xpcshell.ini
+    - update debian/tests/control
+    - update debian/tests/crashtest
+    - update debian/tests/jstestbrowser
+    - update debian/tests/mochitest
+    - update debian/tests/reftest
+    - update debian/tests/xpcshell-package-tests
+    - update debian/tests/xpcshell-tests
+  * We modify the user agent, so test that it is correct
+    - add debian/testing/xpcshell-package-tests/test_ubuntu_useragent.js
+    - update debian/testing/xpcshell-package-tests/xpcshell.ini
+  * LP: #974146 - Add a "Open a New Private Window" action to the desktop file
+    - update debian/firefox.desktop.in
+  * Don't try to override the Amazon searchplugin for Kashubian or Mongolian,
+    as it doesn't exist there
+    - add debian/searchplugins/csb/list.txt
+    - add debian/searchplugins/mn/list.txt
+    - update d/t/xpcshell-package-tests/test_ubuntu_searchplugins_real.js
+  * Testpilot only enabled on beta now
+    - update debian/firefox.install.in
+  * Don't run dh_scour on the testsuite package, as this screws up a lot
+    of reftests and crashtests
+    - update debian/build/mozbuild.mk
+  * Add a test to make sure all of the language packs are loadable by the
+    addon manager
+    - add debian/testing/xpcshell-package-tests/test_langpack_load.js
+    - update debian/testing/xpcshell-package-tests/xpcshell.ini
+  * Add a test to make sure language pack chrome is registered correctly
+    - add debian/testing/xpcshell-package-tests/test_langpack_chrome.js
+    - update debian/testing/xpcshell-package-tests/xpcshell.ini
+  * Disable failing xpcshell tests
+    - add d/p/test-overrides/xpcshell-disable-failing-tests.patch
+    - update debian/patches/series.in
+  * Add JUnit output support for reftests
+    - add d/p/test-integration/reftest-output-junit-xml.patch
+    - update debian/patches/series.in
+    - update debian/testing/run_reftest.in
+  * Allow xpcshell tests to be run with JUnit outputting, and include a fix
+    to make sure that the output matches the schema
+    - update debian/testing/run_xpcshell_tests.in
+    - add d/p/test-integration/xpcshell-output-valid-junit-xml.patch
+    - update debian/patches/series.in
+  * Add JUnit output support for mochitests
+    - add d/p/test-integration/mochitest-output-junit-xml.patch
+    - update debian/patches/series.in
+    - update debian/testing/run_mochitest.in
+  * Turn on JUnit XML output for all tests
+    - update debian/build/mozbuild.mk
+    - update debian/tests/crashtest
+    - update debian/tests/jstestbrowser
+    - update debian/tests/mochitest
+    - update debian/tests/reftest
+    - update debian/tests/xpcshell-package-tests
+    - update debian/tests/xpcshell-tests
+
+ -- Chris Coulson <chris.coulson@canonical.com>  Wed, 20 Feb 2013 09:13:30 +0000
+
 firefox (19.0~b6+build1-0ubuntu1) raring; urgency=low
 
   * New upstream release from the beta channel (FIREFOX_19_0b6_BUILD1)

=== modified file 'debian/config/mozconfig.in'
--- debian/config/mozconfig.in	2012-11-21 13:28:00 +0000
+++ debian/config/mozconfig.in	2013-02-20 09:17:36 +0000
@@ -35,13 +35,7 @@
 %%ifdef DEB_PARALLEL_JOBS
 mk_add_options MOZ_MAKE_FLAGS=-j@DEB_PARALLEL_JOBS@
 %%endif
-%%ifdef MOZ_WANT_UNIT_TESTS
 ac_add_options --enable-tests
-# ac_add_options --enable-ipdl-tests
-%%else
-ac_add_options --disable-tests
-ac_add_options --disable-ipdl-tests
-%%endif
 %%ifdef MOZ_ENABLE_BREAKPAD
 ac_add_options --enable-crashreporter
 %%else

=== removed file 'debian/config/search-mods.list'
--- debian/config/search-mods.list	2012-08-28 10:59:23 +0000
+++ debian/config/search-mods.list	1970-01-01 00:00:00 +0000
@@ -1,171 +0,0 @@
-[Overrides]
-af:en-US/amazondotcom.xml,en-US/google.xml
-ar:en-US/amazondotcom.xml,en-US/google.xml
-as:en-US/amazondotcom.xml,en-US/google.xml
-ast:en-US/google.xml
-be:en-US/google.xml
-bg:en-US/amazondotcom.xml,en-US/google.xml
-bn-BD:en-US/google.xml
-bn-IN:en-US/amazondotcom.xml,en-US/google.xml
-br:br/../fr/amazon-france.xml,en-US/google.xml
-bs:en-US/google.xml
-ca:en-US/google.xml
-cs:en-US/google.xml
-csb:en-US/google.xml
-cy:cy/../en-GB/amazon-en-GB.xml,en-US/google.xml
-da:da/amazon-co-uk.xml,en-US/google.xml
-de:de/amazondotcom-de.xml,en-US/google.xml
-el:el/../en-GB/amazon-en-GB.xml,en-US/google.xml
-en-GB:en-GB/amazon-en-GB.xml,en-GB/google.xml
-en-US:en-US/amazondotcom.xml,en-US/google.xml
-en-ZA:en-US/amazondotcom.xml,en-ZA/google.xml
-eo:en-US/amazondotcom.xml,en-US/google.xml
-es-AR:en-US/amazondotcom.xml,en-US/google.xml
-es-CL:en-US/google.xml
-es-ES:en-US/google.xml
-es-MX:en-US/google.xml
-et:en-US/google.xml
-eu:eu/../en-GB/amazon-en-GB.xml,en-US/google.xml
-fa:en-US/amazondotcom.xml,en-US/google.xml
-fi:en-US/google.xml
-fr:fr/amazon-france.xml,en-US/google.xml
-fy-NL:en-US/google.xml
-ga-IE:ga-IE/../en-GB/amazon-en-GB.xml,en-US/google.xml
-gd:gd/../en-GB/amazon-en-GB.xml,en-US/google.xml
-gl:gl/../en-GB/amazon-en-GB.xml,en-US/google.xml
-gu-IN:en-US/google.xml
-he:en-US/google.xml
-hi-IN:en-US/google.xml
-hr:hr/../en-GB/amazon-en-GB.xml,en-US/google.xml
-hu:en-US/google.xml
-hy-AM:en-US/amazondotcom.xml,en-US/google.xml
-id:en-US/google.xml
-is:en-US/amazondotcom.xml,en-US/google.xml
-it:it/amazon-it.xml,en-US/google.xml
-ja:ja/amazon-jp.xml,ja/google-jp.xml
-kk:en-US/google.xml
-km:en-US/amazondotcom.xml,en-US/google.xml
-kn:en-US/amazondotcom.xml,en-US/google.xml
-ko:en-US/google.xml
-ku:en-US/amazondotcom.xml,ku/google-ku.xml
-lg:en-US/amazondotcom.xml,en-US/google.xml
-lt:en-US/amazondotcom.xml,en-US/google.xml
-lv:en-US/google.xml
-mai:en-US/google.xml
-mk:en-US/amazondotcom.xml,en-US/google.xml
-ml:en-US/google.xml
-mn:en-US/google.xml
-mr:en-US/amazondotcom.xml,en-US/google.xml
-nb-NO:nb-NO/../en-GB/amazon-en-GB.xml,en-US/google.xml
-nl:en-US/google.xml
-nn-NO:nn-NO/../en-GB/amazon-en-GB.xml,en-US/google.xml
-nso:en-US/amazondotcom.xml,en-US/google.xml
-or:en-US/amazondotcom.xml,en-US/google.xml
-pa-IN:en-US/google.xml
-pl:en-US/google.xml
-pt-BR:en-US/google.xml
-pt-PT:pt-PT/../en-GB/amazon-en-GB.xml,en-US/google.xml
-ro:en-US/amazondotcom.xml,en-US/google.xml
-ru:en-US/google.xml
-si:en-US/amazondotcom.xml,en-US/google.xml
-sk:en-US/google.xml
-sl:en-US/google.xml
-sq:sq/amazon-en-GB.xml,en-US/google.xml
-sr:sr/../en-GB/amazon-en-GB.xml,en-US/google.xml
-sv-SE:en-US/google.xml
-sw:en-US/amazondotcom.xml,en-US/google.xml
-ta:en-US/google.xml
-te:en-US/amazondotcom.xml,en-US/google.xml
-th:en-US/amazondotcom.xml,en-US/google.xml
-tr:en-US/amazondotcom.xml,en-US/google.xml
-uk:en-US/google.xml
-vi:en-US/google.xml
-zh-CN:zh-CN/amazondotcn.xml,zh-CN/baidu.xml,en-US/google.xml
-zh-TW:en-US/google.xml
-zu:en-US/amazondotcom.xml,en-US/google.xml
-
-[Additions]
-af:en-US/duckduckgo.xml
-ar:en-US/duckduckgo.xml
-as:en-US/duckduckgo.xml
-ast:en-US/duckduckgo.xml
-be:en-US/duckduckgo.xml
-bg:en-US/duckduckgo.xml
-bn-BD:en-US/duckduckgo.xml
-bn-IN:en-US/duckduckgo.xml
-br:en-US/duckduckgo.xml
-bs:en-US/duckduckgo.xml
-ca:en-US/duckduckgo.xml
-cs:en-US/duckduckgo.xml
-csb:en-US/duckduckgo.xml
-cy:en-US/duckduckgo.xml
-da:en-US/duckduckgo.xml
-de:en-US/duckduckgo.xml
-el:en-US/duckduckgo.xml
-en-GB:en-US/duckduckgo.xml
-en-US:en-US/duckduckgo.xml
-en-ZA:en-US/duckduckgo.xml
-eo:en-US/duckduckgo.xml
-es-AR:en-US/duckduckgo.xml
-es-CL:en-US/duckduckgo.xml
-es-ES:en-US/duckduckgo.xml
-es-MX:en-US/duckduckgo.xml
-et:en-US/duckduckgo.xml
-eu:en-US/duckduckgo.xml
-fa:en-US/duckduckgo.xml
-fi:en-US/duckduckgo.xml
-fr:en-US/duckduckgo.xml
-fy-NL:en-US/duckduckgo.xml
-ga-IE:en-US/duckduckgo.xml
-gd:en-US/duckduckgo.xml
-gl:en-US/duckduckgo.xml
-gu-IN:en-US/duckduckgo.xml
-he:en-US/duckduckgo.xml
-hi-IN:en-US/duckduckgo.xml
-hr:en-US/duckduckgo.xml
-hu:en-US/duckduckgo.xml
-hy-AM:en-US/duckduckgo.xml
-id:en-US/duckduckgo.xml
-is:en-US/duckduckgo.xml
-it:en-US/duckduckgo.xml
-ja:en-US/duckduckgo.xml
-kk:en-US/duckduckgo.xml
-km:en-US/duckduckgo.xml
-kn:en-US/duckduckgo.xml
-ko:en-US/duckduckgo.xml
-ku:en-US/duckduckgo.xml
-lg:en-US/duckduckgo.xml
-lt:en-US/duckduckgo.xml
-lv:en-US/duckduckgo.xml
-mai:en-US/duckduckgo.xml
-mk:en-US/duckduckgo.xml
-ml:en-US/duckduckgo.xml
-mn:en-US/duckduckgo.xml
-mr:en-US/duckduckgo.xml
-nb-NO:en-US/duckduckgo.xml
-nl:en-US/duckduckgo.xml
-nn-NO:en-US/duckduckgo.xml
-nso:en-US/duckduckgo.xml
-or:en-US/duckduckgo.xml
-pa-IN:en-US/duckduckgo.xml
-pl:en-US/duckduckgo.xml
-pt-BR:en-US/duckduckgo.xml
-pt-PT:en-US/duckduckgo.xml
-ro:en-US/duckduckgo.xml
-ru:en-US/duckduckgo.xml
-si:en-US/duckduckgo.xml
-sk:en-US/duckduckgo.xml
-sl:en-US/duckduckgo.xml
-sq:en-US/duckduckgo.xml
-sr:en-US/duckduckgo.xml
-sv-SE:en-US/duckduckgo.xml
-sw:en-US/duckduckgo.xml
-ta:en-US/duckduckgo.xml
-te:en-US/duckduckgo.xml
-th:en-US/duckduckgo.xml
-tr:en-US/duckduckgo.xml
-uk:en-US/duckduckgo.xml
-vi:en-US/duckduckgo.xml
-zh-CN:en-US/duckduckgo.xml
-zh-TW:en-US/duckduckgo.xml
-zu:en-US/duckduckgo.xml

=== modified file 'debian/control.in'
--- debian/control.in	2012-10-26 11:52:57 +0000
+++ debian/control.in	2013-02-20 09:17:36 +0000
@@ -32,13 +32,12 @@
 	libnotify-dev (>= 0.4),
 	libxrender-dev,
 	yasm-1 (>= 1.1) | yasm (>= 1.1),
-	xvfb,
 	libdbusmenu-gtk-dev,
 	unzip,
 	dbus-x11,
-	libxml-simple-perl,
-	libjson-perl
+	xvfb
 Standards-Version: 3.9.1
+XS-Testsuite: autopkgtest
 
 Package: @MOZ_PKG_NAME@
 Architecture: any
@@ -51,13 +50,15 @@
 Provides: www-browser,
 	iceweasel,
 	gnome-www-browser,
-	${app:Provides}
+	${app:Provides},
+	${transitional:Provides}
 Suggests: latex-xft-fonts,
 	libthai0,
 	${support:Suggests}
-Breaks: ${app:Breaks}
-Replaces: ${app:Replaces}
-Conflicts: ${app:Conflicts}
+Breaks: ${transitional:Breaks}
+Replaces: ${transitional:Replaces}
+Conflicts: ${app:Conflicts},
+	${transitional:Conflicts}
 XB-Xul-AppId: {ec8030f7-c20a-464f-9b0e-13a3a9e97384}
 Description: Safe and easy web browser from Mozilla
  Firefox delivers safe, easy web browsing. A familiar user interface,
@@ -70,10 +71,13 @@
 Depends: ${shlibs:Depends}, 
 	${misc:Depends},
 	${gconf:Depends},
+	libnotify4 | libnotify1,
 	@MOZ_PKG_NAME@
-Provides: ${gs:Provides}
-Replaces: ${gs:Replaces}
-Conflicts: ${gs:Conflicts}
+Provides: ${app:Provides}
+	${transitional:Provides}
+Replaces: ${transitional:Replaces}
+Conflicts: ${app:Conflicts},
+	${transitional:Conflicts}
 Description: Safe and easy web browser from Mozilla - GNOME support
  Firefox delivers safe, easy web browsing. A familiar user interface,
  enhanced security features including protection from online identity theft,
@@ -89,9 +93,11 @@
 Depends: ${shlibs:Depends}, 
 	${misc:Depends}, 
 	@MOZ_PKG_NAME@ (= ${binary:Version})
-Provides: ${dbg:Provides}
-Replaces: ${dbg:Replaces}
-Conflicts: ${dbg:Conflicts}
+Provides: ${app:Provides}
+	${transitional:Provides}
+Replaces: ${transitional:Replaces}
+Conflicts: ${app:Conflicts},
+	${transitional:Conflicts}
 Description: Safe and easy web browser from Mozilla - debug symbols
  Firefox delivers safe, easy web browsing. A familiar user interface,
  enhanced security features including protection from online identity theft,
@@ -107,12 +113,14 @@
 Depends: ${shlibs:Depends},
 	${misc:Depends},
 	@MOZ_PKG_NAME@ (= ${binary:Version})
-Provides: ${dev:Provides}
+Provides: ${app:Provides}
+	${transitional:Provides}
+Replaces: ${transitional:Replaces}
 Conflicts: xulrunner-2.0-dev,
 	xulrunner-1.9.2-dev,
 	xulrunner-1.9-dev,
-	${dev:Conflicts}
-Replaces: ${dev:Replaces}
+	${app:Conflicts},
+	${transitional:Conflicts}
 Description: Safe and easy web browser from Mozilla - development files
  Firefox delivers safe, easy web browsing. A familiar user interface,
  enhanced security features including protection from online identity theft,
@@ -125,7 +133,9 @@
 Section: debug
 Priority: extra
 Depends: ${shlibs:Depends}, 
-	${misc:Depends}
+	${misc:Depends},
+Provides: ${app:Provides}
+Conflicts: ${app:Conflicts}
 Description: Safe and easy web browser from Mozilla - Breakpad symbols
  Firefox delivers safe, easy web browsing. A familiar user interface,
  enhanced security features including protection from online identity theft,
@@ -140,8 +150,31 @@
 Depends: ${shlibs:Depends},
 	${misc:Depends},
 	@MOZ_PKG_NAME@ (= ${binary:Version})
-Description: Unity appmenu integration for Firefox
+Provides: ${app:Provides}
+Conflicts: ${app:Conflicts}
+Description: Safe and easy web browser from Mozilla - Unity menubar integration
+ Firefox delivers safe, easy web browsing. A familiar user interface,
+ enhanced security features including protection from online identity theft,
+ and integrated search let you get the most out of the web.
+ .
  This package provides an extension which adds support for the Unity
- appmenu to Firefox 
+ menubar to Firefox 
+
+Package: @MOZ_PKG_NAME@-testsuite
+Architecture: any
+Depends: ${shlibs:Depends},
+	${misc:Depends},
+	@MOZ_PKG_NAME@ (= ${binary:Version}),
+	python,
+	dbus-x11,
+	xvfb
+Provides: ${app:Provides}
+Conflicts: ${app:Conflicts}
+Description: Safe and easy web browser from Mozilla - testsuite
+ Firefox delivers safe, easy web browsing. A familiar user interface,
+ enhanced security features including protection from online identity theft,
+ and integrated search let you get the most out of the web.
+ .
+ This package contains the Firefox testsuite
 
 # Language packs below here

=== modified file 'debian/control.langpacks'
--- debian/control.langpacks	2012-07-23 11:32:05 +0000
+++ debian/control.langpacks	2013-02-20 09:17:36 +0000
@@ -3,8 +3,8 @@
 Architecture: any
 Depends: ${misc:Depends}
 Replaces: language-pack-@LANGCODE@-base
-Conflicts: ${lp:Conflicts}
-Provides: ${lp:Provides}
+Conflicts: ${app:Conflicts}
+Provides: ${app:Provides}
 Description: @LANG@ language pack for Firefox
  This package contains @LANG@ translations and search plugins
  for Firefox

=== modified file 'debian/control.langpacks.unavail'
--- debian/control.langpacks.unavail	2012-07-23 11:32:05 +0000
+++ debian/control.langpacks.unavail	2013-02-20 09:17:36 +0000
@@ -2,6 +2,8 @@
 Package: @MOZ_PKG_NAME@-locale-@LANGCODE@
 Architecture: any
 Depends: ${misc:Depends}
+Conflicts: ${app:Conflicts}
+Provides: ${app:Provides}
 Description: Transitional package for unavailable language
  This language is unavailable for the current version of Firefox
  .

=== added file 'debian/firefox-testsuite.dirs.in'
--- debian/firefox-testsuite.dirs.in	1970-01-01 00:00:00 +0000
+++ debian/firefox-testsuite.dirs.in	2013-02-20 09:17:36 +0000
@@ -0,0 +1,1 @@
+@MOZ_TESTDIR@/xpcshell/package-tests

=== added file 'debian/firefox-testsuite.install.in'
--- debian/firefox-testsuite.install.in	1970-01-01 00:00:00 +0000
+++ debian/firefox-testsuite.install.in	2013-02-20 09:17:36 +0000
@@ -0,0 +1,64 @@
+@MOZ_DISTDIR@/test-package-stage/bin/components @MOZ_LIBDIR@
+@MOZ_DISTDIR@/test-package-stage/bin/plugins @MOZ_ADDONDIR@
+@MOZ_DISTDIR@/test-package-stage/bin/certutil @MOZ_LIBDIR@
+@MOZ_DISTDIR@/test-package-stage/bin/pk12util @MOZ_LIBDIR@
+@MOZ_DISTDIR@/test-package-stage/bin/screentopng @MOZ_LIBDIR@
+@MOZ_DISTDIR@/test-package-stage/bin/ssltunnel @MOZ_LIBDIR@
+@MOZ_DISTDIR@/test-package-stage/bin/xpcshell @MOZ_LIBDIR@
+
+@MOZ_DISTDIR@/test-package-stage/certs @MOZ_TESTDIR@
+
+@MOZ_DISTDIR@/test-package-stage/jsreftest @MOZ_TESTDIR@
+
+@MOZ_DISTDIR@/test-package-stage/mochitest/a11y @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/browser @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/chrome @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/dynamic @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/extensions/worker @MOZ_TESTDIR@/mochitest/extensions
+@MOZ_DISTDIR@/test-package-stage/mochitest/extensions/workerbootstrap @MOZ_TESTDIR@/mochitest/extensions
+@MOZ_DISTDIR@/test-package-stage/mochitest/httpd.js @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/mochijar @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/MochiKit @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/plain-loop.html @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/pywebsocket @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/pywebsocket_wrapper.py @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/redirect.html @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/resources @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/runtests.py @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/server.js @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/server-locations.txt @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/static @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/tests @MOZ_TESTDIR@/mochitest
+@MOZ_DISTDIR@/test-package-stage/mochitest/tests.jar @MOZ_TESTDIR@/mochitest
+
+@MOZ_DISTDIR@/test-package-stage/modules @MOZ_TESTDIR@
+
+@MOZ_DISTDIR@/test-package-stage/reftest/reftest @MOZ_TESTDIR@/reftest
+@MOZ_DISTDIR@/test-package-stage/reftest/runreftest.py @MOZ_TESTDIR@/reftest
+@MOZ_DISTDIR@/test-package-stage/reftest/server-locations.txt @MOZ_TESTDIR@/reftest
+@MOZ_DISTDIR@/test-package-stage/reftest/tests @MOZ_TESTDIR@/reftest
+
+@MOZ_DISTDIR@/test-package-stage/xpcshell/head.js @MOZ_TESTDIR@/xpcshell
+@MOZ_DISTDIR@/test-package-stage/xpcshell/moz-spdy @MOZ_TESTDIR@/xpcshell
+@MOZ_DISTDIR@/test-package-stage/xpcshell/node-spdy @MOZ_TESTDIR@/xpcshell
+@MOZ_DISTDIR@/test-package-stage/xpcshell/runxpcshelltests.py @MOZ_TESTDIR@/xpcshell
+@MOZ_DISTDIR@/test-package-stage/xpcshell/tests @MOZ_TESTDIR@/xpcshell
+
+@MOZ_DISTDIR@/test-package-stage/mochitest/extensions/specialpowers @MOZ_TESTDIR@/extensions
+
+@MOZ_DISTDIR@/test-package-stage/mochitest/automation.py @MOZ_TESTDIR@/python
+@MOZ_DISTDIR@/test-package-stage/mochitest/automationutils.py @MOZ_TESTDIR@/python
+@MOZ_DISTDIR@/test-package-stage/mochitest/manifestparser.py @MOZ_TESTDIR@/python
+@MOZ_DISTDIR@/test-package-stage/xpcshell/mozinfo.json @MOZ_TESTDIR@/python
+@MOZ_DISTDIR@/test-package-stage/xpcshell/mozinfo.py @MOZ_TESTDIR@/python
+
+debian/testing/run_mochitest @MOZ_TESTDIR@
+debian/testing/run_reftest @MOZ_TESTDIR@
+debian/testing/run_xpcshell_tests @MOZ_TESTDIR@
+debian/testing/testrunhelper.py @MOZ_TESTDIR@
+
+debian/testing/mochitest*.json @MOZ_TESTDIR@/mochitest
+
+debian/testing/xpcshell-package-tests/* @MOZ_TESTDIR@/xpcshell/package-tests
+debian/config/locales.shipped @MOZ_TESTDIR@/xpcshell/package-tests/data
+

=== added file 'debian/firefox-testsuite.links.in'
--- debian/firefox-testsuite.links.in	1970-01-01 00:00:00 +0000
+++ debian/firefox-testsuite.links.in	2013-02-20 09:17:36 +0000
@@ -0,0 +1,3 @@
+@MOZ_LIBDIR@ @MOZ_TESTDIR@/bin
+@MOZ_TESTDIR@/extensions/specialpowers @MOZ_TESTDIR@/mochitest/extensions/specialpowers
+@MOZ_TESTDIR@/extensions/specialpowers @MOZ_TESTDIR@/reftest/specialpowers

=== modified file 'debian/firefox.desktop.in'
--- debian/firefox.desktop.in	2012-08-28 10:59:23 +0000
+++ debian/firefox.desktop.in	2013-02-20 09:17:36 +0000
@@ -196,13 +196,15 @@
 StartupNotify=true
 %%if DISTRIB_VERSION >= 1104
 %%if DISTRIB_VERSION >= 1204
-Actions=NewWindow;
+Actions=NewWindow;NewPrivateWindow;
 %%define TARGET_ENV OnlyShowIn=Unity;
 %%define NEW_WINDOW_SECTION [Desktop Action NewWindow]
+%%define NEW_PRIVATE_WINDOW_SECTION [Desktop Action NewPrivateWindow]
 %%else
-X-Ayatana-Desktop-Shortcuts=NewWindow;
+X-Ayatana-Desktop-Shortcuts=NewWindow;NewPrivateWindow;
 %%define TARGET_ENV TargetEnvironment=Unity
 %%define NEW_WINDOW_SECTION [NewWindow Shortcut Group]
+%%define NEW_PRIVATE_WINDOW_SECTION [NewPrivateWindow Shortcut Group]
 %%endif
 
 %%expand __NEW_WINDOW_SECTION__
@@ -241,4 +243,9 @@
 Name[zh_TW]=開啟新視窗
 Exec=@MOZ_APP_NAME@ -new-window
 %%expand __TARGET_ENV__
+
+%%expand __NEW_PRIVATE_WINDOW_SECTION__
+Name=Open a New Private Window
+Exec=@MOZ_APP_NAME@ -private-window
+%%expand __TARGET_ENV__
 %%endif

=== modified file 'debian/firefox.install.in'
--- debian/firefox.install.in	2013-01-08 12:48:17 +0000
+++ debian/firefox.install.in	2013-02-20 09:17:36 +0000
@@ -23,8 +23,6 @@
 @MOZ_LIBDIR@/extensions/\{972ce4c6-7e08-4474-a285-3208198ce6fd\} @MOZ_ADDONDIR@/extensions
 %%if MOZ_UPDATE_CHANNEL == beta
 %%define SHIP_TESTPILOT
-%%elif MOZ_UPDATE_CHANNEL == aurora
-%%define SHIP_TESTPILOT
 %%endif
 %%ifdef SHIP_TESTPILOT
 @MOZ_LIBDIR@/distribution/extensions/testpilot@labs.mozilla.com.xpi @MOZ_ADDONDIR@/distribution/extensions

=== modified file 'debian/patches/fix-broken-langpack-install-manifests.patch'
--- debian/patches/fix-broken-langpack-install-manifests.patch	2013-02-06 20:24:58 +0000
+++ debian/patches/fix-broken-langpack-install-manifests.patch	2013-02-20 09:17:36 +0000
@@ -1,15 +1,15 @@
-Index: firefox-19.0~b1+build2/l10n/nso/browser/defines.inc
+Index: firefox-20.0~a2~hg20130124r123781/l10n/kn/browser/defines.inc
 ===================================================================
---- firefox-19.0~b1+build2.orig/l10n/nso/browser/defines.inc	2013-01-08 21:53:51.000000000 +0000
-+++ firefox-19.0~b1+build2/l10n/nso/browser/defines.inc	2013-01-16 22:25:12.596262823 +0000
+--- firefox-20.0~a2~hg20130124r123781.orig/l10n/kn/browser/defines.inc	2013-01-25 15:12:51.299741042 +0000
++++ firefox-20.0~a2~hg20130124r123781/l10n/kn/browser/defines.inc	2013-01-25 15:12:51.291741042 +0000
 @@ -1,8 +1,8 @@
 -# This Source Code Form is subject to the terms of the Mozilla Public# License, v. 2.0. If a copy of the MPL was not distributed with this# file, You can obtain one at http://mozilla.org/MPL/2.0/.#filter emptyLines
 +#filter emptyLines
- #define MOZ_LANGPACK_CREATOR Translate.org.za
+ #define MOZ_LANGPACK_CREATOR mozilla.org
  
  # If non-English locales wish to credit multiple contributors, uncomment this
  # variable definition and use the format specified.
- #define MOZ_LANGPACK_CONTRIBUTORS <em:contributor>Translate.org.za</em:contributor> <em:contributor>Dwayne Bailey</em:contributor> <em:contributor>Pheledi Mathibela</em:contributor>
+ #define MOZ_LANGPACK_CONTRIBUTORS <em:contributor>Shankar Prasad</em:contributor>
  
 -#unfilter emptyLines
 \ No newline at end of file

=== removed file 'debian/patches/ionmonkey-hardfp-support.patch'
--- debian/patches/ionmonkey-hardfp-support.patch	2013-01-08 12:48:17 +0000
+++ debian/patches/ionmonkey-hardfp-support.patch	1970-01-01 00:00:00 +0000
@@ -1,243 +0,0 @@
-Index: firefox-19.0~a2~hg20121213r118806/js/src/ion/arm/Architecture-arm.h
-===================================================================
---- firefox-19.0~a2~hg20121213r118806.orig/js/src/ion/arm/Architecture-arm.h	2012-12-13 06:04:55.000000000 +0000
-+++ firefox-19.0~a2~hg20121213r118806/js/src/ion/arm/Architecture-arm.h	2012-12-13 21:27:57.510341208 +0000
-@@ -10,6 +10,10 @@
- 
- #include <limits.h>
- 
-+// gcc appears to use __ARM_PCS_VFP to denote that the target is a hard-float target.
-+#ifdef __ARM_PCS_VFP
-+#define JS_CPU_ARM_HARDFP
-+#endif
- namespace js {
- namespace ion {
- 
-@@ -195,8 +199,8 @@
- 
-     static const uint32 WrapperMask = VolatileMask;
- 
--    // d0 is the ARM scratch float register.
--    static const uint32 NonAllocatableMask = (1 << d0) | (1 << invalid_freg);
-+    // d1 is the ARM scratch float register.
-+    static const uint32 NonAllocatableMask = (1 << d1) | (1 << invalid_freg);
- 
-     // Registers that can be allocated without being saved, generally.
-     static const uint32 TempMask = VolatileMask & ~NonAllocatableMask;
-Index: firefox-19.0~a2~hg20121213r118806/js/src/ion/arm/Assembler-arm.h
-===================================================================
---- firefox-19.0~a2~hg20121213r118806.orig/js/src/ion/arm/Assembler-arm.h	2012-12-13 06:04:55.000000000 +0000
-+++ firefox-19.0~a2~hg20121213r118806/js/src/ion/arm/Assembler-arm.h	2012-12-13 21:28:41.102340433 +0000
-@@ -64,8 +64,8 @@
- static const Register StackPointer = sp;
- static const Register FramePointer = InvalidReg;
- static const Register ReturnReg = r0;
--static const FloatRegister ReturnFloatReg = { FloatRegisters::d1 };
--static const FloatRegister ScratchFloatReg = { FloatRegisters::d0 };
-+static const FloatRegister ReturnFloatReg = { FloatRegisters::d0 };
-+static const FloatRegister ScratchFloatReg = { FloatRegisters::d1 };
- 
- static const FloatRegister d0  = {FloatRegisters::d0};
- static const FloatRegister d1  = {FloatRegisters::d1};
-@@ -1935,9 +1935,56 @@
-     }
- };
- 
--static const uint32 NumArgRegs = 4;
-+static const uint32 NumIntArgRegs = 4;
-+static const uint32 NumFloatArgRegs = 8;
-+
-+#ifdef JS_CPU_ARM_HARDFP
-+static inline bool
-+GetIntArgReg(uint32 usedIntArgs, uint32 usedFloatArgs, Register *out)
-+{
-+   if (usedIntArgs >= NumIntArgRegs)
-+        return false;
-+    *out = Register::FromCode(usedIntArgs);
-+    return true;
-+}
-+
-+static inline bool
-+GetFloatArgReg(uint32 usedIntArgs, uint32 usedFloatArgs, FloatRegister *out)
-+{
-+    if (usedFloatArgs >= NumFloatArgRegs)
-+        return false;
-+    *out = FloatRegister::FromCode(usedFloatArgs);
-+    return true;
-+}
-+
-+static inline uint32
-+GetIntArgStackDisp(uint32 usedIntArgs, uint32 usedFloatArgs, uint32 *padding)
-+{
-+    JS_ASSERT(usedIntArgs >= NumIntArgRegs);
-+    uint32 doubleSlots = Max(0, (int32_t)usedFloatArgs - (int32_t)NumFloatArgRegs);
-+    doubleSlots *= 2;
-+    int intSlots = usedIntArgs - NumIntArgRegs;
-+    return (intSlots + doubleSlots + *padding) * STACK_SLOT_SIZE;
-+}
-+
-+static inline uint32
-+GetFloatArgStackDisp(uint32 usedIntArgs, uint32 usedFloatArgs, uint32 *padding)
-+{
-+
-+    JS_ASSERT(usedFloatArgs >= NumFloatArgRegs);
-+    uint32 intSlots = 0;
-+    if (usedIntArgs > NumIntArgRegs) {
-+        intSlots = usedIntArgs - NumIntArgRegs;
-+        // update the amount of padding required.
-+        *padding += (*padding + usedIntArgs) % 2;
-+    }
-+    uint32 doubleSlots = usedFloatArgs - NumFloatArgRegs;
-+    doubleSlots *= 2;
-+    return (intSlots + doubleSlots + *padding) * STACK_SLOT_SIZE;
-+}
-+#else
- static inline bool
--GetArgReg(uint32 arg, Register *out)
-+GetIntArgReg(uint32 arg, uint32 floatArg, Register *out)
- {
-     if (arg < 4) {
-         *out = Register::FromCode(arg);
-@@ -1949,10 +1996,11 @@
- static inline uint32
- GetArgStackDisp(uint32 arg)
- {
--    JS_ASSERT(arg >= NumArgRegs);
--    return (arg - NumArgRegs) * STACK_SLOT_SIZE;
-+    JS_ASSERT(arg >= NumIntArgRegs);
-+    return (arg - NumIntArgRegs) * STACK_SLOT_SIZE;
- }
- 
-+#endif
- class DoubleEncoder {
-     uint32 rep(bool b, uint32 count) {
-         uint32 ret = 0;
-Index: firefox-19.0~a2~hg20121213r118806/js/src/ion/arm/MacroAssembler-arm.cpp
-===================================================================
---- firefox-19.0~a2~hg20121213r118806.orig/js/src/ion/arm/MacroAssembler-arm.cpp	2012-12-13 06:04:55.000000000 +0000
-+++ firefox-19.0~a2~hg20121213r118806/js/src/ion/arm/MacroAssembler-arm.cpp	2012-12-13 21:35:56.938332689 +0000
-@@ -2635,7 +2635,13 @@
-     inCall_ = true;
-     args_ = args;
-     passedArgs_ = 0;
-+#ifdef JS_CPU_ARM_HARDFP
-+    usedIntSlots_ = 0;
-+    usedFloatSlots_ = 0;
-+    padding_ = 0;
-+#else
-     usedSlots_ = 0;
-+#endif
-     floatArgsInGPR[0] = VFPRegister();
-     floatArgsInGPR[1] = VFPRegister();
- }
-@@ -2661,6 +2667,42 @@
-     ma_push(scratch);
- }
- 
-+#ifdef JS_CPU_ARM_HARDFP
-+void
-+MacroAssemblerARMCompat::passABIArg(const MoveOperand &from)
-+{
-+    MoveOperand to;
-+    uint32 increment = 1;
-+    bool useResolver = true;
-+    ++passedArgs_;
-+    Move::Kind kind = Move::GENERAL;
-+    if (!enoughMemory_)
-+        return;
-+    if (from.isDouble()) {
-+        FloatRegister fr;
-+        if (GetFloatArgReg(usedIntSlots_, usedFloatSlots_, &fr)) {
-+            enoughMemory_ = moveResolver_.addMove(from, MoveOperand(fr), Move::DOUBLE);
-+        } else {
-+            // If (and only if) the integer registers have started spilling, do we
-+            // need to take the double register's alignment into accoun
-+            uint32 disp = GetFloatArgStackDisp(usedIntSlots_, usedFloatSlots_, &padding_);
-+            enoughMemory_ = moveResolver_.addMove(from, MoveOperand(sp, disp), Move::DOUBLE);
-+        }
-+        usedFloatSlots_++;
-+    } else {
-+        Register r;
-+        if (GetIntArgReg(usedIntSlots_, usedFloatSlots_, &r)) {
-+            enoughMemory_ = moveResolver_.addMove(from, MoveOperand(r), Move::GENERAL);
-+        } else {
-+            uint32 disp = GetIntArgStackDisp(usedIntSlots_, usedFloatSlots_, &padding_);
-+            fprintf(stderr, "Float on the stack! (%d)\n", disp);
-+            enoughMemory_ = moveResolver_.addMove(from, MoveOperand(sp, disp), Move::GENERAL);
-+        }
-+            usedIntSlots_++;
-+    }
-+}
-+
-+#else
- void
- MacroAssemblerARMCompat::passABIArg(const MoveOperand &from)
- {
-@@ -2679,7 +2721,7 @@
- 
-     Register destReg;
-     MoveOperand dest;
--    if (GetArgReg(usedSlots_, &destReg)) {
-+    if (GetIntArgReg(usedSlots_, 0, &destReg)) {
-         if (from.isDouble()) {
-             floatArgsInGPR[destReg.code() >> 1] = VFPRegister(from.floatReg());
-             useResolver = false;
-@@ -2695,6 +2737,7 @@
-         enoughMemory_ = enoughMemory_ && moveResolver_.addMove(from, dest, kind);
-     usedSlots_ += increment;
- }
-+#endif
- 
- void
- MacroAssemblerARMCompat::passABIArg(const Register &reg)
-@@ -2723,7 +2766,12 @@
- MacroAssemblerARMCompat::callWithABI(void *fun, Result result)
- {
-     JS_ASSERT(inCall_);
--    uint32 stackAdjust = ((usedSlots_ > NumArgRegs) ? usedSlots_ - NumArgRegs : 0) * STACK_SLOT_SIZE;
-+#ifdef JS_CPU_ARM_HARDFP
-+    uint32 stackAdjust = ((usedIntSlots_ > NumIntArgRegs) ? usedIntSlots_ - NumIntArgRegs : 0) * STACK_SLOT_SIZE;
-+    stackAdjust += 2*((usedFloatSlots_ > NumFloatArgRegs) ? usedFloatSlots_ - NumFloatArgRegs : 0) * STACK_SLOT_SIZE;
-+#else
-+    uint32 stackAdjust = ((usedSlots_ > NumIntArgRegs) ? usedSlots_ - NumIntArgRegs : 0) * STACK_SLOT_SIZE;
-+#endif
-     if (!dynamicAlignment_)
-         stackAdjust +=
-             ComputeByteAlignment(framePushed_ + stackAdjust, StackAlignment);
-@@ -2750,8 +2798,12 @@
-     ma_call(fun);
- 
-     if (result == DOUBLE) {
-+#ifdef JS_CPU_ARM_HARDFP
-+        as_vmov(ReturnFloatReg, d0);
-+#else
-         // Move double from r0/r1 to ReturnFloatReg.
-         as_vxfer(r0, r1, ReturnFloatReg, CoreToFloat);
-+#endif
-     }
- 
-     freeStack(stackAdjust);
-Index: firefox-19.0~a2~hg20121213r118806/js/src/ion/arm/MacroAssembler-arm.h
-===================================================================
---- firefox-19.0~a2~hg20121213r118806.orig/js/src/ion/arm/MacroAssembler-arm.h	2012-12-13 06:04:55.000000000 +0000
-+++ firefox-19.0~a2~hg20121213r118806/js/src/ion/arm/MacroAssembler-arm.h	2012-12-13 21:34:49.638333885 +0000
-@@ -321,6 +321,11 @@
-     // the initial number of arguments declared was correct.
-     uint32 passedArgs_;
- 
-+#ifdef JS_CPU_ARM_HARDFP
-+    uint32 usedIntSlots_;
-+    uint32 usedFloatSlots_;
-+    uint32 padding_;
-+#else
-     // ARM treats arguments as a vector in registers/memory, that looks like:
-     // { r0, r1, r2, r3, [sp], [sp,+4], [sp,+8] ... }
-     // usedSlots_ keeps track of how many of these have been used.
-@@ -328,6 +333,7 @@
-     // can effectively use between one and three slots depending on its size and
-     // alignment requirements
-     uint32 usedSlots_;
-+#endif
-     bool dynamicAlignment_;
- 
-     bool enoughMemory_;

=== added file 'debian/patches/python-virtualenv-multiarch-fix.patch'
--- debian/patches/python-virtualenv-multiarch-fix.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/python-virtualenv-multiarch-fix.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,71 @@
+Index: firefox-trunk-20.0~a1~hg20121212r115619/python/virtualenv/virtualenv_embedded/site.py
+===================================================================
+--- firefox-trunk-20.0~a1~hg20121212r115619.orig/python/virtualenv/virtualenv_embedded/site.py	2012-12-13 16:32:34.467045788 +0000
++++ firefox-trunk-20.0~a1~hg20121212r115619/python/virtualenv/virtualenv_embedded/site.py	2012-12-13 16:33:06.187045225 +0000
+@@ -586,7 +586,8 @@
+                 paths.append(lib64_path)
+         # This is hardcoded in the Python executable, but relative to sys.prefix:
+         plat_path = os.path.join(sys.real_prefix, 'lib', 'python'+sys.version[:3],
+-                                 'plat-%s' % sys.platform)
++                                 [os.path.basename(d) for d in sys.path if os.path.basename(d).startswith('plat-') and
++                                  os.path.dirname(d) == os.path.join(sys.prefix, 'lib', 'python'+sys.version[:3])][0])
+         if os.path.exists(plat_path):
+             paths.append(plat_path)
+     # This is hardcoded in the Python executable, but
+Index: firefox-trunk-20.0~a1~hg20121212r115619/python/virtualenv/virtualenv.py
+===================================================================
+--- firefox-trunk-20.0~a1~hg20121212r115619.orig/python/virtualenv/virtualenv.py	2012-12-12 02:12:10.000000000 +0000
++++ firefox-trunk-20.0~a1~hg20121212r115619/python/virtualenv/virtualenv.py	2012-12-13 16:41:27.107036324 +0000
+@@ -1945,29 +1945,29 @@
+ O4tEzg+eKcSOcf5SqBpKM6/tnEIzxur0PZv1pAuzm3IVqkqbgle/bhSKo1qM/2kHMRXfWg9wcSwK
+ LVsgW9BvEk9ayX/20jVMDNTo+SuLnsuk73AKv+HFKfBeE9R1dLYeWuoMewu2Z0+uyyj5CKpp2HD8
+ gx7Vk0SpnSPeaYXHk43Euaz/BB4O6ZIZYpqvWsfC/07m4aT9bYeLHSy/+XoXnq6C6a2Y6FnQx1Yx
+-8KK3SxeahTef/qCXxzJ9Xf940dkqGE9d/kdkBTwsZY+XsF3S9WQq6V79tMING6ZLL2N+g4a3Lo5t
+-QMMoHjxwGrpJdPipbnsrf1jpoAaubsNd0+f+u+auWwR25uYMuTN3v8LPpYHuu51f+mjAm0lNiEdl
+-pjdqoV/juMpirFMX+gOj+oPkdzvhTLfonofAmEQJDLMSm2rsjW1YxTP3O+bhHPAltm5BZ69Fak27
+-o1jaHP8Yc8I5B/jc1nhTIslccyB7p3Qr2YRTEyfy5kZNYrwRb0JbGkqj6fiqxkl+RxeayVhtjG+L
+-18YACMNNOuHRzWkGxoBtE9/My1kozv0ggoamXE0n+VMlc45TaUcawEUcn6L+Jv7J2ZuDVGJYUdVl
+-UcLeY6Dvb+X0iL6M0gaoCZesYnVrUDc9xvo6TxyCc3JMEShHxXg/41EHCME63rmcitOhJxP7Dvjl
+-eVPsnowtQ8isXskyrpqLXvzD2ATsSzMClf7iAjsBkUYyW5ziIpZY/nCQwpCE/f6VduW9rcyOCveR
+-1XqPZyvqoQNtTymed2yP4ebk3l705l4wNKdrgV1XwjZruM9ebgNLYW4tI12pIxT8Vt+kxPdzcvwU
+-nRGHj0Du3cI3PwnYqjV2hSwazjNXMXSvzsHabbLFfTfidbige/ddaztjx/f1hmWWjhOypbGlonbg
+-ehVPM9qo2bdjvt4D+3Y/J/uJ+3YP/iP37fr+QjA4Gh+tD3qztB/Y4LOacC8DbBgB+kyASHh+2LpK
+-zpjMoZvzDJvr5H5gL+NlnekUUhkzgRzZvSWKQPClf8pNEPUu5dq1b/elix5/f/Hh9ekF0WJyefrm
+-P0+/p5wYDFK3bNajAxtZfsDUPvCyb90gh85j6Bu8wbbndk0uIdEQOu87R8A9EPrLhfoWtK3I3Nfb
+-OnTKLrqdAPHd025B3aayeyF3/DOd4u9mL7TSZAP9lHMazS/nYNg8MucjLA7N+Yd534SstYx2Inrb
+-Fs7JLuyqE+236vsYt0QbRzbHlVYAI9XIXzZQbQoWbDiUHZX2/yKBEnOx2MvcZQJSOJPOnXp0nR6D
+-qvz/F0MJyi7G0zZ2GMf2XmNqx0F5ZS/sxhO3mYwMQbxqq0F3fq6wz2W6hQpBwApP3xjHiBj9p4+x
+-7KHvMyWuDqiu8wCVzbX9hWumndy/J3i0W9mblxTnh/DhFjRe1Kl7XGv7dDqQ80dnAPnCKSQAzXcI
+-dG7EUwF7o8/ECnG6ESFsJPWxJOYmEh31tWkO8mg3HewNrZ6Lg21Vf27VmxAvtjectwrrdI8j7qEe
+-6KFqU1vlWGBMkttWzie+I8h8iCToqiXP+cCTS33DL3y9u3pxbEO6yO/42lEklMwzcAz7lZMMt/N6
+-P6c7MUs5pmwp3LM5xaC6xbUDlX2CbXucTkXAln2QOV1mSAPvfX9UxfTwri0ftDG1rHcMUxLDZ2pE
+-03JqKDTu9smoO91GbXWBcD3II4B0VCDAQjAd3ejk5204yXb4XO8KpzVdjOrG9UNHKihXx+cI7mF8
+-vwa/dneq43xUd0bR9OcGbQ7USw7Czb4Dtxp5IZHtJqE99YYPtrgAXBLb3//FI/p3s8hs96NdfrVt
+-9bK3DIt9WUw8xHyMFonM4wiMDOjNIWlrzFY3go63gDR0dBmqmRvyBTp+lMyI1x7TBoOc2Yn2AKxR
+-CP4PNIke9w==
++8KK3SxeahTef/qCXxzJ9Xf940dkqGE9d/kdkBVj+wnQSsnlz3t/N3YsE3GVxGnr7ARJXTjp8eNhO
++aABGPdlxRv0gn4Nl3MVE25TCLoXw5IXVvfqXF/eYmOG9jPkN+gp1cWxjMEZX4hnZ0M37w09121us
++xHoSjUZ1G+6aPvffNXfdIrAzN8fenbn7RYkuDXTf7SzeRwPe/2pCPCqZvtFk/UrS1W9jnW3RH8vV
++HyS/2wlnukVdPgTG5HZgZJgEQmNvzNkqnrnfMXXogO/ddWtQe41oa9odXdjm+MdYQE6TwOe2LJ1y
++X+aaA9mhpovUJpxNOZE3N2oS4yV+E9qFUeZPx702fv07uoNNxmpj3HG86QZAGG7SOZpuGjYwBuz0
+++DJhViWuJqKhKb3UyVdVyZxDa9r3B3ARh9SovwnZcsLpIJUYCVV1WZSwXRroK2c5o6MvCbYBaiI8
++q1jdGtRNj7G+gRSH4DQiU7fKgTzegnnUAUKwWXLu0+IM7snEvgN+ed7U5ydjyxAyq1eyjKvmbhr/
++/DgBk9iMQNXKuMCOzm4ks8UpLmKJ5Q8HKYyi2O9f6d2Ht/vaUZQ/slrv8WxFPXRs8Cn1/o65NNyc
++3Nu76dw7keZ0k7Hr/dhmDffZ+3hgKcxFa6QrdVCF3+rLn/hKUQ75ov/k8BHIvVur5+ctW7XG3ptF
++w3nmKobubT9Ybk7uQ98lfh0u6F7X19qB2fF9vWGZpeM3bWlsqah9zl7F04w2akINmGL4QKjBTyN/
++YqjBg//IUIO+chEMjsZH64PexPIHYhKsJtz7CxtGgD4TIBIeebZuvzMmc+imaRe5Su4H9v5g1pmO
++S9Zx47yLrQgE31Oo3JxW7x6xXaEGX7ro8fcXH16fXhAtJpenb/7z9HtK48G4estmPToWk+UHTO0D
++L2HYjcvo1Iu+wRtsey4E5aoXDaHzvnNq3QOhv8Kpb0Hbisx9va1Dp1Kk2wkQ3z3tFtRtKrsXcsc/
++01UJbsJFK7M30E85DdP8cs6yzSNzpMPi0BzZmPdNlF3LaCcIuW3hnITIrjrRfqu+QnJLgHRk03Jp
++BTC4jvxlY+umxsJGcNlRaf9fHSiXGOvTzPUrIIUz6VwDSDcAMqjK/99HlKDsYjwgZIdxbK9ipnZ8
++jqDsHeN4SDiTkSGIVyA26M7PFfa5TLdQIQhY4elL7hgRo//0yZs9p36mxNUBlaIeoLK5tr9wzbST
+++/cET6Mre1mU4pQWPo+Dxos6dU+YbZ9OB3L+6NgiXzi1D6D5DoHOjXgqYG/0mVghTjcifKZCfZKK
++6ZRER33Tm4M82k0He0Or5+JgW6GiW6gnxIvtDeetWkDd44h7qAd6qNqUgzkWGPP6tlUgiu8IMp97
++CbodynM+8LBVX0oMX++uXhzbKDTyO752FAnlHw0cw37l5O/tvJHQ6U7MUo4pwQv3bE79qm5x7UBl
++n2DbHqdTxLBlH2QOxBnSwHvfHwgyPbyb1gdtTC3rHcOUxPCZGtG0nLIPjbt9MupOt1FbXSBcwvII
++IB0VCLAQTEc3OimFG84LHj7Xu8JpTXe5ukcRoSMVlF7kcwT3ML5fg1+7O5WePqo7o2j6c4M2B+ol
++B+Fm34FbjbyQyHaT0J56wwdbXACu4u3v/+IR/buJb7b70S6/2rZ62Vs5xr4s5kpiCkmLROZxBEYG
++9OaQtDUm2BtBx4tLGjq6DNXMDfkCHT/Kv8SbmmmDQc7sRHsA1igE/wehqlVV
+ """)
+ 
+ ##file ez_setup.py

=== removed file 'debian/patches/python-virtualenv-multiarch-fix.patch'
--- debian/patches/python-virtualenv-multiarch-fix.patch	2013-01-08 12:48:17 +0000
+++ debian/patches/python-virtualenv-multiarch-fix.patch	1970-01-01 00:00:00 +0000
@@ -1,71 +0,0 @@
-Index: firefox-trunk-20.0~a1~hg20121212r115619/python/virtualenv/virtualenv_embedded/site.py
-===================================================================
---- firefox-trunk-20.0~a1~hg20121212r115619.orig/python/virtualenv/virtualenv_embedded/site.py	2012-12-13 16:32:34.467045788 +0000
-+++ firefox-trunk-20.0~a1~hg20121212r115619/python/virtualenv/virtualenv_embedded/site.py	2012-12-13 16:33:06.187045225 +0000
-@@ -586,7 +586,8 @@
-                 paths.append(lib64_path)
-         # This is hardcoded in the Python executable, but relative to sys.prefix:
-         plat_path = os.path.join(sys.real_prefix, 'lib', 'python'+sys.version[:3],
--                                 'plat-%s' % sys.platform)
-+                                 [os.path.basename(d) for d in sys.path if os.path.basename(d).startswith('plat-') and
-+                                  os.path.dirname(d) == os.path.join(sys.prefix, 'lib', 'python'+sys.version[:3])][0])
-         if os.path.exists(plat_path):
-             paths.append(plat_path)
-     # This is hardcoded in the Python executable, but
-Index: firefox-trunk-20.0~a1~hg20121212r115619/python/virtualenv/virtualenv.py
-===================================================================
---- firefox-trunk-20.0~a1~hg20121212r115619.orig/python/virtualenv/virtualenv.py	2012-12-12 02:12:10.000000000 +0000
-+++ firefox-trunk-20.0~a1~hg20121212r115619/python/virtualenv/virtualenv.py	2012-12-13 16:41:27.107036324 +0000
-@@ -1945,29 +1945,29 @@
- O4tEzg+eKcSOcf5SqBpKM6/tnEIzxur0PZv1pAuzm3IVqkqbgle/bhSKo1qM/2kHMRXfWg9wcSwK
- LVsgW9BvEk9ayX/20jVMDNTo+SuLnsuk73AKv+HFKfBeE9R1dLYeWuoMewu2Z0+uyyj5CKpp2HD8
- gx7Vk0SpnSPeaYXHk43Euaz/BB4O6ZIZYpqvWsfC/07m4aT9bYeLHSy/+XoXnq6C6a2Y6FnQx1Yx
--8KK3SxeahTef/qCXxzJ9Xf940dkqGE9d/kdkBTwsZY+XsF3S9WQq6V79tMING6ZLL2N+g4a3Lo5t
--QMMoHjxwGrpJdPipbnsrf1jpoAaubsNd0+f+u+auWwR25uYMuTN3v8LPpYHuu51f+mjAm0lNiEdl
--pjdqoV/juMpirFMX+gOj+oPkdzvhTLfonofAmEQJDLMSm2rsjW1YxTP3O+bhHPAltm5BZ69Fak27
--o1jaHP8Yc8I5B/jc1nhTIslccyB7p3Qr2YRTEyfy5kZNYrwRb0JbGkqj6fiqxkl+RxeayVhtjG+L
--18YACMNNOuHRzWkGxoBtE9/My1kozv0ggoamXE0n+VMlc45TaUcawEUcn6L+Jv7J2ZuDVGJYUdVl
--UcLeY6Dvb+X0iL6M0gaoCZesYnVrUDc9xvo6TxyCc3JMEShHxXg/41EHCME63rmcitOhJxP7Dvjl
--eVPsnowtQ8isXskyrpqLXvzD2ATsSzMClf7iAjsBkUYyW5ziIpZY/nCQwpCE/f6VduW9rcyOCveR
--1XqPZyvqoQNtTymed2yP4ebk3l705l4wNKdrgV1XwjZruM9ebgNLYW4tI12pIxT8Vt+kxPdzcvwU
--nRGHj0Du3cI3PwnYqjV2hSwazjNXMXSvzsHabbLFfTfidbige/ddaztjx/f1hmWWjhOypbGlonbg
--ehVPM9qo2bdjvt4D+3Y/J/uJ+3YP/iP37fr+QjA4Gh+tD3qztB/Y4LOacC8DbBgB+kyASHh+2LpK
--zpjMoZvzDJvr5H5gL+NlnekUUhkzgRzZvSWKQPClf8pNEPUu5dq1b/elix5/f/Hh9ekF0WJyefrm
--P0+/p5wYDFK3bNajAxtZfsDUPvCyb90gh85j6Bu8wbbndk0uIdEQOu87R8A9EPrLhfoWtK3I3Nfb
--OnTKLrqdAPHd025B3aayeyF3/DOd4u9mL7TSZAP9lHMazS/nYNg8MucjLA7N+Yd534SstYx2Inrb
--Fs7JLuyqE+236vsYt0QbRzbHlVYAI9XIXzZQbQoWbDiUHZX2/yKBEnOx2MvcZQJSOJPOnXp0nR6D
--qvz/F0MJyi7G0zZ2GMf2XmNqx0F5ZS/sxhO3mYwMQbxqq0F3fq6wz2W6hQpBwApP3xjHiBj9p4+x
--7KHvMyWuDqiu8wCVzbX9hWumndy/J3i0W9mblxTnh/DhFjRe1Kl7XGv7dDqQ80dnAPnCKSQAzXcI
--dG7EUwF7o8/ECnG6ESFsJPWxJOYmEh31tWkO8mg3HewNrZ6Lg21Vf27VmxAvtjectwrrdI8j7qEe
--6KFqU1vlWGBMkttWzie+I8h8iCToqiXP+cCTS33DL3y9u3pxbEO6yO/42lEklMwzcAz7lZMMt/N6
--P6c7MUs5pmwp3LM5xaC6xbUDlX2CbXucTkXAln2QOV1mSAPvfX9UxfTwri0ftDG1rHcMUxLDZ2pE
--03JqKDTu9smoO91GbXWBcD3II4B0VCDAQjAd3ejk5204yXb4XO8KpzVdjOrG9UNHKihXx+cI7mF8
--vwa/dneq43xUd0bR9OcGbQ7USw7Czb4Dtxp5IZHtJqE99YYPtrgAXBLb3//FI/p3s8hs96NdfrVt
--9bK3DIt9WUw8xHyMFonM4wiMDOjNIWlrzFY3go63gDR0dBmqmRvyBTp+lMyI1x7TBoOc2Yn2AKxR
--CP4PNIke9w==
-+8KK3SxeahTef/qCXxzJ9Xf940dkqGE9d/kdkBVj+wnQSsnlz3t/N3YsE3GVxGnr7ARJXTjp8eNhO
-+aABGPdlxRv0gn4Nl3MVE25TCLoXw5IXVvfqXF/eYmOG9jPkN+gp1cWxjMEZX4hnZ0M37w09121us
-+xHoSjUZ1G+6aPvffNXfdIrAzN8fenbn7RYkuDXTf7SzeRwPe/2pCPCqZvtFk/UrS1W9jnW3RH8vV
-+HyS/2wlnukVdPgTG5HZgZJgEQmNvzNkqnrnfMXXogO/ddWtQe41oa9odXdjm+MdYQE6TwOe2LJ1y
-+X+aaA9mhpovUJpxNOZE3N2oS4yV+E9qFUeZPx702fv07uoNNxmpj3HG86QZAGG7SOZpuGjYwBuz0
-++DJhViWuJqKhKb3UyVdVyZxDa9r3B3ARh9SovwnZcsLpIJUYCVV1WZSwXRroK2c5o6MvCbYBaiI8
-+q1jdGtRNj7G+gRSH4DQiU7fKgTzegnnUAUKwWXLu0+IM7snEvgN+ed7U5ydjyxAyq1eyjKvmbhr/
-+/DgBk9iMQNXKuMCOzm4ks8UpLmKJ5Q8HKYyi2O9f6d2Ht/vaUZQ/slrv8WxFPXRs8Cn1/o65NNyc
-+3Nu76dw7keZ0k7Hr/dhmDffZ+3hgKcxFa6QrdVCF3+rLn/hKUQ75ov/k8BHIvVur5+ctW7XG3ptF
-+w3nmKobubT9Ybk7uQ98lfh0u6F7X19qB2fF9vWGZpeM3bWlsqah9zl7F04w2akINmGL4QKjBTyN/
-+YqjBg//IUIO+chEMjsZH64PexPIHYhKsJtz7CxtGgD4TIBIeebZuvzMmc+imaRe5Su4H9v5g1pmO
-+S9Zx47yLrQgE31Oo3JxW7x6xXaEGX7ro8fcXH16fXhAtJpenb/7z9HtK48G4estmPToWk+UHTO0D
-+L2HYjcvo1Iu+wRtsey4E5aoXDaHzvnNq3QOhv8Kpb0Hbisx9va1Dp1Kk2wkQ3z3tFtRtKrsXcsc/
-+01UJbsJFK7M30E85DdP8cs6yzSNzpMPi0BzZmPdNlF3LaCcIuW3hnITIrjrRfqu+QnJLgHRk03Jp
-+BTC4jvxlY+umxsJGcNlRaf9fHSiXGOvTzPUrIIUz6VwDSDcAMqjK/99HlKDsYjwgZIdxbK9ipnZ8
-+jqDsHeN4SDiTkSGIVyA26M7PFfa5TLdQIQhY4elL7hgRo//0yZs9p36mxNUBlaIeoLK5tr9wzbST
-++/cET6Mre1mU4pQWPo+Dxos6dU+YbZ9OB3L+6NgiXzi1D6D5DoHOjXgqYG/0mVghTjcifKZCfZKK
-+6ZRER33Tm4M82k0He0Or5+JgW6GiW6gnxIvtDeetWkDd44h7qAd6qNqUgzkWGPP6tlUgiu8IMp97
-+CbodynM+8LBVX0oMX++uXhzbKDTyO752FAnlHw0cw37l5O/tvJHQ6U7MUo4pwQv3bE79qm5x7UBl
-+n2DbHqdTxLBlH2QOxBnSwHvfHwgyPbyb1gdtTC3rHcOUxPCZGtG0nLIPjbt9MupOt1FbXSBcwvII
-+IB0VCLAQTEc3OimFG84LHj7Xu8JpTXe5ukcRoSMVlF7kcwT3ML5fg1+7O5WePqo7o2j6c4M2B+ol
-+B+Fm34FbjbyQyHaT0J56wwdbXACu4u3v/+IR/buJb7b70S6/2rZ62Vs5xr4s5kpiCkmLROZxBEYG
-+9OaQtDUm2BtBx4tLGjq6DNXMDfkCHT/Kv8SbmmmDQc7sRHsA1igE/wehqlVV
- """)
- 
- ##file ez_setup.py

=== modified file 'debian/patches/series.in'
--- debian/patches/series.in	2013-01-16 22:26:10 +0000
+++ debian/patches/series.in	2013-02-20 09:17:36 +0000
@@ -13,5 +13,26 @@
 webapprt-support-for-langpacks.patch
 no_neon_on_arm.patch
 python-virtualenv-multiarch-fix.patch
-ionmonkey-hardfp-support.patch
+test-integration/mochitest-optional-websock-log.patch
+test-integration/reftest-output-junit-xml.patch
+test-integration/mochitest-output-junit-xml.patch
+test-integration/mochitest-allow-test-manifest-for-chrome.patch
 fix-broken-langpack-install-manifests.patch
+test-integration/xpcshell-output-valid-junit-xml.patch
+test-fixes/xpcshell-search-fix-browser-dirprovider.patch
+test-fixes/xpcshell-docshell-no-writes-to-appdir.patch
+test-fixes/xpcshell-contentprefs-no-writes-to-appdir.patch
+test-fixes/xpcshell-exthandler-no-writes-to-appdir.patch
+test-fixes/xpcshell-ctypes-no-writes-to-appdir.patch
+test-fixes/xpcshell-xpcom-no-writes-to-testdir-or-appdir.patch
+test-fixes/xpcshell-search-fix-const-redeclaration.patch
+test-fixes/xpcshell-shell-disable-gconf-tests-when-using-gsettings.patch
+test-fixes/xpcshell-libpref-no-writes-to-testdir.patch
+test-fixes/mochitest-content-reset-permissions-when-done.patch
+test-fixes/mochitest-tests-jar-fix.patch
+test-fixes/mochitest-dont-ship-browser-postupdate-test.patch
+test-fixes/mochitest-shell-disable-gconf-tests-when-using-gsettings.patch
+test-integration/xpcshell-disable-addon-select-dialog-test-for-adt.patch
+test-integration/xpcshell-disable-tests-which-need-appdir-write-access.patch
+test-overrides/reftest-disable-failing-tests.patch
+test-overrides/xpcshell-disable-failing-tests.patch

=== added directory 'debian/patches/test-fixes'
=== added file 'debian/patches/test-fixes/mochitest-content-reset-permissions-when-done.patch'
--- debian/patches/test-fixes/mochitest-content-reset-permissions-when-done.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/mochitest-content-reset-permissions-when-done.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,13 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/content/base/test/test_messagemanager_assertpermission.html
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/content/base/test/test_messagemanager_assertpermission.html	2012-11-14 21:07:28.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/content/base/test/test_messagemanager_assertpermission.html	2012-11-20 21:30:39.057447271 +0000
+@@ -172,6 +172,8 @@
+ function tearDown() {
+   SpecialPowers.clearUserPref("dom.mozBrowserFramesEnabled");
+   SpecialPowers.clearUserPref("dom.ipc.browser_frames.oop_by_default");
++  SpecialPowers.removePermission("browser", location.href);
++  SpecialPowers.removePermission("embed-apps", location.href);
+   SimpleTest.finish();
+ }
+ 

=== added file 'debian/patches/test-fixes/mochitest-dont-ship-browser-postupdate-test.patch'
--- debian/patches/test-fixes/mochitest-dont-ship-browser-postupdate-test.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/mochitest-dont-ship-browser-postupdate-test.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,15 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/browser/components/test/Makefile.in
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/browser/components/test/Makefile.in	2012-11-14 21:07:25.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/browser/components/test/Makefile.in	2012-11-21 22:37:47.978528706 +0000
+@@ -10,8 +10,10 @@
+ 
+ include $(DEPTH)/config/autoconf.mk
+ 
++ifdef MOZ_UPDATER
+ MOCHITEST_BROWSER_FILES = \
+   browser_bug538331.js \
+   $(NULL)
++endif
+ 
+ include $(topsrcdir)/config/rules.mk

=== added file 'debian/patches/test-fixes/mochitest-shell-disable-gconf-tests-when-using-gsettings.patch'
--- debian/patches/test-fixes/mochitest-shell-disable-gconf-tests-when-using-gsettings.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/mochitest-shell-disable-gconf-tests-when-using-gsettings.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,20 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/browser/components/shell/test/browser_420786.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/browser/components/shell/test/browser_420786.js	2012-11-14 21:07:25.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/browser/components/shell/test/browser_420786.js	2012-11-21 22:21:26.242493988 +0000
+@@ -77,6 +77,15 @@
+     return;
+   }
+ 
++  try {
++    // If GSettings is available, then the GConf tests
++    // will fail
++    var gsettings = Cc["@mozilla.org/gsettings-service;1"].
++                    getService(Ci.nsIGSettingsService);
++    todo(false, "This test doesn't work when GSettings is available");
++    return;
++  } catch(e) { }
++
+   gBrowser.selectedTab = gBrowser.addTab();
+   gBrowser.selectedBrowser.addEventListener("load", onPageLoad, true);
+   content.location = "about:logo";

=== added file 'debian/patches/test-fixes/mochitest-tests-jar-fix.patch'
--- debian/patches/test-fixes/mochitest-tests-jar-fix.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/mochitest-tests-jar-fix.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,24 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/perf/Makefile.in
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/toolkit/components/perf/Makefile.in	2012-11-14 21:08:31.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/perf/Makefile.in	2012-11-21 16:56:27.513804412 +0000
+@@ -6,6 +6,7 @@
+ topsrcdir = @top_srcdir@
+ srcdir = @srcdir@
+ VPATH = @srcdir@
++relativesrcdir = @relativesrcdir@
+ 
+ include $(DEPTH)/config/autoconf.mk
+ 
+Index: firefox-trunk-19.0~a1~hg20121114r113217/toolkit/forgetaboutsite/test/browser/Makefile.in
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/toolkit/forgetaboutsite/test/browser/Makefile.in	2012-11-14 21:08:34.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/toolkit/forgetaboutsite/test/browser/Makefile.in	2012-11-21 16:54:50.377800978 +0000
+@@ -6,6 +6,7 @@
+ topsrcdir := @top_srcdir@
+ srcdir    := @srcdir@
+ VPATH   := @srcdir@
++relativesrcdir	:= @relativesrcdir@
+ 
+ include $(DEPTH)/config/autoconf.mk
+ 

=== added file 'debian/patches/test-fixes/xpcshell-contentprefs-no-writes-to-appdir.patch'
--- debian/patches/test-fixes/xpcshell-contentprefs-no-writes-to-appdir.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/xpcshell-contentprefs-no-writes-to-appdir.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,121 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/contentprefs/tests/unit/head_contentPrefs.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/toolkit/components/contentprefs/tests/unit/head_contentPrefs.js	2012-11-14 21:08:30.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/contentprefs/tests/unit/head_contentPrefs.js	2012-11-19 21:33:15.781652408 +0000
+@@ -45,34 +45,6 @@
+ 
+ 
+   //**************************************************************************//
+-  // nsISupports
+-  
+-  interfaces: [Ci.nsIDirectoryServiceProvider, Ci.nsISupports],
+-
+-  QueryInterface: function ContentPrefTest_QueryInterface(iid) {
+-    if (!this.interfaces.some( function(v) { return iid.equals(v) } ))
+-      throw Cr.NS_ERROR_NO_INTERFACE;
+-    return this;
+-  },
+-
+-
+-  //**************************************************************************//
+-  // nsIDirectoryServiceProvider
+-
+-  getFile: function ContentPrefTest_getFile(property, persistent) {
+-    persistent.value = true;
+-
+-    if (property == "ProfD")
+-      return this._dirSvc.get("CurProcD", Ci.nsIFile);
+-
+-    // This causes extraneous errors to show up in the log when the directory
+-    // service asks us first for CurProcD and MozBinD.  I wish there was a way
+-    // to suppress those errors.
+-    throw Cr.NS_ERROR_FAILURE;
+-  },
+-
+-
+-  //**************************************************************************//
+   // Utilities
+ 
+   getURI: function ContentPrefTest_getURI(spec) {
+@@ -84,20 +56,7 @@
+    * of that directory if necessary.
+    */
+   getProfileDir: function ContentPrefTest_getProfileDir() {
+-    var profileDir;
+-
+-    try {
+-      profileDir = this._dirSvc.get("ProfD", Ci.nsIFile);
+-    }
+-    catch (e) {}
+-
+-    if (!profileDir) {
+-      this._dirSvc.QueryInterface(Ci.nsIDirectoryService).registerProvider(this);
+-      profileDir = this._dirSvc.get("ProfD", Ci.nsIFile);
+-      this._dirSvc.unregisterProvider(this);
+-    }
+-
+-    return profileDir;
++    return this._dirSvc.get("ProfD", Ci.nsIFile);
+   },
+ 
+   /**
+@@ -136,6 +95,8 @@
+ 
+ };
+ 
++do_get_profile();
++
+ let gInPrivateBrowsing = false;
+ function enterPBMode() {
+   gInPrivateBrowsing = true;
+@@ -145,8 +106,6 @@
+   Services.obs.notifyObservers(null, "last-pb-context-exited", null);
+ }
+ 
+-ContentPrefTest.deleteDatabase();
+-
+ function inChildProcess() {
+   var appInfo = Cc["@mozilla.org/xre/app-info;1"];
+   if (!appInfo || appInfo.getService(Ci.nsIXULRuntime).processType ==
+Index: firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/contentprefs/tests/unit/tail_contentPrefs.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/toolkit/components/contentprefs/tests/unit/tail_contentPrefs.js	2012-11-14 21:08:30.000000000 +0000
++++ /dev/null	1970-01-01 00:00:00.000000000 +0000
+@@ -1,6 +0,0 @@
+-/* This Source Code Form is subject to the terms of the Mozilla Public
+- * License, v. 2.0. If a copy of the MPL was not distributed with this
+- * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
+-
+-ContentPrefTest.deleteDatabase();
+-ContentPrefTest.__dirSvc = null;
+Index: firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/contentprefs/tests/unit/xpcshell.ini
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/toolkit/components/contentprefs/tests/unit/xpcshell.ini	2012-11-14 21:08:30.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/contentprefs/tests/unit/xpcshell.ini	2012-11-19 21:33:15.785652408 +0000
+@@ -1,6 +1,6 @@
+ [DEFAULT]
+ head = head_contentPrefs.js
+-tail = tail_contentPrefs.js
++tail =
+ 
+ [test_bug248970.js]
+ [test_bug503971.js]
+Index: firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/contentprefs/tests/unit_ipc/tail_contentPrefs.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/toolkit/components/contentprefs/tests/unit_ipc/tail_contentPrefs.js	2012-11-14 21:08:30.000000000 +0000
++++ /dev/null	1970-01-01 00:00:00.000000000 +0000
+@@ -1,3 +0,0 @@
+-
+-load("../unit/tail_contentPrefs.js");
+-
+Index: firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/contentprefs/tests/unit_ipc/xpcshell.ini
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/toolkit/components/contentprefs/tests/unit_ipc/xpcshell.ini	2012-11-14 21:08:30.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/contentprefs/tests/unit_ipc/xpcshell.ini	2012-11-19 23:52:10.541504311 +0000
+@@ -1,5 +1,5 @@
+ [DEFAULT]
+ head = head_contentPrefs.js
+-tail = tail_contentPrefs.js
++tail =
+ 
+ [test_contentPrefs_parentipc.js]

=== added file 'debian/patches/test-fixes/xpcshell-ctypes-no-writes-to-appdir.patch'
--- debian/patches/test-fixes/xpcshell-ctypes-no-writes-to-appdir.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/xpcshell-ctypes-no-writes-to-appdir.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,27 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/ctypes/tests/unit/test_jsctypes.js.in
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/toolkit/components/ctypes/tests/unit/test_jsctypes.js.in	2012-11-19 19:09:20.145805853 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/ctypes/tests/unit/test_jsctypes.js.in	2012-11-19 19:17:05.233797589 +0000
+@@ -13,6 +13,8 @@
+ CTYPES_TEST_LIB = ctypes.libraryName("jsctypes-test");
+ CTYPES_UNICODE_LIB = ctypes.libraryName("jsctyp\u00E8s-t\u00EB\u00DFt");
+ 
++var gProfileDir = do_get_profile();
++
+ function do_check_throws(f, type, stack)
+ {
+   if (!stack) {
+@@ -213,10 +215,11 @@
+   // Test loading a library with a unicode name (bug 589413). Note that nsIFile
+   // implementations are not available in some harnesses; if not, the harness
+   // should take care of the copy for us.
+-  let unicodefile = do_get_file(CTYPES_UNICODE_LIB, true);
+   let copy = libfile.copyTo instanceof Function;
+   if (copy)
+-    libfile.copyTo(null, unicodefile.leafName);
++    libfile.copyTo(gProfileDir, CTYPES_UNICODE_LIB);
++  let unicodefile = gProfileDir.clone();
++  unicodefile.append(CTYPES_UNICODE_LIB);
+   library = ctypes.open(unicodefile.path);
+   run_void_tests(library);
+   library.close();

=== added file 'debian/patches/test-fixes/xpcshell-docshell-no-writes-to-appdir.patch'
--- debian/patches/test-fixes/xpcshell-docshell-no-writes-to-appdir.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/xpcshell-docshell-no-writes-to-appdir.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,77 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113129/docshell/test/unit/head_docshell.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113129.orig/docshell/test/unit/head_docshell.js	2012-11-14 00:37:36.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113129/docshell/test/unit/head_docshell.js	2012-11-14 14:59:33.306495000 +0000
+@@ -6,52 +6,5 @@
+ const Ci = Components.interfaces;
+ const Cr = Components.results;
+ 
+-var dirSvc = Cc["@mozilla.org/file/directory_service;1"].
+-             getService(Ci.nsIProperties);
+-var profileDir = dirSvc.get("CurProcD", Ci.nsILocalFile);
+-profileDir.append("test_docshell_profile");
+-
+-// Register our own provider for the profile directory.
+-// It will return our special docshell profile directory.
+-var provider = {
+-  getFile: function(prop, persistent) {
+-    persistent.value = true;
+-    if (prop == "ProfD") {
+-      var retVal = dirSvc.get("CurProcD", Ci.nsILocalFile);
+-      retVal.append("test_docshell_profile");
+-      if (!retVal.exists())
+-        retVal.create(Ci.nsIFile.DIRECTORY_TYPE, 0755);
+-      return retVal;
+-    }
+-    throw Cr.NS_ERROR_FAILURE;
+-  },
+-  QueryInterface: function(iid) {
+-    if (iid.equals(Ci.nsIDirectoryServiceProvider) ||
+-        iid.equals(Ci.nsISupports)) {
+-      return this;
+-    }
+-    throw Cr.NS_ERROR_NO_INTERFACE;
+-  }
+-};
+-dirSvc.QueryInterface(Ci.nsIDirectoryService).registerProvider(provider);
+-
+-function cleanup()
+-{
+-  // we need to remove the folder that we created for the profile
+-  try {
+-    if (profileDir.exists())
+-      profileDir.remove(true);
+-  } catch (e) {
+-    // windows has a slight problem with sqlite databases and trying to remove
+-    // them to quickly after you might expect to be done with them.  Eat any
+-    // errors we'll get.  This should be OK because we cleanup before and after
+-    // each test run.
+-  }
+-}
+-
+-
+-// cleanup from any failed test runs in the past
+-cleanup();
+-
+-// make sure we have our profile directory available to us
+-profileDir.create(Ci.nsIFile.DIRECTORY_TYPE, 0755);
++// Needed to properly setup and shutdown the profile.
++do_get_profile();
+Index: firefox-trunk-19.0~a1~hg20121114r113129/docshell/test/unit/test_nsIDownloadHistory.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113129.orig/docshell/test/unit/test_nsIDownloadHistory.js	2012-11-14 00:37:36.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113129/docshell/test/unit/test_nsIDownloadHistory.js	2012-11-14 14:59:26.738495000 +0000
+@@ -58,13 +58,8 @@
+     return;
+   }
+ 
+-  // Needed to properly setup and shutdown the profile.
+-  do_get_profile();
+-
+   Services.prefs.setBoolPref("places.history.enabled", true);
+ 
+   for (var i = 0; i < tests.length; i++)
+     tests[i]();
+-
+-  cleanup();
+ }

=== added file 'debian/patches/test-fixes/xpcshell-exthandler-no-writes-to-appdir.patch'
--- debian/patches/test-fixes/xpcshell-exthandler-no-writes-to-appdir.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/xpcshell-exthandler-no-writes-to-appdir.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,93 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/uriloader/exthandler/tests/unit/head_handlerService.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/uriloader/exthandler/tests/unit/head_handlerService.js	2012-11-14 21:08:42.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/uriloader/exthandler/tests/unit/head_handlerService.js	2012-11-16 15:33:08.455818000 +0000
+@@ -47,6 +47,9 @@
+   // Initialization & Destruction
+   
+   init: function HandlerServiceTest_init() {
++    // Get a temporary profile
++    do_get_profile();
++
+     // Register ourselves as a directory provider for the datasource file
+     // if there isn't one registered already.
+     try {
+@@ -56,11 +59,6 @@
+       this._providerRegistered = true;
+     }
+ 
+-    // Delete the existing datasource file, if any, so we start from scratch.
+-    // We also do this after finishing the tests, so there shouldn't be an old
+-    // file lying around, but just in case we delete it here as well.
+-    this._deleteDatasourceFile();
+-
+     // Turn on logging so we can troubleshoot problems with the tests.
+     var prefBranch = Cc["@mozilla.org/preferences-service;1"].
+                      getService(Ci.nsIPrefBranch);
+@@ -68,9 +66,6 @@
+   },
+ 
+   destroy: function HandlerServiceTest_destroy() {
+-    // Delete the existing datasource file, if any, so we don't leave test files
+-    // lying around and we start from scratch the next time.
+-    this._deleteDatasourceFile();
+     // Unregister the directory service provider
+     if (this._providerRegistered)
+       this._dirSvc.unregisterProvider(this);
+@@ -86,7 +81,7 @@
+     persistent.value = true;
+ 
+     if (property == "UMimTyp") {
+-      var datasourceFile = this._dirSvc.get("CurProcD", Ci.nsIFile);
++      var datasourceFile = this._dirSvc.get("ProfD", Ci.nsIFile);
+       datasourceFile.append("mimeTypes.rdf");
+       return datasourceFile;
+     }
+@@ -105,15 +100,6 @@
+   // Utilities
+ 
+   /**
+-   * Delete the datasource file.
+-   */
+-  _deleteDatasourceFile: function HandlerServiceTest__deleteDatasourceFile() {
+-    var file = this._dirSvc.get("UMimTyp", Ci.nsIFile);
+-    if (file.exists())
+-      file.remove(false);
+-  },
+-
+-  /**
+    * Get the contents of the datasource as a serialized string.  Useful for
+    * debugging problems with test failures, i.e.:
+    *
+Index: firefox-trunk-19.0~a1~hg20121114r113217/uriloader/exthandler/tests/unit/test_punycodeURIs.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/uriloader/exthandler/tests/unit/test_punycodeURIs.js	2012-11-14 21:08:42.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/uriloader/exthandler/tests/unit/test_punycodeURIs.js	2012-11-16 15:33:22.803818000 +0000
+@@ -13,7 +13,7 @@
+ 
+ function checkFile() {
+   // This is where we expect the output
+-  var tempFile = do_get_cwd();
++  var tempFile = HandlerServiceTest._dirSvc.get("ProfD", Ci.nsIFile);
+   tempFile.append(kOutputFile);
+ 
+   if (!tempFile.exists()) {
+@@ -46,9 +46,6 @@
+   sstream.close();
+   fstream.close();
+ 
+-  // Now remove the old file
+-  tempFile.remove(false);
+-
+   // This currently fails on Mac with an argument like -psn_0_nnnnnn
+   // This seems to be to do with how the executable is called, but I couldn't
+   // find a way around it.
+@@ -90,7 +87,7 @@
+       do_throw("Could not locate the WriteArgument tests executable\n");
+   }
+ 
+-  var outFile = processDir.clone();
++  var outFile = HandlerServiceTest._dirSvc.get("ProfD", Ci.nsIFile);
+   outFile.append(kOutputFile);
+ 
+   // Set an environment variable for WriteArgument to pick up

=== added file 'debian/patches/test-fixes/xpcshell-libpref-no-writes-to-testdir.patch'
--- debian/patches/test-fixes/xpcshell-libpref-no-writes-to-testdir.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/xpcshell-libpref-no-writes-to-testdir.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,67 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/modules/libpref/test/unit/head_libPrefs.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/modules/libpref/test/unit/head_libPrefs.js	2012-11-14 21:08:21.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/modules/libpref/test/unit/head_libPrefs.js	2012-11-19 23:48:51.149507855 +0000
+@@ -23,22 +23,4 @@
+   do_throw("expected result " + result + ", none thrown", stack);
+ }
+ 
+-var dirSvc = Cc["@mozilla.org/file/directory_service;1"].getService(Ci.nsIProperties);
+-
+-// Register current test directory as provider for the profile directory.
+-var provider = {
+-  getFile: function(prop, persistent) {
+-    persistent.value = true;
+-    if (prop == NS_APP_USER_PROFILE_50_DIR)
+-      return dirSvc.get("CurProcD", Ci.nsIFile);
+-    throw Cr.NS_ERROR_FAILURE;
+-  },
+-  QueryInterface: function(iid) {
+-    if (iid.equals(Ci.nsIDirectoryServiceProvider) ||
+-        iid.equals(Ci.nsISupports)) {
+-      return this;
+-    }
+-    throw Cr.NS_ERROR_NO_INTERFACE;
+-  }
+-};
+-dirSvc.QueryInterface(Ci.nsIDirectoryService).registerProvider(provider);
++var gProfileDir = do_get_profile();
+Index: firefox-trunk-19.0~a1~hg20121114r113217/modules/libpref/test/unit/test_extprefs.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/modules/libpref/test/unit/test_extprefs.js	2012-11-14 21:08:21.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/modules/libpref/test/unit/test_extprefs.js	2012-11-19 23:49:02.009507661 +0000
+@@ -56,7 +56,7 @@
+   ps.setBoolPref("testPref.bool1", false);
+   do_check_false(ps.getBoolPref("testPref.bool1"));
+   
+-  dirSvc.registerProvider(extProvider);
++  Services.dirsvc.registerProvider(extProvider);
+   Services.obs.notifyObservers(null, "load-extension-defaults", null);
+ 
+   // The extension default should be available.
+Index: firefox-trunk-19.0~a1~hg20121114r113217/modules/libpref/test/unit/test_libPrefs.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/modules/libpref/test/unit/test_libPrefs.js	2012-11-14 21:08:21.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/modules/libpref/test/unit/test_libPrefs.js	2012-11-19 23:48:56.865507750 +0000
+@@ -295,11 +295,8 @@
+   ps.setCharPref("ReadPref.char", "hello");
+ 
+   // save those prefs in a file
+-  let savePrefFile = do_get_cwd();
+-  savePrefFile.append("data");
++  let savePrefFile = gProfileDir.clone();
+   savePrefFile.append("savePref.js");
+-  if (savePrefFile.exists())
+-    savePrefFile.remove(false);
+   savePrefFile.create(Ci.nsIFile.NORMAL_FILE_TYPE, 0666);
+   ps.savePrefFile(savePrefFile);
+   ps.resetPrefs();
+@@ -327,8 +324,6 @@
+ 
+   // loading our former savePrefFile should allow us to read former prefs
+   ps.readUserPrefs(savePrefFile);
+-  // cleanup the file now we don't need it
+-  savePrefFile.remove(false);
+   do_check_eq(ps.getBoolPref("ReadPref.bool"), true);
+   do_check_eq(ps.getIntPref("ReadPref.int"), 230);
+   do_check_eq(ps.getCharPref("ReadPref.char"), "hello");

=== added file 'debian/patches/test-fixes/xpcshell-search-fix-browser-dirprovider.patch'
--- debian/patches/test-fixes/xpcshell-search-fix-browser-dirprovider.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/xpcshell-search-fix-browser-dirprovider.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,105 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113129/toolkit/components/search/tests/xpcshell/head_search.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113129.orig/toolkit/components/search/tests/xpcshell/head_search.js	2012-11-14 00:37:53.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113129/toolkit/components/search/tests/xpcshell/head_search.js	2012-11-14 14:08:13.854550000 +0000
+@@ -1,9 +1,13 @@
+ /* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*- */
+ /* vim:set ts=2 sw=2 sts=2 et: */
+ 
+-Components.utils.import("resource://gre/modules/Services.jsm");
+-Components.utils.import("resource://gre/modules/NetUtil.jsm");
+-Components.utils.import("resource://gre/modules/XPCOMUtils.jsm");
++const Cu = Components.utils;
++const Ci = Components.interfaces;
++const Cr = Components.results;
++
++Cu.import("resource://gre/modules/Services.jsm");
++Cu.import("resource://gre/modules/NetUtil.jsm");
++Cu.import("resource://gre/modules/XPCOMUtils.jsm");
+ 
+ const XULAPPINFO_CONTRACTID = "@mozilla.org/xre/app-info;1";
+ const XULAPPINFO_CID = Components.ID("{c763b610-9d49-455a-bbd2-ede71682a1ac}");
+@@ -38,23 +42,23 @@
+     invalidateCachesOnRestart: function invalidateCachesOnRestart() {},
+ 
+     QueryInterface: function QueryInterface(iid) {
+-      if (iid.equals(Components.interfaces.nsIXULAppInfo)
+-       || iid.equals(Components.interfaces.nsIXULRuntime)
+-       || iid.equals(Components.interfaces.nsISupports))
++      if (iid.equals(Ci.nsIXULAppInfo)
++       || iid.equals(Ci.nsIXULRuntime)
++       || iid.equals(Ci.nsISupports))
+         return this;
+ 
+-      throw Components.results.NS_ERROR_NO_INTERFACE;
++      throw Cr.NS_ERROR_NO_INTERFACE;
+     }
+   };
+ 
+   var XULAppInfoFactory = {
+     createInstance: function (outer, iid) {
+       if (outer != null)
+-        throw Components.results.NS_ERROR_NO_AGGREGATION;
++        throw Cr.NS_ERROR_NO_AGGREGATION;
+       return gXULAppInfo.QueryInterface(iid);
+     }
+   };
+-  var registrar = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
++  var registrar = Components.manager.QueryInterface(Ci.nsIComponentRegistrar);
+   registrar.registerFactory(XULAPPINFO_CID, "XULAppInfo",
+                             XULAPPINFO_CONTRACTID, XULAppInfoFactory);
+ }
+@@ -62,6 +66,44 @@
+ // Need to create and register a profile folder.
+ var gProfD = do_get_profile();
+ 
++var provider = {
++  getFile: function() {
++    throw Cr.NS_ERROR_FAILURE;
++  },
++
++  getFiles: function(prop) {
++    if (prop == "XREExtDL") {
++      return {
++        getNext: function() {
++          throw Cr.NS_ERROR_FAILURE;
++        },
++        hasMoreElements: function() {
++          return false;
++        },
++        QueryInterface: function(iid) {
++          if (iid.equals(Ci.nsISimpleEnumerator) ||
++              iid.equals(Ci.nsISupports)) {
++            return this;
++          }
++          throw Cr.NS_ERROR_NO_INTERFACE;
++        }
++      };
++    }
++    throw Cr.NS_ERROR_FAILURE;
++  },
++
++  QueryInterface: function(iid) {
++    if (iid.equals(Ci.nsIDirectoryServiceProvider2) ||
++        iid.equals(Ci.nsIDirectoryServiceProvider) ||
++        iid.equals(Ci.nsISupports)) {
++      return this;
++    }
++    throw Cr.NS_ERROR_NO_INTERFACE;
++  }
++};
++
++Services.dirsvc.registerProvider(provider);
++
+ function dumpn(text)
+ {
+   dump("search test: " + text + "\n");
+@@ -102,7 +144,7 @@
+ }
+ 
+ function  parseJsonFromStream(aInputStream) {
+-  const json = Cc["@mozilla.org/dom/json;1"].createInstance(Components.interfaces.nsIJSON);
++  const json = Cc["@mozilla.org/dom/json;1"].createInstance(Ci.nsIJSON);
+   const data = json.decodeFromStream(aInputStream, aInputStream.available());
+   return data;
+ }

=== added file 'debian/patches/test-fixes/xpcshell-search-fix-const-redeclaration.patch'
--- debian/patches/test-fixes/xpcshell-search-fix-const-redeclaration.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/xpcshell-search-fix-const-redeclaration.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,14 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/search/tests/xpcshell/test_nodb_pluschanges.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/toolkit/components/search/tests/xpcshell/test_nodb_pluschanges.js	2012-11-14 21:08:32.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/toolkit/components/search/tests/xpcshell/test_nodb_pluschanges.js	2012-11-19 20:40:48.733708328 +0000
+@@ -20,9 +20,6 @@
+  */
+ 
+ const Cc = Components.classes;
+-const Ci = Components.interfaces;
+-const Cu = Components.utils;
+-const Cr = Components.results;
+ 
+ Cu.import("resource://testing-common/httpd.js");
+ 

=== added file 'debian/patches/test-fixes/xpcshell-shell-disable-gconf-tests-when-using-gsettings.patch'
--- debian/patches/test-fixes/xpcshell-shell-disable-gconf-tests-when-using-gsettings.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/xpcshell-shell-disable-gconf-tests-when-using-gsettings.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,19 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/browser/components/shell/test/unit/test_421977.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/browser/components/shell/test/unit/test_421977.js	2012-11-14 21:07:25.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/browser/components/shell/test/unit/test_421977.js	2012-11-19 20:36:33.069712870 +0000
+@@ -67,6 +67,14 @@
+   if (!("@mozilla.org/gnome-gconf-service;1" in Cc))
+     return;
+ 
++  try {
++    // If GSettings is available, then the GConf tests
++    // will fail
++    var gsettings = Cc["@mozilla.org/gsettings-service;1"].
++                    getService(Ci.nsIGSettingsService);
++    return;
++  } catch(e) { }
++
+   gGConf = Cc["@mozilla.org/gnome-gconf-service;1"].
+            getService(Ci.nsIGConfService);
+ 

=== added file 'debian/patches/test-fixes/xpcshell-xpcom-no-writes-to-testdir-or-appdir.patch'
--- debian/patches/test-fixes/xpcshell-xpcom-no-writes-to-testdir-or-appdir.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-fixes/xpcshell-xpcom-no-writes-to-testdir-or-appdir.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,173 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/test_bug476919.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/xpcom/tests/unit/test_bug476919.js	2012-11-14 21:08:45.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/test_bug476919.js	2012-11-17 01:53:49.599156760 +0000
+@@ -5,17 +5,14 @@
+   // skip this test on Windows
+   var isWindows = ("@mozilla.org/windows-registry-key;1" in Components.classes);
+   if (!isWindows) {
+-    var testDir = __LOCATION__.parent;
++    var testDir = do_get_profile();
+     // create a test file, then symlink it, then check that we think it's a symlink
+     var targetFile = testDir.clone();
+     targetFile.append("target.txt");
+-    if (!targetFile.exists())
+-      targetFile.create(Ci.nsIFile.NORMAL_FILE_TYPE, 0644);
++    targetFile.create(Ci.nsIFile.NORMAL_FILE_TYPE, 0644);
+ 
+     var link = testDir.clone();
+     link.append("link");
+-    if (link.exists())
+-      link.remove(false);
+ 
+     var ln = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsILocalFile);
+     ln.initWithPath("/bin/ln");
+Index: firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/test_iniProcessor.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/xpcom/tests/unit/test_iniProcessor.js	2012-11-14 21:08:45.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/test_iniProcessor.js	2012-11-19 15:09:32.934061498 +0000
+@@ -171,6 +171,9 @@
+           getService(Ci.nsIINIParserFactory);
+ do_check_true(!!factory);
+ 
++var outputDir = do_get_profile();
++outputDir.append("test_iniProcessor_data");
++
+ // Test reading from a variety of files. While we're at it, write out each one
+ // and read it back to ensure that nothing changed.
+ while (testnum < testdata.length) {
+@@ -183,24 +186,23 @@
+         continue;
+     do_check_true(parser instanceof Ci.nsIINIParserWriter);
+     // write contents out to a new file
+-    let newfilename = filename + ".new";
+-    let newfile = do_get_file(filename);
+-    newfile.leafName += ".new";
++    let newfile = outputDir.clone();
++    newfile.appendRelativePath(filename);
++    if (!newfile.parent.exists()) {
++        newfile.parent.create(Ci.nsIFile.DIRECTORY_TYPE, 0755);
++    }
+     parser.writeFile(newfile);
+     // read new file and make sure the contents are the same.
+-    parser = parserForFile(newfilename);
++    parser = factory.createINIParser(newfile);
++    do_check_true(!!parser);
+     checkParserOutput(parser, testdata[testnum - 1].reference);
+-    // cleanup after the test
+-    newfile.remove(false);
+ }
+ 
+ dump("INFO | test #" + ++testnum + "\n");
+ 
+ // test writing to a new file.
+-let newfile = do_get_file("data/");
++let newfile = outputDir.clone();
+ newfile.append("nonexistent-file.ini");
+-if (newfile.exists())
+-    newfile.remove(false);
+ do_check_false(newfile.exists());
+ 
+ let parser = factory.createINIParser(newfile);
+@@ -216,10 +218,8 @@
+ do_check_true(newfile.exists());
+ checkParserOutput(parser, {section: {key: "value"} });
+ // read it in again, check for same data.
+-parser = parserForFile("data/nonexistent-file.ini");
++parser = factory.createINIParser(newfile);
+ checkParserOutput(parser, {section: {key: "value"} });
+-// cleanup after the test
+-newfile.remove(false);
+ 
+ dump("INFO | test #" + ++testnum + "\n");
+ 
+Index: firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/test_nsIProcess.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/xpcom/tests/unit/test_nsIProcess.js	2012-11-14 21:08:45.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/test_nsIProcess.js	2012-11-19 19:07:55.765807352 +0000
+@@ -10,6 +10,8 @@
+                            "\u09AE\u09CB\u099C\u09BF\u09B2\u09BE",
+                            "\uD808\uDE2C\uD808\uDF63\uD808\uDDB7"];
+ 
++gProfileDir = do_get_profile();
++
+ // test if a process can be started, polled for its running status
+ // and then killed
+ function test_kill()
+@@ -86,33 +88,31 @@
+   test_args(get_test_program("TestUnicodeArguments"), TEST_UNICODE_ARGS, false);
+ }
+ 
+-function rename_and_test(asciiName, unicodeName, args, argsAreASCII)
++function copy_and_test(asciiName, unicodeName, args, argsAreASCII)
+ {
+   var asciiFile = get_test_program(asciiName);
+   var asciiLeaf = asciiFile.leafName;
+   var unicodeLeaf = asciiLeaf.replace(asciiName, unicodeName);
+ 
+-  asciiFile.moveTo(null, unicodeLeaf);
++  asciiFile.copyTo(gProfileDir, unicodeLeaf);
+ 
+-  var unicodeFile = get_test_program(unicodeName);
++  var unicodeFile = get_test_program(unicodeName, gProfileDir);
+ 
+   test_args(unicodeFile, args, argsAreASCII);
+-
+-  unicodeFile.moveTo(null, asciiLeaf);
+ }
+ 
+ // test passing ASCII and Unicode arguments to an application with a Unicode name
+ function test_unicode_app()
+ {
+-  rename_and_test("TestArguments",
+-                  // "Unicode" in Tamil
+-                  "\u0BAF\u0BC1\u0BA9\u0BBF\u0B95\u0BCB\u0B9F\u0BCD",
+-                  TEST_ARGS, true);
+-
+-  rename_and_test("TestUnicodeArguments",
+-                  // "Unicode" in Thai
+-                  "\u0E22\u0E39\u0E19\u0E34\u0E42\u0E04\u0E14",
+-                  TEST_UNICODE_ARGS, false);
++  copy_and_test("TestArguments",
++                // "Unicode" in Tamil
++                "\u0BAF\u0BC1\u0BA9\u0BBF\u0B95\u0BCB\u0B9F\u0BCD",
++                TEST_ARGS, true);
++
++  copy_and_test("TestUnicodeArguments",
++                // "Unicode" in Thai
++                "\u0E22\u0E39\u0E19\u0E34\u0E42\u0E04\u0E14",
++                TEST_UNICODE_ARGS, false);
+ }
+ 
+ // test if we get notified about a blocking process
+Index: firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/test_symlinks.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/xpcom/tests/unit/test_symlinks.js	2012-11-14 21:08:45.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/test_symlinks.js	2012-11-19 16:07:43.461999474 +0000
+@@ -144,7 +144,7 @@
+   if (isWin || isOS2)
+     return;
+ 
+-  var testDir = CWD;
++  var testDir = do_get_profile();
+   testDir.append("test_symlinks");
+ 
+   testSymLinks(testDir, false);
+Index: firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/head_xpcom.js
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/xpcom/tests/unit/head_xpcom.js	2012-11-14 21:08:45.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/xpcom/tests/unit/head_xpcom.js	2012-11-19 19:07:21.373807965 +0000
+@@ -1,8 +1,11 @@
+ var isWindows = ("@mozilla.org/windows-registry-key;1" in Components.classes);
+ 
+-function get_test_program(prog)
++function get_test_program(prog, dir)
+ {
+-  var progPath = do_get_cwd();
++  if (!dir)
++    var progPath = do_get_cwd();
++  else
++    var progPath = dir.clone();
+   progPath.append(prog);
+   if (isWindows)
+     progPath.leafName = progPath.leafName + ".exe";

=== added directory 'debian/patches/test-integration'
=== added file 'debian/patches/test-integration/mochitest-allow-test-manifest-for-chrome.patch'
--- debian/patches/test-integration/mochitest-allow-test-manifest-for-chrome.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-integration/mochitest-allow-test-manifest-for-chrome.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,84 @@
+Index: firefox-20.0~a2~hg20130206r123896/testing/mochitest/browser-harness.xul
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/testing/mochitest/browser-harness.xul	2013-02-06 13:57:19.750072042 +0000
++++ firefox-20.0~a2~hg20130206r123896/testing/mochitest/browser-harness.xul	2013-02-06 13:59:07.530070127 +0000
+@@ -11,6 +11,9 @@
+         width="1024">
+   <script src="chrome://mochikit/content/tests/SimpleTest/MozillaLogger.js"/>
+   <script src="chrome://mochikit/content/tests/SimpleTest/LogController.js"/>
++  <!-- We need this to make setup.js happy. Perhaps filterTests() should also exist in chrome-harness.js? -->
++  <script src="chrome://mochikit/content/tests/SimpleTest/TestRunner.js"/>
++  <script src="chrome://mochikit/content/tests/SimpleTest/setup.js"/>
+   <script src="chrome://mochikit/content/chrome-harness.js"/>
+   <style xmlns="http://www.w3.org/1999/xhtml"><![CDATA[
+     #results {
+@@ -186,10 +189,11 @@
+       scriptLoader.loadSubScript('chrome://mochikit/content/server.js',
+                                  srvScope);
+ 
+-      var fileNames = [];
+       var fileNameRegexp = /browser_.+\.js$/;
+-      srvScope.arrayOfTestFiles(links, fileNames, fileNameRegexp);
+-      return fileNames.map(function (f) new browserTest(f));
++      srvScope.arrayOfTestFiles(links, gTestList, fileNameRegexp);
++      gTestBase = "chrome://mochitests/content";
++      gTestList = filterTests(gConfig.testManifest, gConfig.runOnly);
++      return gTestList.map(function (f) new browserTest(f));
+     }
+ 
+     function setStatus(aStatusString) {
+Index: firefox-20.0~a2~hg20130206r123896/testing/mochitest/tests/SimpleTest/setup.js
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/testing/mochitest/tests/SimpleTest/setup.js	2013-02-06 13:57:19.750072042 +0000
++++ firefox-20.0~a2~hg20130206r123896/testing/mochitest/tests/SimpleTest/setup.js	2013-02-06 13:57:19.746072042 +0000
+@@ -248,10 +248,10 @@
+       for (var f in runtests) {
+         // Remove leading /tests/ if exists
+         file = f.replace(/^\//, '')
+-        file = file.replace(/^tests\//, '')
++        file = file.replace(RegExp("^" + gTestBase + "/"), '')
+ 
+         // Match directory or filename, gTestList has tests/<path>
+-        if (tmp_path.match("^tests/" + file) != null) {
++        if (tmp_path.match("^" + gTestBase + "/" + file) != null) {
+           filteredTests.push(test_path);
+           break;
+         }
+@@ -273,10 +273,10 @@
+       for (var f in excludetests) {
+         // Remove leading /tests/ if exists
+         file = f.replace(/^\//, '')
+-        file = file.replace(/^tests\//, '')
++        file = file.replace(RegExp("^" + gTestBase + "/"), '');
+ 
+         // Match directory or filename, gTestList has tests/<path>
+-        if (tmp_path.match("^tests/" + file) != null) {
++        if (tmp_path.match("^" + gTestBase + "/" + file) != null) {
+           found = true;
+           break;
+         }
+Index: firefox-20.0~a2~hg20130206r123896/testing/mochitest/harness-overlay.xul
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/testing/mochitest/harness-overlay.xul	2013-02-06 13:57:19.750072042 +0000
++++ firefox-20.0~a2~hg20130206r123896/testing/mochitest/harness-overlay.xul	2013-02-06 13:57:19.746072042 +0000
+@@ -52,6 +52,7 @@
+     document.getElementById("test-table").innerHTML += tableContent;
+   }
+   gTestList = eval(srvScope.jsonArrayOfTestFiles(links));
++  gTestBase = "chrome://mochitests/content";
+   populate();
+ 
+   hookup();
+Index: firefox-20.0~a2~hg20130206r123896/testing/mochitest/server.js
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/testing/mochitest/server.js	2013-02-06 14:02:18.658066731 +0000
++++ firefox-20.0~a2~hg20130206r123896/testing/mochitest/server.js	2013-02-06 14:02:28.526066556 +0000
+@@ -601,7 +601,7 @@
+         SCRIPT({type: "text/javascript",
+                  src: "/tests/SimpleTest/setup.js"}),
+         SCRIPT({type: "text/javascript"},
+-               "window.onload =  hookup; gTestList=" + tests + ";"
++               "window.onload =  hookup; gTestList=" + tests + "; gTestBase=\"tests\";"
+         )
+       ),
+       BODY(

=== added file 'debian/patches/test-integration/mochitest-optional-websock-log.patch'
--- debian/patches/test-integration/mochitest-optional-websock-log.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-integration/mochitest-optional-websock-log.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,44 @@
+Index: firefox-trunk-19.0~a1~hg20121114r113217/testing/mochitest/runtests.py
+===================================================================
+--- firefox-trunk-19.0~a1~hg20121114r113217.orig/testing/mochitest/runtests.py	2012-11-14 21:08:29.000000000 +0000
++++ firefox-trunk-19.0~a1~hg20121114r113217/testing/mochitest/runtests.py	2012-11-15 18:45:40.212997000 +0000
+@@ -70,6 +70,12 @@
+                     help = "file to which logging occurs")
+     defaults["logFile"] = ""
+ 
++    self.add_option("--websock-log-file",
++                    action = "store", type = "string",
++                    dest = "websockLogFile", metavar = "FILE",
++                    help = "file to which pywebsocket logs to")
++    defaults["websockLogFile"] = ""
++
+     self.add_option("--autorun",
+                     action = "store_true", dest = "autorun",
+                     help = "start running tests when the application starts")
+@@ -434,10 +440,11 @@
+ class WebSocketServer(object):
+   "Class which encapsulates the mod_pywebsocket server"
+ 
+-  def __init__(self, automation, options, scriptdir, debuggerInfo=None):
++  def __init__(self, automation, options, scriptdir, logfile, debuggerInfo=None):
+     self.port = options.webSocketPort
+     self._automation = automation
+     self._scriptdir = scriptdir
++    self._logfile = logfile
+     self.debuggerInfo = debuggerInfo
+ 
+   def start(self):
+@@ -455,9 +462,10 @@
+     cmd = [sys.executable, script]
+     if self.debuggerInfo and self.debuggerInfo['interactive']:
+         cmd += ['--interactive']
+-    cmd += ['-p', str(self.port), '-w', self._scriptdir, '-l',      \
+-           os.path.join(self._scriptdir, "websock.log"),            \
+-           '--log-level=debug', '--allow-handlers-outside-root-dir']
++    cmd += ['-p', str(self.port), '-w', self._scriptdir,       \
++            '--log-level=debug', '--allow-handlers-outside-root-dir']
++    if self._logfile:
++      cmd += ['-l', self._logfile]
+ 
+     self._process = self._automation.Process(cmd)
+     pid = self._process.pid

=== added file 'debian/patches/test-integration/mochitest-output-junit-xml.patch'
--- debian/patches/test-integration/mochitest-output-junit-xml.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-integration/mochitest-output-junit-xml.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,494 @@
+# HG changeset patch
+# Parent 7ffcb24dae1c27dd8b812d7527df802812b70765
+# User Chris Coulson <chris.coulson@canonical.com>
+
+Index: firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/browser-harness.xul
+===================================================================
+--- firefox-trunk-21.0~a1~hg20130205r120792.orig/testing/mochitest/browser-harness.xul	2013-02-06 03:57:53.514199378 -0800
++++ firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/browser-harness.xul	2013-02-06 03:59:34.000000000 -0800
+@@ -113,29 +113,40 @@
+     function browserTest(aTestFile) {
+       this.path = aTestFile;
+       this.dumper = gDumper;
+-      this.results = [];
+       this.scope = null;
+-      this.duration = 0;
++      this.iterations = [];
++      this.currentIteration = null;
+     }
+     browserTest.prototype = {
+       get passCount() {
+-        return this.results.filter(function (t) !t.info && !t.todo && t.pass).length;
++        return this.iterations.reduce(function(p, c, i, a) p + c.results.filter(function(t) !t.info && !t.todo && t.pass).length, 0);
+       },
+       get todoCount() {
+-        return this.results.filter(function (t) !t.info && t.todo && t.pass).length;
++        return this.iterations.reduce(function(p, c, i, a) p + c.results.filter(function(t) !t.info && t.todo && t.pass).length, 0);
+       },
+       get failCount() {
+-        return this.results.filter(function (t) !t.info && !t.pass).length;
++        return this.iterations.reduce(function(p, c, i, a) p + c.results.filter(function(t) !t.info && !t.pass).length, 0);
++      },
++      get testCount() {
++        return this.iterations.reduce(function(p, c, i, a) p + c.results.filter(function(t) !t.info).length, 0);
++      },
++      get iterationCount() {
++        return this.iterations.length;
+       },
+ 
+       addResult: function addResult(result) {
+-        this.results.push(result);
++        this.currentIteration.results.push(result);
+ 
+         this.dumper.dump(result.result + " | " + this.path + " | " + result.msg + "\n");
+       },
+ 
++      startNextIteration: function startNextIteration() {
++        this.currentIteration = {duration: 0, results: []};
++        this.iterations.push(this.currentIteration);
++      },
++
+       setDuration: function setDuration(duration) {
+-        this.duration = duration;
++        this.currentIteration.duration = duration;
+       },
+ 
+       get htmlLog() {
+@@ -145,7 +156,7 @@
+           return txtToHTML.scanTXT(str, Ci.mozITXTToHTMLConv.kEntities);
+         }
+         var path = _entityEncode(this.path);
+-        var html = this.results.map(function (t) {
++        var html = this.iterations.reduce(function(p, c, i, a) p + "\n" + c.results.map(function(t) {
+           var classname = t.info ? "info" : "result " + (t.pass ? "passed" : "failed");
+           var text = t.result + " | " + path + " | " + _entityEncode(t.msg);
+           if (!t.info && !t.pass) {
+@@ -153,7 +164,7 @@
+                    text + " <a href=\"javascript:scrollTo('ERROR" + gErrorCount + "')\">NEXT ERROR</a></p>";
+           }
+           return '<p class="' + classname + '">' + text + "</p>";
+-        }).join("\n");
++        }).join("\n"), "");
+         if (this.duration) {
+           html += "<p class=\"info\">TEST-END | " + path + " | finished in " +
+                   this.duration + " ms</p>";
+@@ -232,6 +243,62 @@
+     }
+ 
+     function testsFinished(aTests) {
++      if (gConfig.xunitFile) {
++        var doc = document.implementation.createDocument(null, null, null);
++        var root = doc.createElement("testsuite");
++        doc.appendChild(root);
++        root.setAttribute("name", gConfig.xunitName ? gConfig.xunitName : "mochitest.browser");
++        root.setAttribute("tests", aTests.reduce(function(p, c, i, a) p + c.testCount, 0));
++        root.setAttribute("failures", aTests.reduce(function(p, c, i, a) p + c.failCount, 0));
++
++        var iter = 0;
++        var suffix = "";
++        if (gConfig.repeat > 0) {
++          suffix = "." + iter;
++        }
++
++        var tests = [];
++        do {
++          tests = aTests.filter(function(t) iter < t.iterationCount);
++          tests.forEach(function(t) {
++            var testcase = doc.createElement("testcase");
++            root.appendChild(testcase);
++
++            var relPath = t.path.substr("chrome://mochitests/content".length);
++            testcase.setAttribute("name", relPath.substr(relPath.lastIndexOf("/") + 1) + suffix);
++            testcase.setAttribute("classname", relPath.substr(0, relPath.lastIndexOf("/")).replace(/\//g, ".").replace(/^\./, ""));
++            testcase.setAttribute("time", t.iterations[iter].duration / 1000);
++
++            var msgs = [];
++            t.iterations[iter].results.forEach(function(res) {
++              if (res.info) {
++                msgs.push(res.result + " | " + t.path + " | " + res.msg);
++              } else if (!res.pass) {
++                var failure = doc.createElement("failure");
++                testcase.appendChild(failure);
++
++                failure.setAttribute("type", res.result);
++                failure.setAttribute("message", res.result + " | " + t.path + " | " + res.msg);
++                var cdata = doc.createCDATASection(msgs.join("\n"));
++                failure.appendChild(cdata);
++                msgs = [];
++              }
++            });
++          });
++
++          iter++;
++        } while (tests.length > 0);
++
++        var file = Cc["@mozilla.org/file/local;1"].createInstance(Ci.nsIFile);
++        file.initWithPath(gConfig.xunitFile);
++        var strm = Cc["@mozilla.org/network/file-output-stream;1"]
++                   .createInstance(Ci.nsIFileOutputStream);
++        // WRONLY | CREATE | TRUNCATE
++        strm.init(file, 42, 0644, strm.DEFER_OPEN);
++        var xmls = new XMLSerializer();
++        xmls.serializeToStream(doc, strm, "UTF-8");
++      }
++
+       // Focus our window, to display the results
+       window.focus();
+ 
+Index: firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/browser-test.js
+===================================================================
+--- firefox-trunk-21.0~a1~hg20130205r120792.orig/testing/mochitest/browser-test.js	2013-02-06 03:57:53.514199378 -0800
++++ firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/browser-test.js	2013-02-06 03:57:53.502199378 -0800
+@@ -319,6 +319,7 @@
+       }
+ 
+       this.currentTestIndex++;
++      this.currentTest.startNextIteration();
+       this.execTest();
+     }).bind(this));
+   },
+Index: firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/runtests.py
+===================================================================
+--- firefox-trunk-21.0~a1~hg20130205r120792.orig/testing/mochitest/runtests.py	2013-02-06 03:57:53.514199378 -0800
++++ firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/runtests.py	2013-02-06 03:57:53.502199378 -0800
+@@ -257,6 +257,16 @@
+                     help = "Delay execution between test files.")
+     defaults["runSlower"] = False
+ 
++    self.add_option("--xunit-file",
++                    action = "store", type="string", dest = "xunitFile",
++                    help = "specify a filename to output xUnit results to")
++    defaults["xunitFile"] = None
++
++    self.add_option("--xunit-name",
++                    action = "store", type="string", dest = "xunitName",
++                    help = "specify a suite name for the xUnit output")
++    defaults["xunitName"] = None
++
+     # -h, --help are automatically handled by OptionParser
+ 
+     self.set_defaults(**defaults)
+@@ -663,6 +673,9 @@
+         self.urlOpts.append("failureFile=%s" % self.getFullPath(options.failureFile))
+       if options.runSlower:
+         self.urlOpts.append("runSlower=true")
++      if options.xunitFile:
++        self.urlOpts.append("xunitFile=%s" % encodeURIComponent(options.xunitFile))
++        self.urlOpts.append("xunitName=%s" % (options.xunitName if options.xunitName != None else "mochitest.plain"))
+ 
+   def cleanup(self, manifest, options):
+     """ remove temporary files and profile """
+@@ -828,6 +841,12 @@
+ 
+       content += '"' + opt + '": '
+       content += jsonString(val)
++
++    if options.xunitFile:
++      if not first:
++        content += ", "
++      content += '"xunitName": "%s"' % (options.xunitName if options.xunitName != None else "mochitest.%s" % testRoot)
++
+     content += "}"
+ 
+     with open(os.path.join(options.profilePath, "testConfig.js"), "w") as config:
+Index: firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/tests/SimpleTest/SimpleTest.js
+===================================================================
+--- firefox-trunk-21.0~a1~hg20130205r120792.orig/testing/mochitest/tests/SimpleTest/SimpleTest.js	2013-02-06 03:57:53.514199378 -0800
++++ firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/tests/SimpleTest/SimpleTest.js	2013-02-06 03:57:53.502199378 -0800
+@@ -283,6 +283,9 @@
+         if (isError) {
+             parentRunner.addFailedTest(url);
+             parentRunner.error(msg);
++            test.failureType = resultString;
++            test.failureMsg = msg;
++            test.testLog = parentRunner.flushLog();
+         } else {
+             parentRunner.log(msg);
+         }
+@@ -1052,6 +1055,12 @@
+ var isDeeply = SimpleTest.isDeeply;
+ var info = SimpleTest.info;
+ 
++// Shovel messages to the runner, so that it can keep a record and write
++// it to the JUnit results file on failure
++if (parentRunner) {
++    dump = parentRunner.dump;
++}
++
+ var gOldOnError = window.onerror;
+ window.onerror = function simpletestOnerror(errorMsg, url, lineNumber) {
+     // Log the message.
+Index: firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/tests/SimpleTest/TestRunner.js
+===================================================================
+--- firefox-trunk-21.0~a1~hg20130205r120792.orig/testing/mochitest/tests/SimpleTest/TestRunner.js	2013-02-06 03:57:53.514199378 -0800
++++ firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/tests/SimpleTest/TestRunner.js	2013-02-06 03:59:51.538197280 -0800
+@@ -75,10 +75,13 @@
+ TestRunner.currentTestURL = "";
+ TestRunner.originalTestURL = "";
+ TestRunner._urls = [];
++TestRunner._results = [];
+ 
+ TestRunner.timeout = 5 * 60 * 1000; // 5 minutes.
+ TestRunner.maxTimeouts = 4; // halt testing after too many timeouts
+ TestRunner.runSlower = false;
++TestRunner.xunitFile = null;
++TestRunner.xunitName = null;
+ 
+ TestRunner._expectingProcessCrash = false;
+ 
+@@ -180,7 +183,15 @@
+ **/
+ TestRunner.logger = LogController;
+ 
++TestRunner._dumpLog = [];
++
++TestRunner.dump = function(msg) {
++    TestRunner._dumpLog.push(msg);
++    dump(msg);
++};
++
+ TestRunner.log = function(msg) {
++    TestRunner._dumpLog.push(msg + "\n");
+     if (TestRunner.logEnabled) {
+         TestRunner.logger.log(msg);
+     } else {
+@@ -189,6 +200,7 @@
+ };
+ 
+ TestRunner.error = function(msg) {
++    TestRunner._dumpLog.push(msg + "\n");
+     if (TestRunner.logEnabled) {
+         TestRunner.logger.error(msg);
+     } else {
+@@ -196,6 +208,12 @@
+     }
+ };
+ 
++TestRunner.flushLog = function() {
++    var res = TestRunner._dumpLog.join("");
++    TestRunner._dumpLog = [];
++    return res;
++};
++
+ /**
+  * Toggle element visibility
+ **/
+@@ -277,6 +295,7 @@
+ **/
+ TestRunner.resetTests = function(listURLs) {
+   TestRunner._currentTest = 0;
++  TestRunner._results = [];
+   // Reset our "Current-test" line - functionality depends on it
+   $("current-test").innerHTML = TestRunner.originalTestURL;
+   if (TestRunner.logEnabled)
+@@ -323,6 +342,72 @@
+   }
+ }
+ 
++TestRunner.saveXUnitResults = function() {
++    if (!TestRunner._xUnitDocument) {
++        TestRunner._xUnitDocument = document.implementation
++                                            .createDocument(null, null, null);
++        var root = TestRunner._xUnitDocument.createElement("testsuite");
++        TestRunner._xUnitDocument.appendChild(root);
++        root.setAttribute("name", TestRunner.xunitName ? TestRunner.xunitName : "mochitest");
++    }
++
++    var doc = TestRunner._xUnitDocument
++    var root = doc.documentElement;
++
++    var suffix = "";
++    if (TestRunner.repeat > 0) {
++        suffix = "." + TestRunner._currentLoop;
++    }
++
++    TestRunner._results.forEach(function(res) {
++        var testcase = doc.createElement("testcase");
++        root.appendChild(testcase);
++
++        var relPath = res.path.substr(window.location.pathname.substr(0, window.location.pathname.lastIndexOf("/")).length);
++        dump("mainPath=" + window.location.pathname + ", path=" + res.path + ", relPath=" + relPath + "\n");
++        testcase.setAttribute("name", relPath.substr(relPath.lastIndexOf("/") + 1) + suffix);
++        testcase.setAttribute("classname", relPath.substr(0, relPath.lastIndexOf("/")).replace(/\//g, ".").replace(/^\./, ""));
++        testcase.setAttribute("time", res.time ? res.time : "0");
++
++        if ("failures" in res) {
++            res.failures.forEach(function(fail) {
++                var failure = doc.createElement("failure");
++                testcase.appendChild(failure);
++
++                failure.setAttribute("type", fail.type);
++                failure.setAttribute("message", fail.msg);
++                var cdata = doc.createCDATASection(fail.log);
++                failure.appendChild(cdata);
++            });
++        }
++    });
++};
++
++TestRunner.writeXUnitResults = function() {
++    var doc = TestRunner._xUnitDocument;
++    var root = doc.documentElement;
++
++    var count = parseInt($("pass-count").innerHTML) +
++                parseInt($("fail-count").innerHTML) +
++                parseInt($("todo-count").innerHTML);
++    root.setAttribute("tests", count);
++    root.setAttribute("failures", $("fail-count").innerHTML);
++
++    var Cc = SpecialPowers.wrap(Components).classes;
++    var Ci = Components.interfaces;
++
++    var file = Cc["@mozilla.org/file/local;1"]
++               .createInstance(Ci.nsIFile);
++    file.initWithPath(TestRunner.xunitFile);
++    var strm = Cc["@mozilla.org/network/file-output-stream;1"]
++               .createInstance(Ci.nsIFileOutputStream);
++    // WRONLY | CREATE | TRUNCATE
++    strm.init(file, 42, 0644, strm.DEFER_OPEN);
++    var xmls = new XMLSerializer();
++    var str = xmls.serializeToString(doc);
++    strm.write(str, str.length);
++};
++
+ /**
+  * Run the next test. If no test remains, calls onComplete().
+  **/
+@@ -331,6 +416,8 @@
+     if (TestRunner._currentTest < TestRunner._urls.length &&
+         !TestRunner._haltTests)
+     {
++        TestRunner._dumpLog = [];
++
+         var url = TestRunner._urls[TestRunner._currentTest];
+         TestRunner.currentTestURL = url;
+ 
+@@ -352,7 +439,11 @@
+         {
+           // No |$('testframe').contentWindow|, so manually update: ...
+           // ... the log,
+-          TestRunner.error("TEST-UNEXPECTED-FAIL | (SimpleTest/TestRunner.js) | No checks actually run.");
++          var msg = "TEST-UNEXPECTED-FAIL | (SimpleTest/TestRunner.js) | No checks actually run.";
++          TestRunner.error(msg);
++          TestRunner._results.push({ url: "SimpleTest/TestRunner.js",
++                                     failures: [{ failureType: "TEST-UNEXPECTED-FAIL",
++                                                  failureMsg: msg }] });
+           // ... the count,
+           $("fail-count").innerHTML = 1;
+           // ... the indicator.
+@@ -372,9 +463,16 @@
+           TestRunner.log("SimpleTest FINISHED");
+         }
+ 
++        if (TestRunner.xunitFile) {
++          TestRunner.saveXUnitResults();
++        }
++
+         if (TestRunner.repeat == 0 && TestRunner.onComplete) {
+-             TestRunner.onComplete();
+-         }
++          if (TestRunner.xunitFile) {
++            TestRunner.writeXUnitResults();
++          }
++          TestRunner.onComplete();
++        }
+ 
+         if (TestRunner._currentLoop < TestRunner.repeat) {
+           TestRunner._currentLoop++;
+@@ -386,6 +484,10 @@
+             TestRunner.log("SimpleTest FINISHED");
+           }
+ 
++          if (TestRunner.xunitFile) {
++            TestRunner.writeXUnitResults();
++          }
++
+           if (TestRunner.onComplete)
+             TestRunner.onComplete();
+        }
+@@ -401,22 +503,23 @@
+  * This stub is called by SimpleTest when a test is finished.
+ **/
+ TestRunner.testFinished = function(tests) {
++    function pushError(name) {
++        var msg = "TEST-UNEXPECTED-FAIL | " + TestRunner.currentTestURL + " | " + name;
++        TestRunner.error(msg);
++        tests.push({ result: false, failureType: "TEST-UNEXPECTED-FAIL",
++                     failureMsg: msg, testLog: TestRunner.flushLog() });
++        TestRunner.addFailedTest(TestRunner.currentTestURL);
++    }
++
+     function cleanUpCrashDumpFiles() {
+         if (!SpecialPowers.removeExpectedCrashDumpFiles(TestRunner._expectingProcessCrash)) {
+-            TestRunner.error("TEST-UNEXPECTED-FAIL | " +
+-                             TestRunner.currentTestURL +
+-                             " | This test did not leave any crash dumps behind, but we were expecting some!");
+-            tests.push({ result: false });
++            pushError("This test did not leave any crash dumps behind, but we were expecting some!");
+         }
+         var unexpectedCrashDumpFiles =
+             SpecialPowers.findUnexpectedCrashDumpFiles();
+         TestRunner._expectingProcessCrash = false;
+         if (unexpectedCrashDumpFiles.length) {
+-            TestRunner.error("TEST-UNEXPECTED-FAIL | " +
+-                             TestRunner.currentTestURL +
+-                             " | This test left crash dumps behind, but we " +
+-                             "weren't expecting it to!");
+-            tests.push({ result: false });
++            pushError("This test left crash dumps behind, but we weren't expecting it to!");
+             unexpectedCrashDumpFiles.sort().forEach(function(aFilename) {
+                 TestRunner.log("TEST-INFO | Found unexpected crash dump file " +
+                                aFilename + ".");
+@@ -426,12 +529,8 @@
+ 
+     function runNextTest() {
+         if (TestRunner.currentTestURL != TestRunner.getLoadedTestURL()) {
+-            TestRunner.error("TEST-UNEXPECTED-FAIL | " +
+-                             TestRunner.currentTestURL +
+-                             " | " + TestRunner.getLoadedTestURL() +
+-                             " finished in a non-clean fashion, probably" +
+-                             " because it didn't call SimpleTest.finish()");
+-            tests.push({ result: false });
++            pushError(TestRunner.getLoadedTestURL() + " finished in a non-clean fashion, probably" +
++                      " because it didn't call SimpleTest.finish()");
+         }
+ 
+         var runtime = new Date().valueOf() - TestRunner._currentTestStartTime;
+@@ -439,6 +538,19 @@
+                        TestRunner.currentTestURL +
+                        " | finished in " + runtime + "ms");
+ 
++        // Save only the path of the test
++        var result = { path: TestRunner.currentTestURL.replace(/^([^:]*:\/\/[^\/]*)?(.*)/, "$2"),
++                       time: runtime / 1000 };
++        TestRunner._results.push(result);
++        if (TestRunner.currentTestURL in TestRunner._failedTests) {
++            result.failures = [];
++            tests.map(function(f) { return !test.result == !test.todo; }).forEach(function(test) {
++                result.failures.push({ type: test.failureType,
++                                       msg: test.failureMsg,
++                                       log: test.testLog });
++            });
++        }
++
+         TestRunner.updateUI(tests);
+         TestRunner._currentTest++;
+         if (TestRunner.runSlower) {
+Index: firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/tests/SimpleTest/setup.js
+===================================================================
+--- firefox-trunk-21.0~a1~hg20130205r120792.orig/testing/mochitest/tests/SimpleTest/setup.js	2013-02-06 03:57:53.514199378 -0800
++++ firefox-trunk-21.0~a1~hg20130205r120792/testing/mochitest/tests/SimpleTest/setup.js	2013-02-06 03:59:34.000000000 -0800
+@@ -109,6 +109,13 @@
+   TestRunner.runSlower = true;
+ }
+ 
++if (params.xunitFile) {
++  TestRunner.xunitFile = decodeURIComponent(params.xunitFile);
++}
++
++if (params.xunitName) {
++  TestRunner.xunitName = params.xunitName;
++}
+ 
+ var gTestList = [];
+ var RunSet = {}

=== added file 'debian/patches/test-integration/reftest-output-junit-xml.patch'
--- debian/patches/test-integration/reftest-output-junit-xml.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-integration/reftest-output-junit-xml.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,679 @@
+Index: firefox-20.0~a2~hg20130206r123896/layout/tools/reftest/reftest-cmdline.js
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/tools/reftest/reftest-cmdline.js	2013-02-06 13:43:40.954086591 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/tools/reftest/reftest-cmdline.js	2013-02-06 13:43:40.946086591 +0000
+@@ -52,6 +52,41 @@
+     catch (e) {
+     }
+ 
++    try {
++      var xunitFile = cmdLine.handleFlagWithParam("reftestxunitfile", false);
++      if (xunitFile) {
++        try {
++          args.xunitFile = cmdLine.resolveFile(xunitFile).path;
++        }
++        catch (e) {
++        }
++      }
++    }
++    catch (e) {
++      cmdLine.handleFlag("reftestxunitfile", false);
++    }
++
++    try {
++      args.xunitName = cmdLine.handleFlagWithParam("reftestxunitname", false);
++    }
++    catch (e) {
++      cmdLine.handleFlag("reftestxunitname", false);
++    }
++
++    try {
++      var testRoot = cmdLine.handleFlagWithParam("reftestroot", false);
++      if (testRoot) {
++        try {
++          args.testRootURI = cmdLine.resolveURI(testRoot).spec;
++        }
++        catch (e) {
++        }
++      }
++    }
++    catch (e) {
++      cmdLine.handleFlag("reftestroot", false);
++    }
++
+     /* Ignore the platform's online/offline status while running reftests. */
+     var ios = Components.classes["@mozilla.org/network/io-service;1"]
+               .getService(Components.interfaces.nsIIOService2);
+Index: firefox-20.0~a2~hg20130206r123896/layout/tools/reftest/reftest.js
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/tools/reftest/reftest.js	2013-02-06 13:43:40.954086591 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/tools/reftest/reftest.js	2013-02-06 13:43:40.950086591 +0000
+@@ -64,32 +64,21 @@
+ var gURIUseCounts;
+ // Map from URI spec to the canvas rendered for that URI
+ var gURICanvases;
+-var gTestResults = {
+-  // Successful...
+-  Pass: 0,
+-  LoadOnly: 0,
+-  // Unexpected...
+-  Exception: 0,
+-  FailedLoad: 0,
+-  UnexpectedFail: 0,
+-  UnexpectedPass: 0,
+-  AssertionUnexpected: 0,
+-  AssertionUnexpectedFixed: 0,
+-  // Known problems...
+-  KnownFail : 0,
+-  AssertionKnown: 0,
+-  Random : 0,
+-  Skip: 0,
+-  Slow: 0,
+-};
++var gTestResults = [];
++var gTestCounters;
+ var gTotalTests = 0;
+ var gState;
+ var gCurrentURL;
++var gCurrentTestResult;
+ var gTestLog = [];
+ var gServer;
+ var gCount = 0;
+ var gAssertionCount = 0;
+ 
++var gXUnitFile;
++var gXUnitName;
++var gTestRootURI;
++
+ var gIOService;
+ var gDebug;
+ var gWindowUtils;
+@@ -122,6 +111,27 @@
+ const EXPECTED_DEATH = 3;  // test must be skipped to avoid e.g. crash/hang
+ const EXPECTED_FUZZY = 4;
+ 
++var Result = {
++    // Successful...
++    Pass: 0,
++    LoadOnly: 1,
++
++    // Known problems...
++    KnownFail: 2,
++    AssertionKnown: 3,
++    Random: 4,
++    Skip: 5,
++    Slow: 6,
++
++    // Unexpected...
++    Exception: 7,
++    FailedLoad: 8,
++    UnexpectedFail: 9,
++    UnexpectedPass: 10,
++    AssertionUnexpected: 11,
++    AssertionUnexpectedFixed: 12
++};
++
+ // types of preference value we might want to set for a specific test
+ const PREF_BOOLEAN = 0;
+ const PREF_STRING  = 1;
+@@ -164,15 +174,47 @@
+     gTestLog.push(str);
+ }
+ 
+-function FlushTestLog()
++function isFail(status)
++{
++    return status >= Result.Exception ? true : false;
++}
++
++function LogTestResult(status, str, time)
+ {
+-    if (!gVerbose) {
+-        // In verbose mode, we've dumped all these messages already.
+-        for (var i = 0; i < gTestLog.length; ++i) {
+-            gDumpLog("REFTEST INFO | Saved log: " + gTestLog[i] + "\n");
++    if (!gCurrentTestResult) {
++        gCurrentTestResult = { path: "preinit" };
++        gTestResults.unshift(gCurrentTestResult);
++    }
++
++    gDumpLog(str);
++
++    if (isFail(status)) {
++        if (!("failures" in gCurrentTestResult)) {
++            gCurrentTestResult.failures = [];
++        }
++        let failure = { status: status, msg: str };
++        gCurrentTestResult.failures.push(failure);
++        if (status != Result.UnexpectedPass &&
++            status != Result.AssertionUnexpectedFixed) {
++            failure.log = "";
++            for (var i = 0; i < gTestLog.length; ++i) {
++                let line = "REFTEST INFO | Saved log: " + gTestLog[i] + "\n";
++                if (!gVerbose) {
++                    // In verbose mode, we've dumped all these messages already.
++                    gDumpLog(line);
++                }
++                failure.log += line;
++            }
++            gTestLog = [];
+         }
++    } else {
++        gCurrentTestResult.status = status;
+     }
+-    gTestLog = [];
++    if (time) {
++        gCurrentTestResult.time = time;
++    }
++
++    gTestCounters[status]++;
+ }
+ 
+ function AllocateCanvas()
+@@ -236,6 +278,11 @@
+       gContainingWindow = win;
+     }
+ 
++    gTestCounters = new Array(Object.keys(Result).length);
++    for (let i = 0; i < gTestCounters.length; ++i) {
++        gTestCounters[i] = 0;
++    }
++
+     if (gBrowserIsIframe) {
+       gBrowser = gContainingWindow.document.createElementNS(XHTML_NS, "iframe");
+       gBrowser.setAttribute("mozbrowser", "");
+@@ -365,8 +412,7 @@
+             StartHTTPServer();
+     } catch (ex) {
+         //gBrowser.loadURI('data:text/plain,' + ex);
+-        ++gTestResults.Exception;
+-        gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | | EXCEPTION: " + ex + "\n");
++        LogTestResult(Result.Exception, "REFTEST TEST-UNEXPECTED-FAIL | | EXCEPTION: " + ex + "\n");
+         DoneTests();
+     }
+ 
+@@ -439,10 +485,22 @@
+         if ("skipslowtests" in args && args.skipslowtests)
+             gRunSlowTests = false;
+ 
++        if ("xunitFile" in args && args["xunitFile"]) {
++            gXUnitFile = args["xunitFile"];
++
++            gTestRootURI = "";
++            if ("testRootURI" in args && args["testRootURI"]) {
++                gTestRootURI = args["testRootURI"];
++            }
++
++            if ("xunitName" in args && args["xunitName"]) {
++                gXUnitName = args["xunitName"];
++            }
++        }
++
+         uri = args.uri;
+     } catch (e) {
+-        ++gTestResults.Exception;
+-        gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | | EXCEPTION: " + ex + "\n");
++        LogTestResult(Result.Exception, "REFTEST TEST-UNEXPECTED-FAIL | | EXCEPTION: " + ex + "\n");
+         DoneTests();
+     }
+ #endif
+@@ -493,8 +551,7 @@
+         StartCurrentTest();
+     } catch (ex) {
+         //gBrowser.loadURI('data:text/plain,' + ex);
+-        ++gTestResults.Exception;
+-        gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | | EXCEPTION: " + ex + "\n");
++        LogTestResult(Result.Exception, "REFTEST TEST-UNEXPECTED-FAIL | | EXCEPTION: " + ex + "\n");
+         DoneTests();
+     }
+ }
+@@ -950,6 +1007,7 @@
+                           expected: expected_status,
+                           allowSilentFail: allow_silent_fail,
+                           prettyPath: prettyPath,
++                          listPath: listURL.spec,
+                           minAsserts: minAsserts,
+                           maxAsserts: maxAsserts,
+                           needsFocus: needs_focus,
+@@ -976,6 +1034,7 @@
+                           expected: expected_status,
+                           allowSilentFail: allow_silent_fail,
+                           prettyPath: prettyPath,
++                          listPath: listURL.spec,
+                           minAsserts: minAsserts,
+                           maxAsserts: maxAsserts,
+                           needsFocus: needs_focus,
+@@ -1005,6 +1064,7 @@
+                           expected: expected_status,
+                           allowSilentFail: allow_silent_fail,
+                           prettyPath: prettyPath,
++                          listPath: listURL.spec,
+                           minAsserts: minAsserts,
+                           maxAsserts: maxAsserts,
+                           needsFocus: needs_focus,
+@@ -1119,19 +1179,21 @@
+     // make sure we don't run tests that are expected to kill the browser
+     while (gURLs.length > 0) {
+         var test = gURLs[0];
++        gCurrentTestResult = { path: test.prettyPath, listPath: test.listPath };
++        gTestResults.unshift(gCurrentTestResult);
+         if (test.expected == EXPECTED_DEATH) {
+-            ++gTestResults.Skip;
+-            gDumpLog("REFTEST TEST-KNOWN-FAIL | " + test.url1.spec + " | (SKIP)\n");
++            LogTestResult(Result.Skip,
++                "REFTEST TEST-KNOWN-FAIL | " + test.url1.spec + " | (SKIP)\n");
+             gURLs.shift();
+         } else if (test.needsFocus && !Focus()) {
+             // FIXME: Marking this as a known fail is dangerous!  What
+             // if it starts failing all the time?
+-            ++gTestResults.Skip;
+-            gDumpLog("REFTEST TEST-KNOWN-FAIL | " + test.url1.spec + " | (SKIPPED; COULDN'T GET FOCUS)\n");
++            LogTestResult(Result.Skip,
++                "REFTEST TEST-KNOWN-FAIL | " + test.url1.spec + " | (SKIPPED; COULDN'T GET FOCUS)\n");
+             gURLs.shift();
+         } else if (test.slow && !gRunSlowTests) {
+-            ++gTestResults.Slow;
+-            gDumpLog("REFTEST TEST-KNOWN-SLOW | " + test.url1.spec + " | (SLOW)\n");
++            LogTestResult(Result.Slow,
++                "REFTEST TEST-KNOWN-SLOW | " + test.url1.spec + " | (SLOW)\n");
+             gURLs.shift();
+         } else {
+             break;
+@@ -1209,13 +1271,13 @@
+             if (e == "bad pref") {
+                 var test = gURLs[0];
+                 if (test.expected == EXPECTED_FAIL) {
+-                    gDumpLog("REFTEST TEST-KNOWN-FAIL | " + test.url1.spec +
+-                             " | (SKIPPED; " + badPref + " not known or wrong type)\n");
+-                    ++gTestResults.Skip;
++                    LogTestResult(Result.Skip,
++                        "REFTEST TEST-KNOWN-FAIL | " + test.url1.spec +
++                        " | (SKIPPED; " + badPref + " not known or wrong type)\n");
+                 } else {
+-                    gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | " + test.url1.spec +
+-                             " | " + badPref + " not known or wrong type\n");
+-                    ++gTestResults.UnexpectedFail;
++                    LogTestResult(Result.UnexpectedFail,
++                        "REFTEST TEST-UNEXPECTED-FAIL | " + test.url1.spec +
++                        " | " + badPref + " not known or wrong type\n");
+                 }
+             } else {
+                 throw e;
+@@ -1252,38 +1314,118 @@
+     }
+ }
+ 
++function WriteXUnitResults(counts)
++{
++    let doc = document.implementation.createDocument(null, null, null);
++    let root = doc.createElement("testsuite");
++    doc.appendChild(root);
++    root.setAttribute("name", gXUnitName ? gXUnitName : "reftest");
++
++    let count = 0;
++    Object.keys(Result).forEach(function(key) {
++        count += gTestCounters[Result[key]];
++    });
++    root.setAttribute("tests", count);
++    count = gTestCounters[Result.Exception] + gTestCounters[Result.FailedLoad] +
++            gTestCounters[Result.UnexpectedFail] + gTestCounters[Result.UnexpectedPass] +
++            gTestCounters[Result.AssertionUnexpected] +
++            gTestCounters[Result.AssertionUnexpectedFixed];
++    root.setAttribute("failures", count);
++    count = gTestCounters[Result.Skip] + gTestCounters[Result.Slow];
++    root.setAttribute("skipped", count);
++
++    function addFailure(testcase, res)
++    {
++        let failure = doc.createElement("failure");
++        testcase.appendChild(failure);
++
++        failure.setAttribute("message", res.msg);
++        if (res.status == Result.UnexpectedPass ||
++            res.status == Result.AssertionUnexpectedFixed) {
++            failure.setAttribute("type", "TEST-UNEXPECTED-PASS");
++        } else {
++            failure.setAttribute("type", "TEST-UNEXPECTED-FAIL");
++        }
++
++        let cdata = doc.createCDATASection(res.log);
++        failure.appendChild(cdata);
++    }
++
++    gTestResults.reverse().forEach(function(res) {
++        let testcase = doc.createElement("testcase");
++        root.appendChild(testcase);
++
++        if (res.path == "preinit") {
++            // Special case for failures that occur during initialization
++            var relPath = "preinit/";
++            testcase.setAttribute("name", "preinit");
++        } else if (!res.path.startsWith(gTestRootURI)) {
++            // For data: URI's
++            var relPath = res.listPath.substr(gTestRootURI.length);
++            testcase.setAttribute("name", res.path);
++        } else {
++            var relPath = res.path.substr(gTestRootURI.length);
++            testcase.setAttribute("name", relPath.substr(relPath.lastIndexOf("/") + 1));
++
++        }
++        testcase.setAttribute("classname", relPath.substr(0, relPath.lastIndexOf("/")).replace(/\//g, ".").replace(/^\./, ""));
++        testcase.setAttribute("time", res.time ? res.time / 1000 : 0);
++
++        if ("failures" in res) {
++            res.failures.forEach(function(failure) {
++                addFailure(testcase, failure);
++            });
++        } else if (res.status == Result.Slow || res.status == Result.Skip) {
++            let skipped = doc.createElement("skipped");
++            testcase.appendChild(skipped);
++        }
++    });
++
++    var f = FileUtils.File(gXUnitFile);
++    if (f.exists()) {
++        f.remove(false);
++    }
++    var strm = FileUtils.openFileOutputStream(f, FileUtils.MODE_WRONLY | FileUtils.MODE_CREATE);
++    var xmls = new XMLSerializer();
++    xmls.serializeToStream(doc, strm, "UTF-8");
++}
++
+ function DoneTests()
+ {
+     gDumpLog("REFTEST FINISHED: Slowest test took " + gSlowestTestTime +
+          "ms (" + gSlowestTestURL + ")\n");
+ 
+     gDumpLog("REFTEST INFO | Result summary:\n");
+-    var count = gTestResults.Pass + gTestResults.LoadOnly;
++    var count = gTestCounters[Result.Pass] + gTestCounters[Result.LoadOnly];
+     gDumpLog("REFTEST INFO | Successful: " + count + " (" +
+-             gTestResults.Pass + " pass, " +
+-             gTestResults.LoadOnly + " load only)\n");
+-    count = gTestResults.Exception + gTestResults.FailedLoad +
+-            gTestResults.UnexpectedFail + gTestResults.UnexpectedPass +
+-            gTestResults.AssertionUnexpected +
+-            gTestResults.AssertionUnexpectedFixed;
++             gTestCounters[Result.Pass] + " pass, " +
++             gTestCounters[Result.LoadOnly] + " load only)\n");
++    count = gTestCounters[Result.Exception] + gTestCounters[Result.FailedLoad] +
++            gTestCounters[Result.UnexpectedFail] + gTestCounters[Result.UnexpectedPass] +
++            gTestCounters[Result.AssertionUnexpected] +
++            gTestCounters[Result.AssertionUnexpectedFixed];
+     gDumpLog("REFTEST INFO | Unexpected: " + count + " (" +
+-             gTestResults.UnexpectedFail + " unexpected fail, " +
+-             gTestResults.UnexpectedPass + " unexpected pass, " +
+-             gTestResults.AssertionUnexpected + " unexpected asserts, " +
+-             gTestResults.AssertionUnexpectedFixed + " unexpected fixed asserts, " +
+-             gTestResults.FailedLoad + " failed load, " +
+-             gTestResults.Exception + " exception)\n");
+-    count = gTestResults.KnownFail + gTestResults.AssertionKnown +
+-            gTestResults.Random + gTestResults.Skip + gTestResults.Slow;
++             gTestCounters[Result.UnexpectedFail] + " unexpected fail, " +
++             gTestCounters[Result.UnexpectedPass] + " unexpected pass, " +
++             gTestCounters[Result.AssertionUnexpected] + " unexpected asserts, " +
++             gTestCounters[Result.AssertionUnexpectedFixed] + " unexpected fixed asserts, " +
++             gTestCounters[Result.FailedLoad] + " failed load, " +
++             gTestCounters[Result.Exception] + " exception)\n");
++    count = gTestCounters[Result.KnownFail] + gTestCounters[Result.AssertionKnown] +
++            gTestCounters[Result.Random] + gTestCounters[Result.Skip] + gTestCounters[Result.Slow];
+     gDumpLog("REFTEST INFO | Known problems: " + count + " (" +
+-             gTestResults.KnownFail + " known fail, " +
+-             gTestResults.AssertionKnown + " known asserts, " +
+-             gTestResults.Random + " random, " +
+-             gTestResults.Skip + " skipped, " +
+-             gTestResults.Slow + " slow)\n");
++             gTestCounters[Result.KnownFail] + " known fail, " +
++             gTestCounters[Result.AssertionKnown] + " known asserts, " +
++             gTestCounters[Result.Random] + " random, " +
++             gTestCounters[Result.Skip] + " skipped, " +
++             gTestCounters[Result.Slow] + " slow)\n");
+ 
+     gDumpLog("REFTEST INFO | Total canvas count = " + gRecycledCanvases.length + "\n");
+ 
++    if (gXUnitFile) {
++        WriteXUnitResults();
++    }
++
+     gDumpLog("REFTEST TEST-START | Shutdown\n");
+     function onStopped() {
+         let appStartup = CC["@mozilla.org/toolkit/app-startup;1"].getService(CI.nsIAppStartup);
+@@ -1332,8 +1474,8 @@
+         // browser element
+         flags |= ctx.DRAWWINDOW_USE_WIDGET_LAYERS;
+     } else if (gBrowserIsRemote) {
+-        gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | " + gCurrentURL + " | can't drawWindow remote content\n");
+-        ++gTestResults.Exception;
++        LogTestResult(Result.Exception,
++            "REFTEST TEST-UNEXPECTED-FAIL | " + gCurrentURL + " | can't drawWindow remote content\n");
+     }
+ 
+     if (gDrawWindowFlags != flags) {
+@@ -1414,24 +1556,25 @@
+     var outputs = {};
+     const randomMsg = "(EXPECTED RANDOM)";
+     outputs[EXPECTED_PASS] = {
+-        true:  {s: "TEST-PASS"                  , n: "Pass"},
+-        false: {s: "TEST-UNEXPECTED-FAIL"       , n: "UnexpectedFail"}
++        true:  {s: "TEST-PASS"                  , n: Result.Pass},
++        false: {s: "TEST-UNEXPECTED-FAIL"       , n: Result.UnexpectedFail}
+     };
+     outputs[EXPECTED_FAIL] = {
+-        true:  {s: "TEST-UNEXPECTED-PASS"       , n: "UnexpectedPass"},
+-        false: {s: "TEST-KNOWN-FAIL"            , n: "KnownFail"}
++        true:  {s: "TEST-UNEXPECTED-PASS"       , n: Result.UnexpectedPass},
++        false: {s: "TEST-KNOWN-FAIL"            , n: Result.KnownFail}
+     };
+     outputs[EXPECTED_RANDOM] = {
+-        true:  {s: "TEST-PASS" + randomMsg      , n: "Random"},
+-        false: {s: "TEST-KNOWN-FAIL" + randomMsg, n: "Random"}
++        true:  {s: "TEST-PASS" + randomMsg      , n: Result.Random},
++        false: {s: "TEST-KNOWN-FAIL" + randomMsg, n: Result.Random}
+     };
+     outputs[EXPECTED_FUZZY] = outputs[EXPECTED_PASS];
+ 
+     var output;
+ 
+     if (gURLs[0].type == TYPE_LOAD) {
+-        ++gTestResults.LoadOnly;
+-        gDumpLog("REFTEST TEST-PASS | " + gURLs[0].prettyPath + " | (LOAD ONLY)\n");
++        LogTestResult(Result.LoadOnly,
++            "REFTEST TEST-PASS | " + gURLs[0].prettyPath + " | (LOAD ONLY)\n",
++            testRunTime);
+         gCurrentCanvas = null;
+         FinishTestItem();
+         return;
+@@ -1454,12 +1597,11 @@
+ 
+         if (errorMsg) {
+             output = outputs[expected][false];
+-            ++gTestResults[output.n];
+             var result = "REFTEST " + output.s + " | " +
+                 gURLs[0].prettyPath + " | " + // the URL being tested
+                 errorMsg;
+ 
+-            gDumpLog(result);
++            LogTestResult(output.n, result);
+             FinishTestItem();
+             return;
+         }
+@@ -1478,18 +1620,13 @@
+         }
+         var index = 0;
+         scriptResults.forEach(function(result) {
+-                var output = outputPair[result.passed];
+-
+-                ++gTestResults[output.n];
+-                result = "REFTEST " + output.s + " | " +
+-                    gURLs[0].prettyPath + " | " + // the URL being tested
+-                    result.description + " item " + (++index) + "\n";
+-                gDumpLog(result);
+-            });
++            var output = outputPair[result.passed];
+ 
+-        if (anyFailed && expected == EXPECTED_PASS) {
+-            FlushTestLog();
+-        }
++            result = "REFTEST " + output.s + " | " +
++                gURLs[0].prettyPath + " | " + // the URL being tested
++                result.description + " item " + (++index) + "\n";
++            LogTestResult(output.n, result);
++        });
+ 
+         FinishTestItem();
+         return;
+@@ -1500,8 +1637,8 @@
+         gCurrentCanvas = gURICanvases[gCurrentURL];
+     }
+     if (gCurrentCanvas == null) {
+-        gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | | program error managing snapshots\n");
+-        ++gTestResults.Exception;
++        LogTestResult(Result.Exception,
++            "REFTEST TEST-UNEXPECTED-FAIL | | program error managing snapshots\n");
+     }
+     if (gState == 1) {
+         gCanvas1 = gCurrentCanvas;
+@@ -1551,8 +1688,6 @@
+ 
+             output = outputs[expected][test_passed];
+ 
+-            ++gTestResults[output.n];
+-
+             var result = "REFTEST " + output.s + " | " +
+                          gURLs[0].prettyPath + " | "; // the URL being tested
+             switch (gURLs[0].type) {
+@@ -1579,11 +1714,7 @@
+                 result += "\n";
+             }
+ 
+-            gDumpLog(result);
+-
+-            if (!test_passed && expected == EXPECTED_PASS) {
+-                FlushTestLog();
+-            }
++            LogTestResult(output.n, result, testRunTime);
+ 
+             if (gURLs[0].prefSettings1.length == 0) {
+                 UpdateCanvasCache(gURLs[0].url1, gCanvas1);
+@@ -1602,10 +1733,8 @@
+ 
+ function LoadFailed(why)
+ {
+-    ++gTestResults.FailedLoad;
+-    gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | " +
+-         gURLs[0]["url" + gState].spec + " | load failed: " + why + "\n");
+-    FlushTestLog();
++    LogTestResult(Result.FailedLoad,
++        "REFTEST TEST-UNEXPECTED-FAIL | " + gURLs[0]["url" + gState].spec + " | load failed: " + why + "\n");
+     FinishTestItem();
+ }
+ 
+@@ -1640,10 +1769,10 @@
+         let path = String(file.path);
+         if (path.match(/\.(dmp|extra)$/) && !gUnexpectedCrashDumpFiles[path]) {
+             if (!foundCrashDumpFile) {
+-                ++gTestResults.UnexpectedFail;
+                 foundCrashDumpFile = true;
+-                gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | " + gCurrentURL +
+-                         " | This test left crash dumps behind, but we weren't expecting it to!\n");
++                LogTestResult(Result.UnexpectedFail,
++                    "REFTEST TEST-UNEXPECTED-FAIL | " + gCurrentURL +
++                    " | This test left crash dumps behind, but we weren't expecting it to!\n");
+             }
+             gDumpLog("REFTEST INFO | Found unexpected crash dump file" + path +
+                      ".\n");
+@@ -1693,20 +1822,20 @@
+         expectedAssertions += " assertions";
+ 
+         if (numAsserts < minAsserts) {
+-            ++gTestResults.AssertionUnexpectedFixed;
+-            gDumpLog("REFTEST TEST-UNEXPECTED-PASS | " + gURLs[0].prettyPath +
+-                 " | assertion count " + numAsserts + " is less than " +
+-                 expectedAssertions + "\n");
++            LogTestResult(Result.AssertionUnexpectedFixed,
++                "REFTEST TEST-UNEXPECTED-PASS | " + gURLs[0].prettyPath +
++                " | assertion count " + numAsserts + " is less than " +
++                expectedAssertions + "\n");
+         } else if (numAsserts > maxAsserts) {
+-            ++gTestResults.AssertionUnexpected;
+-            gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | " + gURLs[0].prettyPath +
+-                 " | assertion count " + numAsserts + " is more than " +
+-                 expectedAssertions + "\n");
++            LogTestResult(Result.AssertionUnexpected,
++                "REFTEST TEST-UNEXPECTED-FAIL | " + gURLs[0].prettyPath +
++                " | assertion count " + numAsserts + " is more than " +
++                expectedAssertions + "\n");
+         } else if (numAsserts != 0) {
+-            ++gTestResults.AssertionKnown;
+-            gDumpLog("REFTEST TEST-KNOWN-FAIL | " + gURLs[0].prettyPath +
+-                 " | assertion count " + numAsserts + " matches " +
+-                 expectedAssertions + "\n");
++            LogTestResult(Result.AssertionKnown,
++                "REFTEST TEST-KNOWN-FAIL | " + gURLs[0].prettyPath +
++                " | assertion count " + numAsserts + " matches " +
++                expectedAssertions + "\n");
+         }
+     }
+ 
+@@ -1813,8 +1942,7 @@
+ 
+ function RecvException(what)
+ {
+-    gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | | "+ what +"\n");
+-    ++gTestResults.Exception;
++    LogTestResult(Result.Exception, "REFTEST TEST-UNEXPECTED-FAIL | | "+ what +"\n");
+ }
+ 
+ function RecvFailedLoad(why)
+@@ -1836,8 +1964,8 @@
+     } else if (type == "warning") {
+         LogWarning(msg);
+     } else {
+-        gDumpLog("REFTEST TEST-UNEXPECTED-FAIL | | unknown log type "+ type +"\n");
+-        ++gTestResults.Exception;
++        LogTestResult(Result.Exception,
++            "REFTEST TEST-UNEXPECTED-FAIL | | unknown log type "+ type +"\n");
+     }
+ }
+ 
+Index: firefox-20.0~a2~hg20130206r123896/layout/tools/reftest/runreftest.py
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/tools/reftest/runreftest.py	2013-02-06 13:43:40.954086591 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/tools/reftest/runreftest.py	2013-02-06 13:43:40.950086591 +0000
+@@ -120,6 +120,14 @@
+       reftestlist = self.getManifestPath(testPath)
+       if cmdlineArgs == None:
+         cmdlineArgs = ['-reftest', reftestlist]
++        if options.xunitFile != None:
++          cmdlineArgs.extend(['-reftestxunitfile', options.xunitFile])
++          if options.testsRootDir == None:
++            print "Error: Need to specify the root test directory when outputting xUnit"
++            sys.exit(1)
++          cmdlineArgs.extend(['-reftestroot', options.testsRootDir])
++        if options.xunitName != None:
++          cmdlineArgs.extend(['-reftestxunitname', options.xunitName])
+       profileDir = mkdtemp()
+       self.copyExtraFilesToProfile(options, profileDir)
+       self.createReftestProfile(options, profileDir, reftestlist)
+@@ -256,6 +264,21 @@
+                            "only test items that have a matching test URL will be run.")
+     defaults["filter"] = None
+ 
++    self.add_option("--xunit-file",
++                    action = "store", type = "string", dest = "xunitFile",
++                    help = "specify a filename to output xUnit results to")
++    defaults["xunitFile"] = None
++
++    self.add_option("--xunit-name",
++                    action = "store", type = "string", dest = "xunitName",
++                    help = "specify a name for the xUnit results")
++    defaults["xunitName"] = None
++
++    self.add_option("--tests-root-dir",
++                    action = "store", type = "string", dest = "testsRootDir",
++                    help = "specify the root directory of the tests")
++    defaults["testsRootDir"] = None
++
+     self.set_defaults(**defaults)
+ 
+ def main():

=== added file 'debian/patches/test-integration/xpcshell-disable-addon-select-dialog-test-for-adt.patch'
--- debian/patches/test-integration/xpcshell-disable-addon-select-dialog-test-for-adt.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-integration/xpcshell-disable-addon-select-dialog-test-for-adt.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,41 @@
+Index: firefox-trunk-20.0~a1~hg20121130r114518/toolkit/mozapps/extensions/test/xpcshell/test_bug596343.js
+===================================================================
+--- firefox-trunk-20.0~a1~hg20121130r114518.orig/toolkit/mozapps/extensions/test/xpcshell/test_bug596343.js	2012-11-30 02:14:18.000000000 +0000
++++ firefox-trunk-20.0~a1~hg20121130r114518/toolkit/mozapps/extensions/test/xpcshell/test_bug596343.js	2012-11-30 13:14:46.057476721 +0000
+@@ -59,17 +59,27 @@
+     name: "Test Addon 1",
+   }, profileDir);
+ 
+-  startupManager();
+-
+-  // For a new profile it should disable showing the selection UI in the future
+-  do_check_true(Services.prefs.getBoolPref(PREF_SHOWN_SELECTION_UI));
+-  Services.prefs.clearUserPref(PREF_SHOWN_SELECTION_UI);
++  // When running on an installed system, the selection UI is disabled in
++  // vendor-firefox.js. But ensure the selection UI is tested when running
++  // from the build tree
++  let selectionUIDisabled = false;
++  try {
++    selectionUIDisabled = Services.prefs.getBoolPref(PREF_SHOWN_SELECTION_UI);
++  } catch(e) {}
+ 
+-  gExpectedURL = URI_EXTENSION_SELECT_DIALOG;
+-  restartManager("2");
++  startupManager();
+ 
+-  do_check_true(Services.prefs.getBoolPref(PREF_SHOWN_SELECTION_UI));
+-  do_check_eq(gExpectedURL, null);
++  if (!selectionUIDisabled) {
++    // For a new profile it should disable showing the selection UI in the future
++    do_check_true(Services.prefs.getBoolPref(PREF_SHOWN_SELECTION_UI));
++    Services.prefs.clearUserPref(PREF_SHOWN_SELECTION_UI);
++
++    gExpectedURL = URI_EXTENSION_SELECT_DIALOG;
++    restartManager("2");
++
++    do_check_true(Services.prefs.getBoolPref(PREF_SHOWN_SELECTION_UI));
++    do_check_eq(gExpectedURL, null);
++  }
+ 
+   gExpectedURL = URI_EXTENSION_UPDATE_DIALOG;
+ 

=== added file 'debian/patches/test-integration/xpcshell-disable-tests-which-need-appdir-write-access.patch'
--- debian/patches/test-integration/xpcshell-disable-tests-which-need-appdir-write-access.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-integration/xpcshell-disable-tests-which-need-appdir-write-access.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,30 @@
+Index: firefox-trunk-20.0~a1~hg20121130r114518/browser/components/places/tests/unit/xpcshell.ini
+===================================================================
+--- firefox-trunk-20.0~a1~hg20121130r114518.orig/browser/components/places/tests/unit/xpcshell.ini	2012-11-30 02:05:49.000000000 +0000
++++ firefox-trunk-20.0~a1~hg20121130r114518/browser/components/places/tests/unit/xpcshell.ini	2012-11-30 12:46:35.285407263 +0000
+@@ -7,6 +7,9 @@
+ [test_browserGlue_corrupt_nobackup.js]
+ [test_browserGlue_corrupt_nobackup_default.js]
+ [test_browserGlue_distribution.js]
++# This test requires write access to the application directory
++skip-if = true
++
+ [test_browserGlue_migrate.js]
+ [test_browserGlue_prefs.js]
+ [test_browserGlue_restore.js]
+Index: firefox-trunk-20.0~a1~hg20121130r114518/toolkit/mozapps/extensions/test/xpcshell/xpcshell.ini
+===================================================================
+--- firefox-trunk-20.0~a1~hg20121130r114518.orig/toolkit/mozapps/extensions/test/xpcshell/xpcshell.ini	2012-11-30 12:48:52.757412913 +0000
++++ firefox-trunk-20.0~a1~hg20121130r114518/toolkit/mozapps/extensions/test/xpcshell/xpcshell.ini	2012-11-30 13:41:15.617542019 +0000
+@@ -231,7 +231,9 @@
+ [test_update_compatmode.js]
+ [test_upgrade.js]
+ # Bug 676992: test consistently hangs on Android
+-skip-if = os == "android"
++# This needs to write to the application directory
++skip-if = true
+ [test_upgrade_strictcompat.js]
+ # Bug 676992: test consistently hangs on Android
+-skip-if = os == "android"
++# This needs to write to the application directory
++skip-if = true

=== added file 'debian/patches/test-integration/xpcshell-output-valid-junit-xml.patch'
--- debian/patches/test-integration/xpcshell-output-valid-junit-xml.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-integration/xpcshell-output-valid-junit-xml.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,26 @@
+Index: firefox-trunk-21.0~a1~hg20130205r120792/testing/xpcshell/runxpcshelltests.py
+===================================================================
+--- firefox-trunk-21.0~a1~hg20130205r120792.orig/testing/xpcshell/runxpcshelltests.py	2013-02-05 22:49:57.525807392 +0000
++++ firefox-trunk-21.0~a1~hg20130205r120792/testing/xpcshell/runxpcshelltests.py	2013-02-05 22:49:57.517807392 +0000
+@@ -550,7 +550,7 @@
+ 
+     testsuite.setAttribute("tests", str(total))
+     testsuite.setAttribute("failures", str(failed))
+-    testsuite.setAttribute("skip", str(skipped))
++    testsuite.setAttribute("skipped", str(skipped))
+ 
+     doc.writexml(fh, addindent="  ", newl="\n", encoding="utf-8")
+ 
+Index: firefox-trunk-21.0~a1~hg20130205r120792/testing/xpcshell/selftest.py
+===================================================================
+--- firefox-trunk-21.0~a1~hg20130205r120792.orig/testing/xpcshell/selftest.py	2013-02-05 15:17:37.000000000 +0000
++++ firefox-trunk-21.0~a1~hg20130205r120792/testing/xpcshell/selftest.py	2013-02-05 22:52:51.041804309 +0000
+@@ -432,7 +432,7 @@
+         self.assertTrue(suite is not None)
+         self.assertEqual(suite.get("tests"), "3")
+         self.assertEqual(suite.get("failures"), "1")
+-        self.assertEqual(suite.get("skip"), "1")
++        self.assertEqual(suite.get("skipped"), "1")
+ 
+         testcases = suite.findall("testcase")
+         self.assertEqual(len(testcases), 3)

=== added directory 'debian/patches/test-overrides'
=== added file 'debian/patches/test-overrides/reftest-disable-failing-tests.patch'
--- debian/patches/test-overrides/reftest-disable-failing-tests.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-overrides/reftest-disable-failing-tests.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,361 @@
+Index: firefox-20.0~a2~hg20130206r123896/layout/reftests/bugs/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/reftests/bugs/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/reftests/bugs/reftest.list	2013-02-06 13:25:47.038105673 +0000
+@@ -1314,8 +1314,8 @@
+ != 481948-2.html 481948-2-ref.html
+ skip-if(B2G) fails-if(Android) random-if(winWidget) fails-if(gtk2Widget) == 481948-3.html 481948-3-ref.html # questionable test, see bug 488364
+ == 482398-1.html 482398-1-ref.html
+-random-if(d2d) == 482592-1a.xhtml 482592-1-ref.html # bug 586771
+-random-if(d2d) == 482592-1b.xhtml 482592-1-ref.html # bug 586771
++fails == 482592-1a.xhtml 482592-1-ref.html # bug 586771
++fails == 482592-1b.xhtml 482592-1-ref.html # bug 586771
+ random-if(winWidget) == 482659-1a.html 482659-1-ref.html
+ == 482659-1b.html 482659-1-ref.html
+ == 482659-1c.html 482659-1-ref.html
+@@ -1631,7 +1631,7 @@
+ HTTP(..) == 621253-2-externalFilter.html 621253-2-ref.html
+ == 621253-2-internalFilter.html 621253-2-ref.html
+ fails-if(Android) HTTP(..) == 619511-1.html 619511-1-ref.html
+-skip-if(B2G) random-if(winWidget) fuzzy-if(OSX==10.8,19,17) == 621918-1.svg 621918-1-ref.svg # 1-pixel diacritic positioning discrepancy in rotated text (may depend on platform fonts)
++fails == 621918-1.svg 621918-1-ref.svg # 1-pixel diacritic positioning discrepancy in rotated text (may depend on platform fonts)
+ random-if(winWidget) HTTP(..) == 621918-2.svg 621918-2-ref.svg # same 1px issue as above, and HTTP(..) for filters.svg, used to mask antialiasing issues where glyphs touch
+ fuzzy-if(d2d,5,1) == 622585-1.html 622585-1-ref.html # bug 789402
+ fails-if(Android) == 625409-1.html 625409-1-ref.html
+Index: firefox-20.0~a2~hg20130206r123896/layout/reftests/first-letter/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/reftests/first-letter/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/reftests/first-letter/reftest.list	2013-02-06 13:25:47.038105673 +0000
+@@ -35,7 +35,7 @@
+ != 229764-1.html 229764-ref.html
+ == 229764-2.html 229764-ref.html
+ == 329069-1.html 329069-1-ref.html
+-== 329069-2.html 329069-2-ref.html
++fails == 329069-2.html 329069-2-ref.html
+ == 329069-3.html 329069-3-ref.html
+ == 329069-4.html 329069-4-ref.html
+ fails-if(!cocoaWidget) == 329069-5.html 329069-5-ref.html # bug 603710
+Index: firefox-20.0~a2~hg20130206r123896/layout/reftests/mathml/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/reftests/mathml/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/reftests/mathml/reftest.list	2013-02-06 13:25:47.038105673 +0000
+@@ -29,7 +29,7 @@
+ == mfenced-7.html mfenced-7-ref.html
+ != mfenced-8.html mfenced-8-ref.html
+ == mfenced-9.html mfenced-9-ref.html
+-fails-if(winWidget) == mfenced-10.html mfenced-10-ref.html
++fails == mfenced-10.html mfenced-10-ref.html
+ == mi-mathvariant-1.xhtml mi-mathvariant-1-ref.xhtml
+ == mi-mathvariant-2.xhtml mi-mathvariant-2-ref.xhtml
+ != non-spacing-accent-1.xhtml non-spacing-accent-1-ref.xhtml
+Index: firefox-20.0~a2~hg20130206r123896/parser/htmlparser/tests/reftest/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/parser/htmlparser/tests/reftest/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/parser/htmlparser/tests/reftest/reftest.list	2013-02-06 13:25:47.038105673 +0000
+@@ -1,5 +1,5 @@
+ == bug535530-1.html bug535530-1-ref.html
+-== view-source:bug535530-2.html bug535530-2-ref.html
++fails == view-source:bug535530-2.html bug535530-2-ref.html
+ == bug566280-1.html bug566280-1-ref.html
+ == bug577418-1.html bug577418-1-ref.html
+ == bug582788-1.html bug582788-1-ref.html
+Index: firefox-20.0~a2~hg20130206r123896/layout/reftests/text/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/reftests/text/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/reftests/text/reftest.list	2013-02-06 13:25:47.038105673 +0000
+@@ -106,7 +106,7 @@
+ == wordbreak-1.html wordbreak-1-ref.html
+ == wordbreak-2.html wordbreak-2-ref.html
+ == wordbreak-3.html wordbreak-3-ref.html
+-== wordbreak-4a.html wordbreak-4a-ref.html
++fails == wordbreak-4a.html wordbreak-4a-ref.html
+ == wordbreak-4b.html wordbreak-4b-ref.html
+ == wordbreak-5.html wordbreak-5-ref.html
+ == wordbreak-6.html wordbreak-6-ref.html
+@@ -184,52 +184,52 @@
+ pref(gfx.font_rendering.graphite.enabled,true) HTTP(..) == glyph-decomposition-graphite.html glyph-decomposition-graphite-ref.html
+ 
+ # Tests for hyphenation with -moz-hyphens
+-== auto-hyphenation-1.html auto-hyphenation-1-ref.html
+-!= auto-hyphenation-1.html auto-hyphenation-1-notref.html
+-== auto-hyphenation-1a.html auto-hyphenation-1-ref.html
+-== auto-hyphenation-2.html auto-hyphenation-2-ref.html
+-== auto-hyphenation-3.html auto-hyphenation-3-ref.html
+-== auto-hyphenation-4.html auto-hyphenation-4-ref.html
+-== auto-hyphenation-5.html auto-hyphenation-5-ref.html
+-== auto-hyphenation-6.html auto-hyphenation-6-ref.html
+-== auto-hyphenation-7.html auto-hyphenation-7-ref.html
+-== auto-hyphenation-8.html auto-hyphenation-4-ref.html
+-== auto-hyphenation-9.html auto-hyphenation-4-ref.html
+-== auto-hyphenation-10.html auto-hyphenation-4-ref.html
+-== auto-hyphenation-af-1.html auto-hyphenation-af-1-ref.html
+-== auto-hyphenation-bg-1.html auto-hyphenation-bg-1-ref.html
+-== auto-hyphenation-ca-1.html auto-hyphenation-ca-1-ref.html
+-== auto-hyphenation-cy-1.html auto-hyphenation-cy-1-ref.html
+-== auto-hyphenation-da-1.html auto-hyphenation-da-1-ref.html
+-== auto-hyphenation-de-1901-1.html auto-hyphenation-de-1901-1-ref.html
+-== auto-hyphenation-de-1996-1.html auto-hyphenation-de-1996-1-ref.html
+-!= auto-hyphenation-de-1901-1.html auto-hyphenation-de-1996-1.html
+-== auto-hyphenation-de-ch-1.html auto-hyphenation-de-ch-1-ref.html
+-== auto-hyphenation-eo-1.html auto-hyphenation-eo-1-ref.html
+-== auto-hyphenation-es-1.html auto-hyphenation-es-1-ref.html
+-== auto-hyphenation-et-1.html auto-hyphenation-et-1-ref.html
+-== auto-hyphenation-fi-1.html auto-hyphenation-fi-1-ref.html
+-== auto-hyphenation-fr-1.html auto-hyphenation-fr-1-ref.html
+-== auto-hyphenation-gl-1.html auto-hyphenation-gl-1-ref.html
+-== auto-hyphenation-hr-1.html auto-hyphenation-hr-1-ref.html
+-== auto-hyphenation-hsb-1.html auto-hyphenation-hsb-1-ref.html
+-== auto-hyphenation-hu-1.html auto-hyphenation-hu-1-ref.html
+-== auto-hyphenation-ia-1.html auto-hyphenation-ia-1-ref.html
+-== auto-hyphenation-is-1.html auto-hyphenation-is-1-ref.html
+-== auto-hyphenation-it-1.html auto-hyphenation-it-1-ref.html
+-== auto-hyphenation-kmr-1.html auto-hyphenation-kmr-1-ref.html
+-== auto-hyphenation-la-1.html auto-hyphenation-la-1-ref.html
+-== auto-hyphenation-lt-1.html auto-hyphenation-lt-1-ref.html
+-== auto-hyphenation-mn-1.html auto-hyphenation-mn-1-ref.html
+-== auto-hyphenation-nb-1.html auto-hyphenation-nb-1-ref.html
+-== auto-hyphenation-nl-1.html auto-hyphenation-nl-1-ref.html
+-== auto-hyphenation-nn-1.html auto-hyphenation-nn-1-ref.html
+-== auto-hyphenation-pt-1.html auto-hyphenation-pt-1-ref.html
+-== auto-hyphenation-ru-1.html auto-hyphenation-ru-1-ref.html
+-== auto-hyphenation-sh-1.html auto-hyphenation-sh-1-ref.html
+-== auto-hyphenation-sl-1.html auto-hyphenation-sl-1-ref.html
+-== auto-hyphenation-sr-1.html auto-hyphenation-sr-1-ref.html
+-== auto-hyphenation-sv-1.html auto-hyphenation-sv-1-ref.html # test swedish patterns
+-!= auto-hyphenation-sv-1.html auto-hyphenation-sv-1-notref.html # verify swedish != english
+-== auto-hyphenation-tr-1.html auto-hyphenation-tr-1-ref.html
+-== auto-hyphenation-uk-1.html auto-hyphenation-uk-1-ref.html
++skip == auto-hyphenation-1.html auto-hyphenation-1-ref.html
++skip != auto-hyphenation-1.html auto-hyphenation-1-notref.html
++skip == auto-hyphenation-1a.html auto-hyphenation-1-ref.html
++skip == auto-hyphenation-2.html auto-hyphenation-2-ref.html
++skip == auto-hyphenation-3.html auto-hyphenation-3-ref.html
++skip == auto-hyphenation-4.html auto-hyphenation-4-ref.html
++skip == auto-hyphenation-5.html auto-hyphenation-5-ref.html
++skip == auto-hyphenation-6.html auto-hyphenation-6-ref.html
++skip == auto-hyphenation-7.html auto-hyphenation-7-ref.html
++skip == auto-hyphenation-8.html auto-hyphenation-4-ref.html
++skip == auto-hyphenation-9.html auto-hyphenation-4-ref.html
++skip == auto-hyphenation-10.html auto-hyphenation-4-ref.html
++skip == auto-hyphenation-af-1.html auto-hyphenation-af-1-ref.html
++skip == auto-hyphenation-bg-1.html auto-hyphenation-bg-1-ref.html
++skip == auto-hyphenation-ca-1.html auto-hyphenation-ca-1-ref.html
++skip == auto-hyphenation-cy-1.html auto-hyphenation-cy-1-ref.html
++skip == auto-hyphenation-da-1.html auto-hyphenation-da-1-ref.html
++skip == auto-hyphenation-de-1901-1.html auto-hyphenation-de-1901-1-ref.html
++skip == auto-hyphenation-de-1996-1.html auto-hyphenation-de-1996-1-ref.html
++skip != auto-hyphenation-de-1901-1.html auto-hyphenation-de-1996-1.html
++skip == auto-hyphenation-de-ch-1.html auto-hyphenation-de-ch-1-ref.html
++skip == auto-hyphenation-eo-1.html auto-hyphenation-eo-1-ref.html
++skip == auto-hyphenation-es-1.html auto-hyphenation-es-1-ref.html
++skip == auto-hyphenation-et-1.html auto-hyphenation-et-1-ref.html
++skip == auto-hyphenation-fi-1.html auto-hyphenation-fi-1-ref.html
++skip == auto-hyphenation-fr-1.html auto-hyphenation-fr-1-ref.html
++skip == auto-hyphenation-gl-1.html auto-hyphenation-gl-1-ref.html
++skip == auto-hyphenation-hr-1.html auto-hyphenation-hr-1-ref.html
++skip == auto-hyphenation-hsb-1.html auto-hyphenation-hsb-1-ref.html
++skip == auto-hyphenation-hu-1.html auto-hyphenation-hu-1-ref.html
++skip == auto-hyphenation-ia-1.html auto-hyphenation-ia-1-ref.html
++skip == auto-hyphenation-is-1.html auto-hyphenation-is-1-ref.html
++skip == auto-hyphenation-it-1.html auto-hyphenation-it-1-ref.html
++skip == auto-hyphenation-kmr-1.html auto-hyphenation-kmr-1-ref.html
++skip == auto-hyphenation-la-1.html auto-hyphenation-la-1-ref.html
++skip == auto-hyphenation-lt-1.html auto-hyphenation-lt-1-ref.html
++skip == auto-hyphenation-mn-1.html auto-hyphenation-mn-1-ref.html
++skip == auto-hyphenation-nb-1.html auto-hyphenation-nb-1-ref.html
++skip == auto-hyphenation-nl-1.html auto-hyphenation-nl-1-ref.html
++skip == auto-hyphenation-nn-1.html auto-hyphenation-nn-1-ref.html
++skip == auto-hyphenation-pt-1.html auto-hyphenation-pt-1-ref.html
++skip == auto-hyphenation-ru-1.html auto-hyphenation-ru-1-ref.html
++skip == auto-hyphenation-sh-1.html auto-hyphenation-sh-1-ref.html
++skip == auto-hyphenation-sl-1.html auto-hyphenation-sl-1-ref.html
++skip == auto-hyphenation-sr-1.html auto-hyphenation-sr-1-ref.html
++skip == auto-hyphenation-sv-1.html auto-hyphenation-sv-1-ref.html # test swedish patterns
++skip != auto-hyphenation-sv-1.html auto-hyphenation-sv-1-notref.html # verify swedish != english
++skip == auto-hyphenation-tr-1.html auto-hyphenation-tr-1-ref.html
++skip == auto-hyphenation-uk-1.html auto-hyphenation-uk-1-ref.html
+Index: firefox-20.0~a2~hg20130206r123896/layout/reftests/flexbox/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/reftests/flexbox/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/reftests/flexbox/reftest.list	2013-02-06 13:25:47.038105673 +0000
+@@ -10,7 +10,7 @@
+ fails == flexbox-align-self-baseline-horiz-2.xhtml  flexbox-align-self-baseline-horiz-2-ref.xhtml # bug 793456, and possibly others
+ # This one fails on windows R (but not Ru, strangely). On Windows R, the
+ # single-line <label> flex item has a different background size in test vs. ref
+-random-if(winWidget) == flexbox-align-self-baseline-horiz-3.xhtml  flexbox-align-self-baseline-horiz-3-ref.xhtml # XXXdholbert investigate
++fuzzy(40,3) == flexbox-align-self-baseline-horiz-3.xhtml  flexbox-align-self-baseline-horiz-3-ref.xhtml # XXXdholbert investigate
+ == flexbox-align-self-baseline-horiz-4.xhtml flexbox-align-self-baseline-horiz-4-ref.xhtml
+ 
+ == flexbox-align-self-horiz-1-block.xhtml  flexbox-align-self-horiz-1-ref.xhtml
+Index: firefox-20.0~a2~hg20130206r123896/editor/reftests/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/editor/reftests/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/editor/reftests/reftest.list	2013-02-06 13:25:47.038105673 +0000
+@@ -17,46 +17,46 @@
+ == emptypasswd-1.html emptypasswd-ref.html
+ == emptypasswd-2.html emptypasswd-ref.html
+ == caret_on_positioned.html caret_on_positioned-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-disabled.html spellcheck-input-ref.html
++fails != spellcheck-input-disabled.html spellcheck-input-ref.html
+ == spellcheck-input-attr-before.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-attr-before.html spellcheck-input-ref.html
++fails != spellcheck-input-attr-before.html spellcheck-input-ref.html
+ == spellcheck-input-attr-after.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-attr-after.html spellcheck-input-ref.html
++fails != spellcheck-input-attr-after.html spellcheck-input-ref.html
+ == spellcheck-input-attr-inherit.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-attr-inherit.html spellcheck-input-ref.html
++fails != spellcheck-input-attr-inherit.html spellcheck-input-ref.html
+ == spellcheck-input-attr-dynamic.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-attr-dynamic.html spellcheck-input-ref.html
++fails != spellcheck-input-attr-dynamic.html spellcheck-input-ref.html
+ == spellcheck-input-attr-dynamic-inherit.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-attr-dynamic-inherit.html spellcheck-input-ref.html
++fails != spellcheck-input-attr-dynamic-inherit.html spellcheck-input-ref.html
+ == spellcheck-input-property-dynamic.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-property-dynamic.html spellcheck-input-ref.html
++fails != spellcheck-input-property-dynamic.html spellcheck-input-ref.html
+ == spellcheck-input-property-dynamic-inherit.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-property-dynamic-inherit.html spellcheck-input-ref.html
++fails != spellcheck-input-property-dynamic-inherit.html spellcheck-input-ref.html
+ == spellcheck-input-attr-dynamic-override.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-attr-dynamic-override.html spellcheck-input-ref.html
++fails != spellcheck-input-attr-dynamic-override.html spellcheck-input-ref.html
+ == spellcheck-input-attr-dynamic-override-inherit.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-attr-dynamic-override-inherit.html spellcheck-input-ref.html
++fails != spellcheck-input-attr-dynamic-override-inherit.html spellcheck-input-ref.html
+ == spellcheck-input-property-dynamic-override.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-property-dynamic-override.html spellcheck-input-ref.html
++fails != spellcheck-input-property-dynamic-override.html spellcheck-input-ref.html
+ == spellcheck-input-property-dynamic-override-inherit.html spellcheck-input-nofocus-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-input-property-dynamic-override-inherit.html spellcheck-input-ref.html
++fails != spellcheck-input-property-dynamic-override-inherit.html spellcheck-input-ref.html
+ == spellcheck-textarea-attr.html spellcheck-textarea-nofocus-ref.html
+ #the random-if(Android) tests pass on android native, but fail on android-xul, see bug 728942
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-attr.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-attr.html spellcheck-textarea-ref.html
+ needs-focus == spellcheck-textarea-focused.html spellcheck-textarea-ref.html
+ needs-focus == spellcheck-textarea-focused-reframe.html spellcheck-textarea-ref.html
+ needs-focus == spellcheck-textarea-focused-notreadonly.html spellcheck-textarea-ref2.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-nofocus.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-disabled.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-attr-inherit.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-attr-dynamic.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-attr-dynamic-inherit.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-property-dynamic.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-property-dynamic-inherit.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-attr-dynamic-override.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-attr-dynamic-override-inherit.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-property-dynamic-override.html spellcheck-textarea-ref.html
+-skip-if(B2G) random-if(Android) != spellcheck-textarea-property-dynamic-override-inherit.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-nofocus.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-disabled.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-attr-inherit.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-attr-dynamic.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-attr-dynamic-inherit.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-property-dynamic.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-property-dynamic-inherit.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-attr-dynamic-override.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-attr-dynamic-override-inherit.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-property-dynamic-override.html spellcheck-textarea-ref.html
++fails != spellcheck-textarea-property-dynamic-override-inherit.html spellcheck-textarea-ref.html
+ needs-focus == caret_on_focus.html caret_on_focus-ref.html
+ needs-focus != caret_on_textarea_lastline.html caret_on_textarea_lastline-ref.html
+ needs-focus == input-text-onfocus-reframe.html input-text-onfocus-reframe-ref.html
+@@ -65,13 +65,13 @@
+ == nobogusnode-1.html nobogusnode-ref.html
+ == nobogusnode-2.html nobogusnode-ref.html
+ == spellcheck-hyphen-valid.html spellcheck-hyphen-valid-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-hyphen-invalid.html spellcheck-hyphen-invalid-ref.html
++fails != spellcheck-hyphen-invalid.html spellcheck-hyphen-invalid-ref.html
+ == spellcheck-slash-valid.html spellcheck-slash-valid-ref.html
+ == spellcheck-period-valid.html spellcheck-period-valid-ref.html
+ == spellcheck-space-valid.html spellcheck-space-valid-ref.html
+ == spellcheck-comma-valid.html spellcheck-comma-valid-ref.html
+ == spellcheck-hyphen-multiple-valid.html spellcheck-hyphen-multiple-valid-ref.html
+-skip-if(B2G) fails-if(Android) != spellcheck-hyphen-multiple-invalid.html spellcheck-hyphen-multiple-invalid-ref.html
++fails != spellcheck-hyphen-multiple-invalid.html spellcheck-hyphen-multiple-invalid-ref.html
+ == spellcheck-dotafterquote-valid.html spellcheck-dotafterquote-valid-ref.html
+ == spellcheck-url-valid.html spellcheck-url-valid-ref.html
+ == unneeded_scroll.html unneeded_scroll-ref.html
+@@ -97,4 +97,4 @@
+ == 694880-3.html 694880-ref.html
+ == 388980-1.html 388980-1-ref.html
+ needs-focus == spellcheck-superscript-1.html spellcheck-superscript-1-ref.html
+-skip-if(B2G) fails-if(Android) needs-focus != spellcheck-superscript-2.html spellcheck-superscript-2-ref.html # bug 783658
++fails needs-focus != spellcheck-superscript-2.html spellcheck-superscript-2-ref.html # bug 783658
+Index: firefox-20.0~a2~hg20130206r123896/layout/reftests/font-face/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/reftests/font-face/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/reftests/font-face/reftest.list	2013-02-06 13:27:00.086104375 +0000
+@@ -27,8 +27,8 @@
+ # assumes AAT fonts are only supported on MacOS
+ skip-if(B2G) random-if(cocoaWidget) HTTP(..) == src-list-format-7.html src-list-format-2-ref.html
+ skip-if(B2G) random-if(!cocoaWidget) HTTP(..) == src-list-format-7.html src-list-format-3-ref.html
+-fails-if(Android||B2G) == src-list-local-full.html src-list-local-full-ref.html # bug 773482
+-fails-if(Android||B2G) == src-list-local-full-quotes.html src-list-local-full-ref.html # bug 773482
++fails == src-list-local-full.html src-list-local-full-ref.html # bug 773482
++fails == src-list-local-full-quotes.html src-list-local-full-ref.html # bug 773482
+ skip-if(B2G) HTTP(..) == src-list-local-fallback.html src-list-local-fallback-ref.html
+ 
+ # data url tests (these don't need the HTTP server)
+@@ -95,8 +95,8 @@
+ # random-if(cocoaWidget) HTTP(..) == src-format-arabic.html src-format-arabic-ot-ref.html
+ 
+ # bug 769194 - src:local() completely broken on android
+-skip-if(B2G) fails-if(Android) == local-1.html local-1-ref.html # bug 773482
+-skip-if(B2G) fails-if(Android) == local-styled-1.html local-styled-1-ref.html # bug 773482
++fails == local-1.html local-1-ref.html # bug 773482
++fails == local-styled-1.html local-styled-1-ref.html # bug 773482
+ 
+ skip-if(B2G) HTTP(..) == synthetic-weight-style.html synthetic-weight-style-ref.html # bug 773482
+ skip-if(B2G) HTTP(..) == synthetic-variations.html synthetic-variations-ref.html
+Index: firefox-20.0~a2~hg20130206r123896/layout/reftests/forms/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/reftests/forms/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/reftests/forms/reftest.list	2013-02-06 13:25:47.038105673 +0000
+@@ -25,7 +25,7 @@
+ skip-if(B2G) fails-if(Android) == textbox-setsize.xul textbox-setsize-ref.xul
+ skip-if(B2G) fails-if(Android) == textarea-resize.html textarea-resize-ref.html
+ # an offset seems to apply to the native resizer on windows so skip this test for now
+-skip-if(B2G) fails-if(Android) skip-if(winWidget) == textarea-resize-background.html textarea-resize-background-ref.html
++fails == textarea-resize-background.html textarea-resize-background-ref.html
+ skip-if(B2G) fails-if(Android) != textarea-ltr.html textarea-rtl.html
+ skip-if(B2G) fails-if(Android) != textarea-ltr-scrollbar.html textarea-rtl-scrollbar.html
+ skip-if(B2G) fails-if(Android) != textarea-in-ltr-doc-scrollbar.html textarea-in-rtl-doc-scrollbar.html
+Index: firefox-20.0~a2~hg20130206r123896/layout/reftests/text-overflow/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/reftests/text-overflow/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/reftests/text-overflow/reftest.list	2013-02-06 13:25:47.042105673 +0000
+@@ -7,7 +7,7 @@
+ fuzzy-if(OSX==10.8,1,1) HTTP(..) == anonymous-block.html anonymous-block-ref.html
+ skip-if(B2G) HTTP(..) == false-marker-overlap.html false-marker-overlap-ref.html
+ HTTP(..) == visibility-hidden.html visibility-hidden-ref.html
+-skip-if(B2G) HTTP(..) == block-padding.html block-padding-ref.html
++fails HTTP(..) == block-padding.html block-padding-ref.html
+ HTTP(..) == quirks-decorations.html quirks-decorations-ref.html
+ HTTP(..) == quirks-line-height.html quirks-line-height-ref.html
+ HTTP(..) == standards-decorations.html standards-decorations-ref.html
+@@ -18,7 +18,7 @@
+ skip-if(Android||B2G) == clipped-elements.html clipped-elements-ref.html
+ HTTP(..) == theme-overflow.html theme-overflow-ref.html
+ skip-if(B2G) HTTP(..) == table-cell.html table-cell-ref.html
+-HTTP(..) == two-value-syntax.html two-value-syntax-ref.html
++fails HTTP(..) == two-value-syntax.html two-value-syntax-ref.html
+ skip-if(B2G) HTTP(..) == single-value.html single-value-ref.html 
+-skip-if(B2G) HTTP(..) == atomic-under-marker.html atomic-under-marker-ref.html
++fails HTTP(..) == atomic-under-marker.html atomic-under-marker-ref.html
+ fuzzy(1,702) skip-if(Android||B2G) HTTP(..) == xulscroll.html xulscroll-ref.html
+Index: firefox-20.0~a2~hg20130206r123896/layout/reftests/box-shadow/reftest.list
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/layout/reftests/box-shadow/reftest.list	2013-02-06 13:25:47.046105673 +0000
++++ firefox-20.0~a2~hg20130206r123896/layout/reftests/box-shadow/reftest.list	2013-02-06 13:25:47.042105673 +0000
+@@ -11,7 +11,7 @@
+ == boxshadow-rounding.html boxshadow-rounding-ref.html
+ fails-if(Android) == boxshadow-button.html boxshadow-button-ref.html
+ fails-if(Android) == boxshadow-fileupload.html boxshadow-fileupload-ref.html
+-== boxshadow-inner-basic.html boxshadow-inner-basic-ref.svg
++fuzzy(1,4) == boxshadow-inner-basic.html boxshadow-inner-basic-ref.svg
+ random-if(layersGPUAccelerated) == boxshadow-mixed.html boxshadow-mixed-ref.html
+ random-if(d2d) == boxshadow-rounded-spread.html boxshadow-rounded-spread-ref.html
+ HTTP(..) == boxshadow-dynamic.xul boxshadow-dynamic-ref.xul

=== added file 'debian/patches/test-overrides/xpcshell-disable-failing-tests.patch'
--- debian/patches/test-overrides/xpcshell-disable-failing-tests.patch	1970-01-01 00:00:00 +0000
+++ debian/patches/test-overrides/xpcshell-disable-failing-tests.patch	2013-02-20 09:17:36 +0000
@@ -0,0 +1,68 @@
+Index: firefox-20.0~a2~hg20130206r123896/uriloader/exthandler/tests/unit/xpcshell.ini
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/uriloader/exthandler/tests/unit/xpcshell.ini	2013-02-06 14:07:02.074061695 +0000
++++ firefox-20.0~a2~hg20130206r123896/uriloader/exthandler/tests/unit/xpcshell.ini	2013-02-06 14:07:02.066061695 +0000
+@@ -5,6 +5,5 @@
+ [test_getTypeFromExtension_ext_to_type_mapping.js]
+ [test_getTypeFromExtension_with_empty_Content_Type.js]
+ [test_handlerService.js]
+-# Bug 676997: test consistently fails on Android
+-fail-if = os == "android"
++fail-if = true
+ [test_punycodeURIs.js]
+Index: firefox-20.0~a2~hg20130206r123896/extensions/cookie/test/unit/xpcshell.ini
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/extensions/cookie/test/unit/xpcshell.ini	2013-02-06 14:07:02.074061695 +0000
++++ firefox-20.0~a2~hg20130206r123896/extensions/cookie/test/unit/xpcshell.ini	2013-02-06 14:07:02.066061695 +0000
+@@ -9,6 +9,8 @@
+ [test_bug667087.js]
+ [test_cookies_async_failure.js]
+ [test_cookies_persistence.js]
++# Seems to fail randomly
++skip-if = true
+ [test_cookies_privatebrowsing.js]
+ [test_cookies_profile_close.js]
+ [test_cookies_read.js]
+Index: firefox-20.0~a2~hg20130206r123896/toolkit/components/downloads/test/unit/xpcshell.ini
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/toolkit/components/downloads/test/unit/xpcshell.ini	2013-02-06 14:07:02.074061695 +0000
++++ firefox-20.0~a2~hg20130206r123896/toolkit/components/downloads/test/unit/xpcshell.ini	2013-02-06 14:07:02.070061695 +0000
+@@ -15,8 +15,8 @@
+ skip-if = os == "android"
+ [test_download_manager.js]
+ [test_download_samename.js]
+-# Bug 676989: test hangs consistently on Android
+-skip-if = os == "android"
++# Seems to fail randomly
++skip-if = true
+ [test_guid.js]
+ [test_history_expiration.js]
+ [test_offline_support.js]
+Index: firefox-20.0~a2~hg20130206r123896/dom/tests/unit/xpcshell.ini
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/dom/tests/unit/xpcshell.ini	2013-02-06 14:07:02.074061695 +0000
++++ firefox-20.0~a2~hg20130206r123896/dom/tests/unit/xpcshell.ini	2013-02-06 14:07:02.070061695 +0000
+@@ -5,8 +5,8 @@
+ [test_bug319968.js]
+ [test_bug465752.js]
+ [test_geolocation_provider.js]
+-# Bug 684962: test hangs consistently on Android
+-skip-if = os == "android"
++# Seems to fail intermittently on Ubuntu
++skip-if = true
+ [test_geolocation_timeout.js]
+ [test_geolocation_timeout_wrap.js]
+ skip-if = os == "mac"
+Index: firefox-20.0~a2~hg20130206r123896/services/sync/tests/unit/xpcshell.ini
+===================================================================
+--- firefox-20.0~a2~hg20130206r123896.orig/services/sync/tests/unit/xpcshell.ini	2013-02-06 05:51:06.000000000 +0000
++++ firefox-20.0~a2~hg20130206r123896/services/sync/tests/unit/xpcshell.ini	2013-02-06 14:07:47.490060888 +0000
+@@ -130,6 +130,8 @@
+ [test_history_engine.js]
+ [test_history_store.js]
+ [test_history_tracker.js]
++# Seems to fail randomly
++skip-if = true
+ [test_places_guid_downgrade.js]
+ [test_password_store.js]
+ [test_password_tracker.js]

=== modified file 'debian/rules'
--- debian/rules	2012-10-26 11:55:58 +0000
+++ debian/rules	2013-02-20 09:17:36 +0000
@@ -1,7 +1,6 @@
 #!/usr/bin/make -f
 
 include $(CURDIR)/debian/build/mozvars.mk
-include $(CURDIR)/debian/config/branch.mk
 
 MOZ_PKG_BASENAME	:= firefox
 MOZ_APP			:= browser
@@ -30,81 +29,11 @@
 MOZ_SEARCHPLUGIN_DIR	= $(MOZ_LIBDIR)/distribution/searchplugins
 endif
 
-ifeq (firefox, $(MOZ_APP_NAME))
-ifneq (,$(filter lucid, $(DISTRIB_CODENAME)))
-PLUGIN_BREAKS := flashplugin-installer (<= 11.2.202.233ubuntu0.10.04.1), adobe-flashplugin (<= 11.1.102.63-0lucid1)
-PLUGIN_CONFLICTS := gcu-plugin (<= 0.10.12-2ubuntu1), gecko-mediaplayer (<= 0.9.9.2-1ubuntu0.10.04.1), \
-		    mozilla-gtk-vnc (<= 0.3.10-2ubuntu2.1), mozilla-opensc  (<= 0.11.12-1ubuntu3.2), \
-		    mozilla-plugin-pcmanx (<= 0.3.9-2ubuntu2), mozplugger (<= 1.13.3-1ubuntu1), \
-		    xine-plugin (<= 1.0.2-1ubuntu2), mozilla-virt-viewer (<= 0.0.3-6ubuntu7.xul191.1)
-else
-ifneq (,$(filter maverick, $(DISTRIB_CODENAME)))
-PLUGIN_BREAKS := flashplugin-installer (<= 11.2.202.228ubuntu0.10.10.1), adobe-flashplugin (<= 11.1.102.63-0maverick1)
-PLUGIN_CONFLICTS := gcu-plugin (<= 0.12.3-1), gecko-mediaplayer (<= 0.9.9.2-1ubuntu0.10.10.1), \
-		    mozilla-gtk-vnc (<= 0.4.1-3ubuntu2), mozilla-opensc (<= 0.11.13-1ubuntu2.1), \
-		    mozilla-plugin-pcmanx (<= 0.3.9-2ubuntu2), mozplugger (<= 1.14.1-2~exp3ubuntu1), \
-		    xine-plugin (<= 1.0.2-2ubuntu1)
-else
-ifneq (,$(filter natty, $(DISTRIB_CODENAME)))
-PLUGIN_BREAKS := flashplugin-installer (<= 11.2.202.233ubuntu0.11.04.2), adobe-flashplugin (<= 11.1.102.63-0natty1)
-PLUGIN_CONFLICTS := gcu-plugin (<=  0.12.7-1ubuntu1)
-else
-ifneq (,$(filter oneiric, $(DISTRIB_CODENAME)))
-PLUGIN_BREAKS := flashplugin-installer (<= 11.2.202.233ubuntu0.11.10.3), adobe-flashplugin (<= 11.1.102.63-0oneiric1)
-PLUGIN_CONFLICTS := gcu-plugin (<= 0.12.8-1ubuntu3)
-else
-ifneq (,$(filter precise, $(DISTRIB_CODENAME)))
-PLUGIN_BREAKS := flashplugin-installer (<= 11.1.102.63ubuntu1), adobe-flashplugin (<= 11.1.102.63-0precise1)
-PLUGIN_CONFLICTS := gcu-plugin (<= 0.12.10-1ubuntu1)
-endif
-endif
-endif
-endif
-endif
-endif
-
-ifeq (firefox, $(MOZ_PKG_NAME))
-ifeq (,$(filter lucid maverick natty oneiric precise, $(DISTRIB_CODENAME)))
-PKG_APP_REPLACES_ARGS	:= kubuntu-firefox-installer
-else
-ifeq (,$(filter lucid, $(DISTRIB_CODENAME)))
-PKG_APP_REPLACES_ARGS	:= abrowser, abrowser-branding, firefox-branding, kubuntu-firefox-installer
-PKG_APP_BREAKS_ARGS	:= abrowser (<= 4.0~b11+build3+nobinonly-0ubuntu1), abrowser-branding (<= 4.0~b11+build3+nobinonly-0ubuntu1), \
-			   firefox-branding (<= 4.0~b11+build3+nobinonly-0ubuntu1), $(PLUGIN_BREAKS)
-PKG_APP_CONFLICTS_ARGS	:= $(PLUGIN_CONFLICTS)
-else
-PKG_APP_PROVIDES_ARGS	:= firefox-3.6, firefox-3.5, firefox-3.0, firefox-2, firefox-2-dom-inspector, firefox-2-libthai
-PKG_APP_CONFLICTS_ARGS	:= firefox-3.6 (<< 3.6~hg20100117r33523), firefox-3.5 (<< 3.6~hg20100117r33523), \
-			   firefox-3.0 (<< 3.6~hg20100117r33523), firefox-3.6-gnome-support (<< 3.6~hg20100117r33523), \
-			   firefox-2 (<< 3), firefox-2-libthai (<< 3), firefox-2-dom-inspector (<< 3), \
-			   abrowser (<= 4.0~b11+build3+nobinonly-0ubuntu1), abrowser-branding (<= 4.0~b11+build3+nobinonly-0ubuntu1), \
-			   firefox-branding (<= 4.0~b11+build3+nobinonly-0ubuntu1), $(PLUGIN_CONFLICTS)
-PKG_APP_REPLACES_ARGS	:= firefox-3.6, firefox-3.5, firefox-3.0, firefox-3.6-gnome-support, firefox-2, firefox-2-libthai, \
-			   firefox-2-dom-inspector, abrowser, abrowser-branding, firefox-branding, kubuntu-firefox-installer
-PKG_APP_BREAKS_ARGS	:= $(PLUGIN_BREAKS)
-PKG_DEV_PROVIDES_ARGS	:= firefox-3.6-dev, firefox-3.5-dev, firefox-3.0-dev, firefox-2-dev
-PKG_DEV_REPLACES_ARGS	:= firefox-3.6-dev, firefox-3.5-dev, firefox-3.0-dev, firefox-2-dev
-PKG_DEV_CONFLICTS_ARGS	:= firefox-3.6-dev (<< 3.6~hg20100117r33523+nobinonly), firefox-3.5-dev (<< 3.6~hg20100117r33523), \
-			   firefox-3.0-dev (<< 3.6~hg20100117r33523), firefox-2-dev (<< 3)
-PKG_GS_PROVIDES_ARGS	:= firefox-3.6-gnome-support, firefox-3.5-gnome-support, firefox-3.0-gnome-support, firefox-2
-PKG_GS_CONFLICTS_ARGS	:= firefox-3.6-gnome-support (<< 3.6~hg20100117r33523+nobinonly), \
-			   firefox-3.5-gnome-support (<< 3.6~hg20100117r33523), firefox-3.0-gnome-support (<< 3.6~hg20100117r33523), \
-			   firefox-2 (<< 3)
-PKG_GS_REPLACES_ARGS	:= firefox-3.6-gnome-support, firefox-3.5-gnome-support, firefox-3.0-gnome-support, firefox-2-gnome-support
-PKG_DBG_CONFLICTS_ARGS	:= firefox-3.6-dbg (<< 3.6~hg20100117r33523+nobinonly), firefox-3.5-dbg (<< 3.6~hg20100117r33523), firefox-2-dbg (<< 3)
-PKG_DBG_REPLACES_ARGS	:= firefox-3.6-dbg, firefox-3.5-dbg, firefox-2-dbg
-PKG_DBG_PROVIDES_ARGS	:= firefox-3.6-dbg, firefox-3.5-dbg, firefox-2-dbg
-endif
-endif
-endif
-
-ifneq (,$(filter lucid, $(DISTRIB_CODENAME)))
-PKG_SUPPORT_SUGGESTS	:= $(MOZ_PKG_NAME)-gnome-support, kmozillahelper (>= 0.6)
+ifneq (,$(filter lucid, $(DISTRIB_CODENAME)))
+MOZ_PKG_SUPPORT_SUGGESTS	= $(MOZ_PKG_NAME)-gnome-support, kmozillahelper (>= 0.6)
 else
 ifneq (,$(filter lucid maverick natty oneiric, $(DISTRIB_CODENAME)))
-PKG_SUPPORT_SUGGESTS	:= $(MOZ_PKG_NAME)-gnome-support | firefox-kde-support
-else
-PKG_SUPPORT_SUGGESTS	:= $(MOZ_PKG_NAME)-gnome-support
+MOZ_PKG_SUPPORT_SUGGESTS	= $(MOZ_PKG_NAME)-gnome-support | firefox-kde-support
 endif
 endif
 
@@ -116,6 +45,9 @@
 	debian/apport/blacklist \
 	debian/apport/native-origins \
 	debian/apport/source_$(MOZ_PKG_NAME).py \
+	debian/testing/run_mochitest \
+	debian/testing/run_reftest \
+	debian/testing/run_xpcshell_tests \
 	$(NULL)
 
 MOZ_APPNAME_SUBST_FILES = \
@@ -131,6 +63,12 @@
 
 include $(CURDIR)/debian/build/mozbuild.mk
 
+MOZ_EXECUTABLES_$(MOZ_PKG_NAME)-testsuite =	$(MOZ_TESTDIR)/run_mochitest \
+						$(MOZ_TESTDIR)/run_reftest \
+						$(MOZ_TESTDIR)/run_xpcshell_tests \
+						$(MOZ_LIBDIR)/xpcshell \
+						$(NULL)
+
 debian/usr.bin.firefox.in:
 	if [ '$(DISTRIB_VERSION_MAJOR)$(DISTRIB_VERSION_MINOR)' -ge '1204' ]; then \
 		cp $(CURDIR)/debian/usr.bin.firefox.apparmor.12.04 $(CURDIR)/debian/usr.bin.firefox.in ; \
@@ -144,7 +82,105 @@
 		cp $(CURDIR)/debian/usr.bin.firefox.apparmor.9.10 $(CURDIR)/debian/usr.bin.firefox.in ; \
 	fi
 
-common-binary-fixup-arch::
+ifeq (firefox, $(MOZ_APP_NAME))
+ifneq (,$(filter lucid, $(DISTRIB_CODENAME)))
+PLUGIN_BREAKS := flashplugin-installer (<= 11.2.202.233ubuntu0.10.04.1), adobe-flashplugin (<= 11.1.102.63-0lucid1)
+PLUGIN_CONFLICTS := gcu-plugin (<= 0.10.12-2ubuntu1), gecko-mediaplayer (<= 0.9.9.2-1ubuntu0.10.04.1), \
+		    mozilla-gtk-vnc (<= 0.3.10-2ubuntu2.1), mozilla-opensc  (<= 0.11.12-1ubuntu3.2), \
+		    mozilla-plugin-pcmanx (<= 0.3.9-2ubuntu2), mozplugger (<= 1.13.3-1ubuntu1), \
+		    xine-plugin (<= 1.0.2-1ubuntu2), mozilla-virt-viewer (<= 0.0.3-6ubuntu7.xul191.1)
+else
+ifneq (,$(filter maverick, $(DISTRIB_CODENAME)))
+PLUGIN_BREAKS := flashplugin-installer (<= 11.2.202.228ubuntu0.10.10.1), adobe-flashplugin (<= 11.1.102.63-0maverick1)
+PLUGIN_CONFLICTS := gcu-plugin (<= 0.12.3-1), gecko-mediaplayer (<= 0.9.9.2-1ubuntu0.10.10.1), \
+		    mozilla-gtk-vnc (<= 0.4.1-3ubuntu2), mozilla-opensc (<= 0.11.13-1ubuntu2.1), \
+		    mozilla-plugin-pcmanx (<= 0.3.9-2ubuntu2), mozplugger (<= 1.14.1-2~exp3ubuntu1), \
+		    xine-plugin (<= 1.0.2-2ubuntu1)
+else
+ifneq (,$(filter natty, $(DISTRIB_CODENAME)))
+PLUGIN_BREAKS := flashplugin-installer (<= 11.2.202.233ubuntu0.11.04.2), adobe-flashplugin (<= 11.1.102.63-0natty1)
+PLUGIN_CONFLICTS := gcu-plugin (<=  0.12.7-1ubuntu1)
+else
+ifneq (,$(filter oneiric, $(DISTRIB_CODENAME)))
+PLUGIN_BREAKS := flashplugin-installer (<= 11.2.202.233ubuntu0.11.10.3), adobe-flashplugin (<= 11.1.102.63-0oneiric1)
+PLUGIN_CONFLICTS := gcu-plugin (<= 0.12.8-1ubuntu3)
+else
+ifneq (,$(filter precise, $(DISTRIB_CODENAME)))
+PLUGIN_BREAKS := flashplugin-installer (<= 11.1.102.63ubuntu1), adobe-flashplugin (<= 11.1.102.63-0precise1)
+PLUGIN_CONFLICTS := gcu-plugin (<= 0.12.10-1ubuntu1)
+endif
+endif
+endif
+endif
+endif
+endif
+
+WRITE_SUBSTVARS = $(shell echo "$(2)=$(3)" | sed -n 's/[ \t\n]\+/ /g p' >> debian/$(1).substvars)
+
+ifeq (firefox, $(MOZ_PKG_NAME))
+ifeq (,$(filter lucid maverick natty oneiric precise, $(DISTRIB_CODENAME)))
+install/firefox::
+	$(call WRITE_SUBSTVARS,firefox,transitional:Replaces,kubuntu-firefox-installer)
+else
+ifeq (,$(filter lucid, $(DISTRIB_CODENAME)))
+FIREFOX_REPLACES = abrowser, abrowser-branding, firefox-branding, kubuntu-firefox-installer
+FIREFOX_BREAKS = abrowser (<= 4.0~b11+build3+nobinonly-0ubuntu1), abrowser-branding (<= 4.0~b11+build3+nobinonly-0ubuntu1), \
+		 firefox-branding (<= 4.0~b11+build3+nobinonly-0ubuntu1), $(PLUGIN_BREAKS)
+install/firefox::
+	$(call WRITE_SUBSTVARS,firefox,transitional:Replaces,$(FIREFOX_REPLACES))
+	$(call WRITE_SUBSTVARS,firefox,transitional:Breaks,$(FIREFOX_BREAKS))
+	$(call WRITE_SUBSTVARS,firefox,transitional:Conflicts,$(PLUGIN_CONFLICTS))
+else
+FIREFOX_PROVIDES = firefox-3.6, firefox-3.5, firefox-3.0, firefox-2, firefox-2-dom-inspector, firefox-2-libthai
+FIREFOX_CONFLICTS = firefox-3.6 (<< 3.6~hg20100117r33523), firefox-3.5 (<< 3.6~hg20100117r33523), firefox-3.0 (<< 3.6~hg20100117r33523), \
+		    firefox-3.6-gnome-support (<< 3.6~hg20100117r33523), firefox-2 (<< 3), firefox-2-libthai (<< 3), \
+		    firefox-2-dom-inspector (<< 3), abrowser (<= 4.0~b11+build3+nobinonly-0ubuntu1), \
+		    abrowser-branding (<= 4.0~b11+build3+nobinonly-0ubuntu1), firefox-branding (<= 4.0~b11+build3+nobinonly-0ubuntu1), \
+		    $(PLUGIN_CONFLICTS)
+FIREFOX_REPLACES = firefox-3.6, firefox-3.5, firefox-3.0, firefox-3.6-gnome-support, firefox-2, firefox-2-libthai, \
+		   firefox-2-dom-inspector, abrowser, abrowser-branding, firefox-branding, kubuntu-firefox-installer
+install/firefox::
+	$(call WRITE_SUBSTVARS,firefox,transitional:Provides,$(FIREFOX_PROVIDES))
+	$(call WRITE_SUBSTVARS,firefox,transitional:Conflicts,$(FIREFOX_CONFLICTS))
+	$(call WRITE_SUBSTVARS,firefox,transitional:Replaces,$(FIREFOX_REPLACES))
+	$(call WRITE_SUBSTVARS,firefox,transitional:Breaks,$(PLUGIN_BREAKS))
+
+DEV_PROVIDES = firefox-3.6-dev, firefox-3.5-dev, firefox-3.0-dev, firefox-2-dev
+DEV_REPLACES = firefox-3.6-dev, firefox-3.5-dev, firefox-3.0-dev, firefox-2-dev
+DEV_CONFLICTS = firefox-3.6-dev (<< 3.6~hg20100117r33523+nobinonly), firefox-3.5-dev (<< 3.6~hg20100117r33523), \
+		firefox-3.0-dev (<< 3.6~hg20100117r33523), firefox-2-dev (<< 3)
+install/firefox-dev::
+	$(call WRITE_SUBSTVARS,firefox-dev,transitional:Provides,$(DEV_PROVIDES))
+	$(call WRITE_SUBSTVARS,firefox-dev,transitional:Replaces,$(DEV_REPLACES))
+	$(call WRITE_SUBSTVARS,firefox-dev,transitional:Conflicts,$(DEV_CONFLICTS))
+
+GS_PROVIDES = firefox-3.6-gnome-support, firefox-3.5-gnome-support, firefox-3.0-gnome-support, firefox-2
+GS_REPLACES = firefox-3.6-gnome-support, firefox-3.5-gnome-support, firefox-3.0-gnome-support, firefox-2-gnome-support
+GS_CONFLICTS = firefox-3.6-gnome-support (<< 3.6~hg20100117r33523+nobinonly), firefox-3.5-gnome-support (<< 3.6~hg20100117r33523), \
+	       firefox-3.0-gnome-support (<< 3.6~hg20100117r33523), firefox-2 (<< 3)
+install/firefox-gnome-support::
+	$(call WRITE_SUBSTVARS,firefox-gnome-support,transitional:Provides,$(GS_PROVIDES))
+	$(call WRITE_SUBSTVARS,firefox-gnome-support,transitional:Replaces,$(GS_REPLACES))
+	$(call WRITE_SUBSTVARS,firefox-gnome-support,transitional:Conflicts,$(GS_CONFLICTS))
+
+DBG_PROVIDES = firefox-3.6-dbg, firefox-3.5-dbg, firefox-2-dbg
+DBG_REPLACES = firefox-3.6-dbg, firefox-3.5-dbg, firefox-2-dbg
+DBG_CONFLICTS = firefox-3.6-dbg (<< 3.6~hg20100117r33523+nobinonly), firefox-3.5-dbg (<< 3.6~hg20100117r33523), firefox-2-dbg (<< 3)
+install/firefox-dbg::
+	$(call WRITE_SUBSTVARS,firefox-dbg,transitional:Provides,$(DBG_PROVIDES))
+	$(call WRITE_SUBSTVARS,firefox-dbg,transitional:Replaces,$(DBG_REPLACES))
+	$(call WRITE_SUBSTVARS,firefox-dbg,transitional:Conflicts,$(DBG_CONFLICTS))
+endif
+endif
+endif
+
+$(patsubst %,binary-post-install/$(MOZ_PKG_NAME)-locale-%,$(MOZ_LANGPACK_TARGETS)):: binary-post-install/$(MOZ_PKG_NAME)-locale-%: install-webapprt-langpack-links-%
+
+install-webapprt-langpack-links-%: XPIS = $(notdir $(wildcard debian/$(MOZ_PKG_NAME)-locale-$*/$(MOZ_ADDONDIR)/extensions/*.xpi))
+install-webapprt-langpack-links-%:
+	$(foreach xpi,$(XPIS),dh_link -p$(MOZ_PKG_NAME)-locale-$* $(MOZ_ADDONDIR)/extensions/$(xpi) $(MOZ_LIBDIR)/webapprt/extensions/$(xpi);)
+
+make-langpack-preinsts::
 	@while read line ; \
 	do \
 		line=`echo $$line | sed 's/#.*//' | sed '/^$$/d'` ; \
@@ -155,16 +191,7 @@
 		fi \
 	done < $(CURDIR)/debian/config/locales.shipped
 
-LOCALE_PACKAGES := $(shell cat $(CURDIR)/debian/control | grep "^Package:[[:space:]]*$(MOZ_PKG_NAME)-locale\-" | sed -n -e 's/^Package\:[[:space:]]*\([^[:space:]]*\)/\1/ p')
-
-common-binary-post-install-arch:: install-webapprt-langpack-links
-
-install-webapprt-langpack-links: $(foreach target, $(LOCALE_PACKAGES), install-webapprt-langpack-link-$(target))
-install-webapprt-langpack-link-%: XPIS = $(notdir $(wildcard debian/$*/$(MOZ_ADDONDIR)/extensions/*.xpi))
-install-webapprt-langpack-link-%:
-	$(foreach xpi,$(XPIS),dh_link -p$* $(MOZ_ADDONDIR)/extensions/$(xpi) $(MOZ_LIBDIR)/webapprt/extensions/$(xpi);)
-
-pre-build::
+pre-build:: make-langpack-preinsts
 	@cp $(DEB_SRCDIR)/toolkit/content/widgets/dialog.xml $(DEB_SRCDIR)/toolkit/content/widgets/dialog-kde.xml
 	@cp $(DEB_SRCDIR)/toolkit/content/widgets/preferences.xml $(DEB_SRCDIR)/toolkit/content/widgets/preferences-kde.xml
 	@cp $(DEB_SRCDIR)/browser/base/content/browser.xul $(DEB_SRCDIR)/browser/base/content/browser-kde.xul
@@ -193,3 +220,5 @@
 	rm -f $(DEB_SRCDIR)/toolkit/content/widgets/dialog-kde.xml
 	rm -f $(DEB_SRCDIR)/toolkit/content/widgets/preferences-kde.xml
 	rm -f $(DEB_SRCDIR)/browser/base/content/browser-kde.xul
+
+.PHONY: make-langpack-preinsts

=== added directory 'debian/searchplugins/ast'
=== added file 'debian/searchplugins/ast/list.txt'
--- debian/searchplugins/ast/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/ast/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/be'
=== added file 'debian/searchplugins/be/list.txt'
--- debian/searchplugins/be/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/be/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/bn-BD'
=== added file 'debian/searchplugins/bn-BD/list.txt'
--- debian/searchplugins/bn-BD/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/bn-BD/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/br/list.txt'
--- debian/searchplugins/br/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/br/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../fr/amazon-france
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/bs'
=== added file 'debian/searchplugins/bs/list.txt'
--- debian/searchplugins/bs/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/bs/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google*

=== added directory 'debian/searchplugins/ca'
=== added file 'debian/searchplugins/ca/list.txt'
--- debian/searchplugins/ca/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/ca/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== removed file 'debian/searchplugins/compute-overrides.json'
--- debian/searchplugins/compute-overrides.json	2012-08-28 10:59:23 +0000
+++ debian/searchplugins/compute-overrides.json	1970-01-01 00:00:00 +0000
@@ -1,26 +0,0 @@
-{
-    "matches": [
-        {
-            "Url": {
-                "template": "https?://www\\.google\\.[^/]+/search.*"
-            }
-        },
-        {
-            "Url": {
-                "template": "https?://www\\.amazon.*"
-            }
-        },
-        {
-            "Url": {
-                "template": "https?://.*baidu\\.com.*"
-            }
-        }
-    ],
-    "ignore": [
-        {
-            "Url": {
-                "template": "https?://zhidao\\.baidu\\.com.*"
-            }
-        }
-    ]
-}

=== added directory 'debian/searchplugins/cs'
=== added file 'debian/searchplugins/cs/list.txt'
--- debian/searchplugins/cs/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/cs/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/csb'
=== added file 'debian/searchplugins/csb/list.txt'
--- debian/searchplugins/csb/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/csb/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google*

=== modified file 'debian/searchplugins/cy/list.txt'
--- debian/searchplugins/cy/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/cy/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== modified file 'debian/searchplugins/el/list.txt'
--- debian/searchplugins/el/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/el/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/es-CL'
=== added file 'debian/searchplugins/es-CL/list.txt'
--- debian/searchplugins/es-CL/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/es-CL/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/es-ES'
=== added file 'debian/searchplugins/es-ES/list.txt'
--- debian/searchplugins/es-ES/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/es-ES/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/es-MX'
=== added file 'debian/searchplugins/es-MX/list.txt'
--- debian/searchplugins/es-MX/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/es-MX/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/et'
=== added file 'debian/searchplugins/et/list.txt'
--- debian/searchplugins/et/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/et/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/eu/list.txt'
--- debian/searchplugins/eu/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/eu/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/fi'
=== added file 'debian/searchplugins/fi/list.txt'
--- debian/searchplugins/fi/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/fi/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/fy-NL'
=== added file 'debian/searchplugins/fy-NL/list.txt'
--- debian/searchplugins/fy-NL/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/fy-NL/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/ga-IE/list.txt'
--- debian/searchplugins/ga-IE/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/ga-IE/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== modified file 'debian/searchplugins/gd/list.txt'
--- debian/searchplugins/gd/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/gd/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== modified file 'debian/searchplugins/gl/list.txt'
--- debian/searchplugins/gl/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/gl/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/gu-IN'
=== added file 'debian/searchplugins/gu-IN/list.txt'
--- debian/searchplugins/gu-IN/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/gu-IN/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/he'
=== added file 'debian/searchplugins/he/list.txt'
--- debian/searchplugins/he/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/he/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/hi-IN'
=== added file 'debian/searchplugins/hi-IN/list.txt'
--- debian/searchplugins/hi-IN/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/hi-IN/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/hr/list.txt'
--- debian/searchplugins/hr/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/hr/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/hu'
=== added file 'debian/searchplugins/hu/list.txt'
--- debian/searchplugins/hu/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/hu/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/id'
=== added file 'debian/searchplugins/id/list.txt'
--- debian/searchplugins/id/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/id/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/it/amazon-it.xml'
--- debian/searchplugins/it/amazon-it.xml	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/it/amazon-it.xml	2013-02-20 09:17:36 +0000
@@ -6,7 +6,7 @@
 <Url type="text/html" method="GET" template="http://www.amazon.it/exec/obidos/external-search/">
   <Param name="field-keywords" value="{searchTerms}"/>
   <Param name="mode" value="blended"/>
-  <Param name="tag" value="firefoxit-21"/>
+  <Param name="tag" value="wwwcanoniccom-20"/>
   <Param name="sourceid" value="Mozilla-search"/>
 </Url>
 <SearchForm>http://www.amazon.it/</SearchForm>

=== added directory 'debian/searchplugins/kk'
=== added file 'debian/searchplugins/kk/list.txt'
--- debian/searchplugins/kk/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/kk/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/ko'
=== added file 'debian/searchplugins/ko/list.txt'
--- debian/searchplugins/ko/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/ko/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/list.txt'
--- debian/searchplugins/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 amazon*
 google*
-
-[Additions]
-duckduckgo

=== added directory 'debian/searchplugins/lv'
=== added file 'debian/searchplugins/lv/list.txt'
--- debian/searchplugins/lv/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/lv/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/mai'
=== added file 'debian/searchplugins/mai/list.txt'
--- debian/searchplugins/mai/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/mai/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/ml'
=== added file 'debian/searchplugins/ml/list.txt'
--- debian/searchplugins/ml/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/ml/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/mn'
=== added file 'debian/searchplugins/mn/list.txt'
--- debian/searchplugins/mn/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/mn/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google*

=== modified file 'debian/searchplugins/nb-NO/list.txt'
--- debian/searchplugins/nb-NO/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/nb-NO/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/nl'
=== added file 'debian/searchplugins/nl/list.txt'
--- debian/searchplugins/nl/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/nl/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/nn-NO/list.txt'
--- debian/searchplugins/nn-NO/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/nn-NO/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== modified file 'debian/searchplugins/oc/list.txt'
--- debian/searchplugins/oc/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/oc/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../fr/amazon-france
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/pa-IN'
=== added file 'debian/searchplugins/pa-IN/list.txt'
--- debian/searchplugins/pa-IN/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/pa-IN/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/pl'
=== added file 'debian/searchplugins/pl/list.txt'
--- debian/searchplugins/pl/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/pl/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/pt-BR'
=== added file 'debian/searchplugins/pt-BR/list.txt'
--- debian/searchplugins/pt-BR/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/pt-BR/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/pt-PT/list.txt'
--- debian/searchplugins/pt-PT/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/pt-PT/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/ru'
=== added file 'debian/searchplugins/ru/list.txt'
--- debian/searchplugins/ru/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/ru/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/sk'
=== added file 'debian/searchplugins/sk/list.txt'
--- debian/searchplugins/sk/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/sk/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/sl'
=== added file 'debian/searchplugins/sl/list.txt'
--- debian/searchplugins/sl/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/sl/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/sr/list.txt'
--- debian/searchplugins/sr/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/sr/list.txt	2013-02-20 09:17:36 +0000
@@ -1,6 +1,6 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 ../en-GB/amazon-en-GB
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/sv-SE'
=== added file 'debian/searchplugins/sv-SE/list.txt'
--- debian/searchplugins/sv-SE/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/sv-SE/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/ta'
=== added file 'debian/searchplugins/ta/list.txt'
--- debian/searchplugins/ta/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/ta/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/uk'
=== added file 'debian/searchplugins/uk/list.txt'
--- debian/searchplugins/uk/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/uk/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/searchplugins/vi'
=== added file 'debian/searchplugins/vi/list.txt'
--- debian/searchplugins/vi/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/vi/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== modified file 'debian/searchplugins/zh-CN/list.txt'
--- debian/searchplugins/zh-CN/list.txt	2012-07-23 11:32:05 +0000
+++ debian/searchplugins/zh-CN/list.txt	2013-02-20 09:17:36 +0000
@@ -1,7 +1,7 @@
+[Additions]
+duckduckgo
+
 [Overrides]
 amazondotcn
 baidu
-google*
-
-[Additions]
-duckduckgo
+google

=== added directory 'debian/searchplugins/zh-TW'
=== added file 'debian/searchplugins/zh-TW/list.txt'
--- debian/searchplugins/zh-TW/list.txt	1970-01-01 00:00:00 +0000
+++ debian/searchplugins/zh-TW/list.txt	2013-02-20 09:17:36 +0000
@@ -0,0 +1,5 @@
+[Additions]
+duckduckgo
+
+[Overrides]
+google

=== added directory 'debian/testing'
=== added file 'debian/testing/mochitest-chrome.json'
--- debian/testing/mochitest-chrome.json	1970-01-01 00:00:00 +0000
+++ debian/testing/mochitest-chrome.json	2013-02-20 09:17:36 +0000
@@ -0,0 +1,59 @@
+{
+ "runtests": {},
+ "excludetests": {
+  "a11y/accessible/attributes/test_text.html": "FAILS",
+  "a11y/accessible/events/test_focus_general.xul": "FAILS",
+  "a11y/accessible/events/test_textattrchange.html": "HANGS",
+  "browser/browser/base/content/test/browser_allTabsPanel.js": "HANGS INTERMITTENT",
+  "browser/browser/base/content/test/browser_canonizeURL.js": "FAILS UBUNTU-SEARCHPLUGINS",
+  "browser/browser/base/content/test/browser_clearplugindata.js": "FAILS",
+  "browser/browser/base/content/test/browser_keywordSearch.js": "FAILS UBUNTU-SEARCHPLUGINS",
+  "browser/browser/base/content/test/social/browser_social_chatwindow.js": "HANGS",
+  "browser/browser/devtools/debugger/test/browser_dbg_createChrome.js": "FAILS",
+  "browser/browser/devtools/inspector/test/browser_inspector_initialization.js": "FAILS",
+  "browser/toolkit/mozapps/extensions/test/browser/browser_bug557956.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser/browser_bug562797.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser/browser_bug572561.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser/browser_bug577990.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser/browser_checkAddonCompatibility.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser/browser_details.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser/browser_select_confirm.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser/browser_select_selection.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser-window/browser_bug562797.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser-window/browser_bug572561.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser-window/browser_bug577990.js": "FAILS UBUNTU-EXTENSIONS",
+  "browser/toolkit/mozapps/extensions/test/browser-window/browser_details.js": "FAILS UBUNTU-EXTENSIONS",
+  "chrome/content/canvas/test/chrome/test_webgl_debug_renderer_info.html": "UNSUPPORTED",
+  "chrome/dom/tests/mochitest/chrome/test_resize_move_windows.xul": "HANGS",
+  "chrome/editor/composer/test/test_bug338427.html": "FAILS",
+  "chrome/editor/composer/test/test_bug678842.html": "FAILS",
+  "chrome/editor/libeditor/base/tests/test_dragdrop.html": "FAILS",
+  "chrome/editor/libeditor/html/tests/test_bug366682.html": "FAILS",
+  "chrome/editor/libeditor/text/tests/test_bug636465.xul": "FAILS",
+  "chrome/extensions/spellcheck/tests/chrome/test_add_remove_dictionaries.xul": "FAILS",
+  "chrome/layout/inspector/tests/chrome/test_bug467669.xul": "FAILS",
+  "chrome/layout/inspector/tests/chrome/test_bug695639.xul": "FAILS",
+  "chrome/layout/xul/test/test_bug159346.xul": "FAILS",
+  "chrome/layout/xul/test/test_bug703150.xul": "FAILS",
+  "chrome/test_sanityChromeUtils.xul": "FAILS",
+  "chrome/toolkit/components/osfile/tests/mochi/test_osfile_async.xul": "FAILS PERMS",
+  "chrome/toolkit/components/osfile/tests/mochi/test_osfile_back.xul": "FAILS PERMS",
+  "chrome/toolkit/components/osfile/tests/mochi/test_osfile_front.xul": "FAILS PERMS",
+  "chrome/toolkit/components/perf/test_pm.xul": "FAILS",
+  "chrome/toolkit/components/toolkit/components/ctypes/tests/test_ctypes.xul": "FAILS UBUNTU-PATCH",
+  "chrome/toolkit/components/viewsource/test/test_428653.xul": "FAILS",
+  "chrome/toolkit/content/tests/chrome/test_bug557987.xul": "FAILS",
+  "chrome/toolkit/content/tests/chrome/test_bug562554.xul": "FAILS",
+  "chrome/toolkit/content/tests/chrome/test_button.xul": "FAILS",
+  "chrome/toolkit/content/tests/chrome/test_colorpicker_popup.xul": "HANGS",
+  "chrome/toolkit/content/tests/chrome/test_contextmenu_list.xul": "HANGS",
+  "chrome/toolkit/content/tests/chrome/test_datepicker.xul": "FAILS",
+  "chrome/toolkit/content/tests/chrome/test_deck.xul": "FAILS",
+  "chrome/toolkit/content/tests/chrome/test_largemenu.xul": "FAILS",
+  "chrome/toolkit/content/tests/chrome/test_menuchecks.xul": "HANGS",
+  "chrome/toolkit/content/tests/chrome/test_scaledrag.xul": "FAILS",
+  "chrome/toolkit/content/tests/chrome/test_textbox_dictionary.xul": "FAILS",
+  "chrome/toolkit/mozapps/downloads/tests/chrome/test_bug_462172.xul": "HANGS PERMS",
+  "chrome/toolkit/mozapps/downloads/tests/chrome/test_unknownContentType_dialog_layout.xul": "FAILS"
+ }
+}

=== added file 'debian/testing/mochitest.json'
--- debian/testing/mochitest.json	1970-01-01 00:00:00 +0000
+++ debian/testing/mochitest.json	2013-02-20 09:17:36 +0000
@@ -0,0 +1,18 @@
+{
+ "runtests": {},
+ "excludetests": {
+  "content/base/test/test_mixed_content_blocker_bug803225.html": "FAILS",
+  "content/canvas/test/webgl/test_webgl_conformance_test_suite.html": "UNSUPPORTED",
+  "content/media/test/test_a4_tone.html": "FAILS",
+  "docshell/test/navigation/test_bug13871.html": "FAILS",
+  "docshell/test/navigation/test_not-opener.html": "FAILS",
+  "dom/tests/mochitest/bugs/test_bug458091.html": "FAILS",
+  "dom/tests/mochitest/geolocation/": "FAILS",
+  "editor/libeditor/html/tests/test_bug432225.html": "FAILS",
+  "editor/libeditor/html/tests/test_bug484181.html": "FAILS",
+  "editor/libeditor/text/tests/test_bug596333.html": "FAILS",
+  "parser/htmlparser/tests/mochitest/test_bug672453.html": "FAILS",
+  "toolkit/content/tests/widgets/test_contextmenu_nested.xul": "FAILS",
+  "toolkit/content/tests/widgets/test_videocontrols.html": "FAILS"
+ }
+}

=== added file 'debian/testing/run_mochitest.in'
--- debian/testing/run_mochitest.in	1970-01-01 00:00:00 +0000
+++ debian/testing/run_mochitest.in	2013-02-20 09:17:36 +0000
@@ -0,0 +1,69 @@
+#!/usr/bin/python
+
+import sys
+import os.path
+from testrunhelper import TestRunHelper
+
+class MochitestHelper(TestRunHelper):
+  def __init__(self):
+    PASSTHROUGH_ARGS = [
+      '--a11y',
+      '--browser-chrome',
+      '--chrome',
+      '--console-level',
+      '--ipcplugins',
+      '--install-extension',
+      '--log-file',
+      '--file-level',
+      '--setpref',
+      '--test-manifest',
+      '--test-path',
+      '--timeout',
+      '--xunit-file',
+      '--xunit-name',
+      '--debugger',
+      '--debugger-args',
+      '--debugger-interactive',
+    ]
+
+    TestRunHelper.__init__(self, 'mochitest/runtests.py',
+                           lambda g: g['MochitestOptions'](g['Automation'](), g['__file__']),
+                           pass_args=PASSTHROUGH_ARGS,
+                           root='/@MOZ_TESTDIR@',
+                           need_x=True, need_dbus=True, need_wm=True)
+
+    self.add_option('--no-autorun',
+                    action='store_true', dest='noAutorun', default=False,
+                    help="Don't start running tests when the application starts")
+    self.add_option('--no-close-when-done',
+                    action='store_true', dest='noCloseWhenDone',
+                    help="Don't close the application when tests have finished running")
+
+def main():
+  DEFAULTS = {
+    '--appname': lambda: os.path.join(helper.root, 'bin', '@MOZ_APP_NAME@'),
+    '--console-level': 'INFO',
+    '--utility-path': lambda: os.path.join(helper.root, 'bin'),
+    '--certificate-path': lambda: os.path.join(helper.root, 'certs')
+  }
+
+  def pre_run_cb(options, args):
+    if not options.noAutorun:
+      sys.argv.append('--autorun')
+    if not options.noCloseWhenDone:
+      sys.argv.append('--close-when-done')
+    if '--test-manifest' not in sys.argv:
+      if '--a11y' in sys.argv or \
+         '--browser-chrome' in sys.argv or \
+         '--chrome' in sys.argv:
+        manifest = 'mochitest-chrome.json'
+      else:
+        manifest = 'mochitest.json'
+      if os.path.exists(os.path.join(helper.root, 'mochitest', manifest)):
+          sys.argv.extend(['--test-manifest', manifest])
+
+  helper = MochitestHelper()
+  sys.exit(helper.run(defaults=DEFAULTS, pre_run_cb=pre_run_cb))
+
+if __name__ == '__main__':
+  main()

=== added file 'debian/testing/run_reftest.in'
--- debian/testing/run_reftest.in	1970-01-01 00:00:00 +0000
+++ debian/testing/run_reftest.in	2013-02-20 09:17:36 +0000
@@ -0,0 +1,43 @@
+#!/usr/bin/python
+
+import sys
+import os.path
+from testrunhelper import TestRunHelper
+
+class ReftestHelper(TestRunHelper):
+  def __init__(self):
+    PASSTHROUGH_ARGS = [
+      '--extra-profile-file',
+      '--install-extension',
+      '--log-file',
+      '--timeout',
+      '--debugger',
+      '--debugger-args',
+      '--debugger-interactive',
+      '--xunit-file',
+      '--xunit-name',
+      '--tests-root-dir'
+    ]
+
+    TestRunHelper.__init__(self, 'reftest/runreftest.py',
+                           lambda g: g['ReftestOptions'](g['Automation']()),
+                           pass_args=PASSTHROUGH_ARGS,
+                           root='/@MOZ_TESTDIR@',
+                           need_x=True, need_dbus=True)
+
+def main():
+  DEFAULTS = {
+    '--appname': lambda: os.path.join(helper.root, 'bin', '@MOZ_APP_NAME@'),
+    '--utility-path': lambda: os.path.join(helper.root, 'bin')
+  }
+
+  def pre_run_cb(options, args):
+    if '--xunit-file' in sys.argv and '--tests-root-dir' not in sys.argv and \
+       args[0].startswith(helper.root):
+      sys.argv.extend(['--tests-root-dir', os.path.join(helper.root, 'reftest', 'tests')])
+
+  helper = ReftestHelper()
+  sys.exit(helper.run(defaults=DEFAULTS, pre_run_cb=pre_run_cb))
+
+if __name__ == '__main__':
+  main()

=== added file 'debian/testing/run_xpcshell_tests.in'
--- debian/testing/run_xpcshell_tests.in	1970-01-01 00:00:00 +0000
+++ debian/testing/run_xpcshell_tests.in	2013-02-20 09:17:36 +0000
@@ -0,0 +1,81 @@
+#!/usr/bin/python
+
+import sys
+import os.path
+from testrunhelper import TestRunHelper
+
+class XPCShellTestsHelper(TestRunHelper):
+  def __init__(self):
+    PASSTHROUGH_ARGS = [
+      '--interactive',
+      '--verbose',
+      '--manifest',
+      '--debugger',
+      '--debugger-args',
+      '--debugger-interactive',
+      '--testing-modules-dir',
+      '--tests-root-dir',
+      '--xunit-file',
+      '--xunit-suite-name'
+    ]
+
+    root = '/@MOZ_TESTDIR@'
+    args = iter(sys.argv[1:])
+    while True:
+      try:
+        arg = args.next()
+      except StopIteration:
+        break
+
+      if arg == '--harness-root-dir':
+        try:
+          root = args.next()
+          break
+        except StopIteration:
+          pass
+
+    TestRunHelper.__init__(self, 'xpcshell/runxpcshelltests.py',
+                           lambda g: g['XPCShellOptions'](),
+                           pass_args=PASSTHROUGH_ARGS,
+                           paths=[], root=root,
+                           need_x=True, need_dbus=True)
+
+    self.add_option('--harness-root-dir',
+                    dest='root',
+                    help='Override the path to the test harness installation')
+    self.add_option('--xpcshell',
+                    dest='xpcshell', default=None,
+                    help='Override the path to the xpcshell binary')
+    self.add_option('--logfiles',
+                    action='store_true', dest='logfiles', default=False,
+                    help='Create log files')
+
+def main():
+  abspath = lambda x: os.path.join(helper.root, x)
+
+  DEFAULTS = {
+    '--build-info-json': lambda: abspath('python/mozinfo.json') if os.path.exists(abspath('python/mozinfo.json')) else abspath('xpcshell/mozinfo.json')
+  }
+
+  def pre_run_cb(options, args):
+    if not options.logfiles:
+      sys.argv.append('--no-logfiles')
+
+    if '--xunit-file' in sys.argv and '--tests-root-dir' not in sys.argv and \
+       '--manifest' in sys.argv:
+        sys.argv.extend(['--tests-root-dir', os.path.dirname(options.manifest)])
+
+    for arg in args:
+      if arg.endswith('.js'):
+        if len(args) > 1:
+          raise Exception('Can only specify one file at a time')
+        sys.argv.extend(['--test-path', os.path.basename(arg)])
+        args[0] = os.path.dirname(arg)
+
+    sys.argv.append(os.path.join(helper.root, 'bin', 'xpcshell') if options.xpcshell == None else options.xpcshell)
+
+  helper = XPCShellTestsHelper()
+  sys.exit(helper.run(defaults=DEFAULTS, pre_run_cb=pre_run_cb))
+
+if __name__ == '__main__':
+  main()

=== added file 'debian/testing/testrunhelper.py'
--- debian/testing/testrunhelper.py	1970-01-01 00:00:00 +0000
+++ debian/testing/testrunhelper.py	2013-02-20 09:17:36 +0000
@@ -0,0 +1,157 @@
+#!/usr/bin/python
+
+import os
+import os.path
+import sys
+from optparse import OptionParser
+from subprocess import Popen
+import tempfile
+import shutil
+
+skel = {
+  '.config/user-dirs.dirs':
+'''# This file is written by xdg-user-dirs-update
+# If you want to change or add directories, just edit the line you're
+# interested in. All local changes will be retained on the next run
+# Format is XDG_xxx_DIR="$HOME/yyy", where yyy is a shell-escaped
+# homedir-relative path, or XDG_xxx_DIR="/yyy", where /yyy is an
+# absolute path. No other format is supported.
+# 
+XDG_DESKTOP_DIR="$HOME/Desktop"
+XDG_DOWNLOAD_DIR="$HOME/Downloads"
+XDG_TEMPLATES_DIR="$HOME/Templates"
+XDG_PUBLICSHARE_DIR="$HOME/Public"
+XDG_DOCUMENTS_DIR="$HOME/Documents"
+XDG_MUSIC_DIR="$HOME/Music"
+XDG_PICTURES_DIR="$HOME/Pictures"
+XDG_VIDEOS_DIR="$HOME/Videos"'''
+}
+
+class TestRunHelper(OptionParser):
+
+  def __init__(self, runner, get_runner_parser_cb, pass_args=[], paths=[], root=None, need_x=False, need_dbus=False, need_wm=False):
+    OptionParser.__init__(self)
+
+    assert root != None
+
+    self.root = root
+    self._pass_args = pass_args
+    self._need_x = need_x
+    self._need_dbus = need_dbus
+    self._need_wm = need_wm
+
+    assert not need_wm or (need_wm and need_x)
+
+    if self._need_x:
+      self.add_option('--own-display',
+                      action='store_true', dest='wantOwnDisplay', default=False,
+                      help='Run the test inside its own X session')
+    if self._need_dbus:
+      self.add_option('--own-session-bus',
+                      action='store_true', dest='wantOwnSessionBus', default=False,
+                      help='Run the test with its own dbus session')
+
+    runner = os.path.join(self.root, runner)
+    if os.path.isdir(os.path.join(os.path.dirname(__file__), 'python')):
+      sys.path.insert(0, os.path.join(os.path.dirname(__file__), 'python'))
+    sys.path.insert(0, os.path.dirname(runner))
+
+    for path in reversed(paths):
+      sys.path.insert(0, os.path.join(self.root, path))
+
+    self._runner_global = {}
+    self._runner_global['__file__'] = runner
+    saved_argv0 = sys.argv[0]
+    sys.argv[0] = runner
+    try:
+      execfile(runner, self._runner_global)
+
+      runner_parser = get_runner_parser_cb(self._runner_global)
+
+      for arg in self._pass_args:
+        assert runner_parser.has_option(arg)
+        self.add_option(runner_parser.get_option(arg))
+
+    finally:
+      sys.argv[0] = saved_argv0
+
+  def run(self, defaults=[], pre_run_cb=None):
+    (options, args) = self.parse_args()
+
+    respawn_args = []
+    strip_args = []
+
+    if self._need_x and (options.wantOwnDisplay or os.getenv('DISPLAY') == None):
+      respawn_args.extend(['xvfb-run', '-a', '-s', '-screen 0 1024x768x24 -extension MIT-SCREEN-SAVER'])
+      strip_args.append('--own-display')
+    if self._need_dbus and (options.wantOwnSessionBus or os.getenv('DBUS_SESSION_BUS_ADDRESS') == None):
+      respawn_args.extend(['dbus-launch', '--exit-with-session'])
+      strip_args.append('--own-session-bus')
+
+    if len(respawn_args) > 0:
+      import subprocess
+
+      i = 0
+      while len(sys.argv) > 0 and i < len(sys.argv):
+        arg = sys.argv[i]
+        if arg in strip_args:
+          del sys.argv[i]
+          if self.has_option(arg) and self.get_option(arg).action == 'store':
+            del sys.argv[i]
+        else:
+          i+=1
+
+      respawn_args.extend(sys.argv)
+      return subprocess.call(respawn_args, stdin=sys.stdin, stdout=sys.stdout, stderr=sys.stderr)
+
+    sys.argv = []
+    argv = sys.argv
+    argv.append(self._runner_global['__file__'])
+
+    for arg in self._pass_args:
+      opt = self.get_option(arg)
+      action = opt.action
+      val = getattr(options, opt.dest)
+      if val == opt.default and action != 'append':
+        continue
+      if action == 'store':
+        if val != None:
+          argv.extend([arg, str(val)])
+      elif action == 'store_true':
+        if val == True:
+          argv.append(arg)
+      elif action == 'store_false':
+        if val == False:
+          argv.append(arg)
+      elif action == 'append':
+        if val != None:
+          for v in val:
+            argv.extend([arg, str(v)])
+      else:
+        raise RuntimeError('Unexpected argument type with action "%s"' % action)
+
+    for arg in defaults:
+      if arg not in argv:
+        argv.extend([arg, defaults[arg]() if hasattr(defaults[arg], '__call__') else defaults[arg]])
+
+    if pre_run_cb != None:
+      pre_run_cb(options, args)
+
+    argv.extend(args)
+
+    tmphome = tempfile.mkdtemp()
+    os.environ['HOME'] = tmphome
+    for name in skel:
+      os.mkdir(os.path.dirname(os.path.join(tmphome, name)))
+      with open(os.path.join(tmphome, name), 'w+') as f:
+        print >>f, skel[name]
+
+    if self._need_wm:
+      wm = Popen(['/usr/bin/metacity', '--sm-disable', '--no-composite'])
+
+    try:
+      return self._runner_global['main']()
+    finally:
+      if self._need_wm:
+        wm.terminate()
+      shutil.rmtree(tmphome)

=== added file 'debian/testing/xpcshell-build.ini'
--- debian/testing/xpcshell-build.ini	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-build.ini	2013-02-20 09:17:36 +0000
@@ -0,0 +1,19 @@
+[browser/components/places/tests/unit/test_browserGlue_distribution.js]
+head = browser/components/places/tests/unit/head_bookmarks.js
+tail = 
+
+[toolkit/mozapps/extensions/test/xpcshell/test_upgrade.js]
+head = toolkit/mozapps/extensions/test/xpcshell/head_addons.js
+tail = 
+
+[toolkit/mozapps/extensions/test/xpcshell/test_upgrade_strictcompat.js]
+head = toolkit/mozapps/extensions/test/xpcshell/head_addons.js
+tail = 
+
+[toolkit/mozapps/extensions/test/xpcshell-unpack/test_upgrade.js]
+head = toolkit/mozapps/extensions/test/xpcshell-unpack/head_addons.js toolkit/mozapps/extensions/test/xpcshell-unpack/head_unpack.js
+tail = 
+
+[toolkit/mozapps/extensions/test/xpcshell-unpack/test_upgrade_strictcompat.js]
+head = toolkit/mozapps/extensions/test/xpcshell-unpack/head_addons.js toolkit/mozapps/extensions/test/xpcshell-unpack/head_unpack.js
+tail = 

=== added directory 'debian/testing/xpcshell-package-tests'
=== added file 'debian/testing/xpcshell-package-tests/head_package_tests.js'
--- debian/testing/xpcshell-package-tests/head_package_tests.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/head_package_tests.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,160 @@
+const { classes: Cc, interfaces: Ci, results: Cr, utils: Cu } = Components;
+
+const NS_GRE_DIR                        = "GreD";
+const XRE_EXECUTABLE_FILE               = "XREExeF";
+const NS_XPCOM_INIT_CURRENT_PROCESS_DIR = "MozBinD";
+
+Cu.import("resource://gre/modules/Services.jsm");
+
+do_get_profile();
+
+var provider = {
+  getFile: function() {
+    throw Cr.NS_ERROR_FAILURE;
+  },
+
+  getFiles: function(prop) {
+    if (prop == "XREExtDL") {
+      return {
+        getNext: function() {
+          throw Cr.NS_ERROR_FAILURE;
+        },
+        hasMoreElements: function() {
+          return false;
+        },
+        QueryInterface: function(iid) {
+          if (iid.equals(Ci.nsISimpleEnumerator) ||
+              iid.equals(Ci.nsISupports)) {
+            return this;
+          }
+          throw Cr.NS_ERROR_NO_INTERFACE;
+        }
+      };
+    }
+    throw Cr.NS_ERROR_FAILURE;
+  },
+
+  QueryInterface: function(iid) {
+    if (iid.equals(Ci.nsIDirectoryServiceProvider2) ||
+        iid.equals(Ci.nsIDirectoryServiceProvider) ||
+        iid.equals(Ci.nsISupports)) {
+      return this;
+    }
+    throw Cr.NS_ERROR_NO_INTERFACE;
+  }
+};
+
+Services.dirsvc.registerProvider(provider);
+
+function createAppInfo(id, name, version, platformVersion)
+{
+  gXULAppInfo = {
+    vendor: "Mozilla",
+    name: name,
+    ID: id,
+    version: version,
+    appBuildID: "20121202",
+    platformVersion: platformVersion,
+    platformBuildID: "20121202",
+    inSafeMode: false,
+    logConsoleErrors: true,
+    OS: "XPCShell",
+    XPCOMABI: "noarch-spidermonkey",
+    invalidateCachesOnRestart: function invalidateCachesOnRestart() {},
+
+    QueryInterface: function QueryInterface(iid) {
+      if (iid.equals(Ci.nsIXULAppInfo) ||
+          iid.equals(Ci.nsIXULRuntime) ||
+          iid.equals(Ci.nsISupports)) {
+        return this;
+      }
+
+      throw Cr.NS_ERROR_NO_INTERFACE;
+    }
+  };
+
+  var XULAppInfoFactory = {
+    createInstance: function (outer, iid) {
+      if (outer != null)
+        throw Cr.NS_ERROR_NO_AGGREGATION;
+      return gXULAppInfo.QueryInterface(iid);
+    }
+  };
+
+  var registrar = Components.manager.QueryInterface(Ci.nsIComponentRegistrar);
+  registrar.registerFactory(Components.ID("{ee408b20-f0c6-4474-bdfe-f8a1f377ca3d}"),
+                            "XULAppInfo",
+                            "@mozilla.org/xre/app-info;1", XULAppInfoFactory);
+}
+
+function do_run_test_in_subprocess_with_params(aTestFile, aParams, aEnv, aCallback)
+{
+  let proc = Cc["@mozilla.org/process/util;1"].createInstance(Ci.nsIProcess);
+  proc.init(Services.dirsvc.get("XREExeF", Ci.nsIFile));
+
+  function addQuotes(str) {
+    return "\"" + str + "\"";
+  }
+
+  let head_files = _HEAD_FILES.map(addQuotes);
+  let tail_files = _TAIL_FILES.map(addQuotes);
+
+  let args = [ "-g", Services.dirsvc.get(NS_GRE_DIR, Ci.nsIFile).path,
+               "-a", Services.dirsvc.get(NS_XPCOM_INIT_CURRENT_PROCESS_DIR, Ci.nsIFile).path,
+               "-m", "-n", "-s",
+               "-e", "const _HEAD_JS_PATH = \"" + _HEAD_JS_PATH + "\";",
+               "-e", "const _TESTING_MODULES_DIR = \"" + _TESTING_MODULES_DIR + "\";",
+               "-f", _HEAD_JS_PATH,
+               "-e", "const _HEAD_FILES = [" + head_files.join() + "];",
+               "-e", "const _TAIL_FILES = [" + tail_files.join() + "];",
+               "-e", "const _TEST_FILE = [\"" + do_get_file(aTestFile).path + "\"];" ];
+
+  if (aParams) {
+    for (let param in aParams) {
+      args.push("-e", "const " + param + " = \"" + aParams[param] + "\";");
+    }
+  }
+
+  args.push("-e", "_execute_test(); quit(_passed ? 0 : -1);");
+
+  let envs = Cc["@mozilla.org/process/environment;1"].getService(Ci.nsIEnvironment);
+  let restoreEnv = {};
+
+  if (aEnv) {
+    for (let v in aEnv) {
+      if (envs.exists(v)) {
+        restoreEnv[v] = envs.get(v);
+      }
+      envs.set(v, aEnv[v]);
+    }
+  }
+
+  do_print("Running " + aTestFile + " in subprocess");
+
+  proc.runAsync(args, args.length, {
+                observe: function(subject, topic, data) {
+    if (aCallback) {
+      aCallback(topic == "process-finished" && proc.exitValue == 0);
+    }
+  }}, false);
+
+  if (aEnv) {
+    for (let v in aEnv) {
+      envs.set(v, restoreEnv[v]);
+    }
+  }
+}
+
+function run_tests_async(aTests, aCallback)
+{
+  function maybe_schedule_next_test() {
+    let i;
+    if ((i = aTests.shift())) {
+      do_execute_soon(function() {
+        aCallback(i, maybe_schedule_next_test);
+      });
+    }
+  }
+
+  maybe_schedule_next_test();
+}

=== added file 'debian/testing/xpcshell-package-tests/test_langpack_chrome.js'
--- debian/testing/xpcshell-package-tests/test_langpack_chrome.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/test_langpack_chrome.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,84 @@
+Cu.import("resource://gre/modules/AddonManager.jsm");
+Cu.import("resource://gre/modules/FileUtils.jsm");
+
+function run_test()
+{
+  Services.prefs.setBoolPref("intl.locale.matchOS", false);
+
+  let appIni = Services.dirsvc.get("CurProcD", Ci.nsIFile);
+  appIni.append("application.ini");
+
+  let parser = Components.manager.getClassObjectByContractID("@mozilla.org/xpcom/ini-parser-factory;1", Ci.nsIINIParserFactory).createINIParser(appIni);
+
+  createAppInfo(parser.getString("App", "ID"), parser.getString("App", "Name"), parser.getString("App", "Version"), parser.getString("Gecko", "MaxVersion"));
+
+  Cc["@mozilla.org/addons/integration;1"].getService(Ci.nsIObserver).observe(null, "addons-startup", null);
+
+  // We've started the addon manager, but need to manually register addon chrome
+  // for non-restartless addons. This is normally handled in
+  // toolkit/xre/nsXREDirProvider.cpp, which is not available to xpcshell. When
+  // we use restartless language packs, this can go away
+  let extensions_ini = Services.dirsvc.get("ProfD", Ci.nsIFile);
+  extensions_ini.append("extensions.ini");
+
+  let re = /langpack-[a-zA-Z\-]+@firefox.mozilla.org.xpi/;
+  parser = Components.manager.getClassObjectByContractID("@mozilla.org/xpcom/ini-parser-factory;1", Ci.nsIINIParserFactory).createINIParser(extensions_ini);
+  let e = parser.getKeys("ExtensionDirs");
+  while (e.hasMore()) {
+    let k = e.getNext();
+    let file = new FileUtils.File(parser.getString("ExtensionDirs", k));
+    if (file.leafName.match(re)) {
+      Components.manager.addBootstrappedManifestLocation(file);
+    }
+  }
+
+  let istream = Services.io.newChannelFromURI(Services.io.newFileURI(do_get_file("data/locales.shipped"))).open();
+
+  let line = { value: "" };
+  let locales = [];
+  while (istream.readLine(line)) {
+    if (!line.value.match(/^\s*#.*/)) {
+      locales.push(line.value.replace(/^([^:]*).*/, "$1"))
+    }
+  }
+
+  // For most locales, "chrome://global/locale/intl.properties:general.useragent.locale"
+  // is set to the locale. There are some exceptions though, listed here:
+  const OVERRIDES = {
+    "bn-BD": "en-US",
+    "cs": "cs-CZ",
+    "da": "da-DK",
+    "el": "el-GR",
+    "fa": "fa-IR",
+    "fi": "fi-FI",
+    "gl": "gl-ES",
+    "he": "he-IL",
+    "hi-IN": "en-US",
+    "hu": "hu-HU",
+    "is": "is-IS",
+    "kn": "kn-IN",
+    "ko": "ko-KR",
+    "lv": "lv-LV",
+    "mai": "en-US",
+    "mk": "mk-MK",
+    "mr": "mr-IN",
+    "pa-IN": "pa",
+    "pl": "pl-PL",
+    "si": "si-LK",
+    "te": "te-IN",
+    "tr": "tr-TR"
+  };
+
+  locales.forEach(function(locale) {
+    do_print("Testing locale " + locale);
+
+    Services.strings.flushBundles();
+    Services.prefs.setCharPref("general.useragent.locale", locale);
+
+    if (locale in OVERRIDES) {
+      locale = OVERRIDES[locale];
+    }
+
+    do_check_eq(Services.strings.createBundle("chrome://global/locale/intl.properties").GetStringFromName("general.useragent.locale"), locale);
+  });
+}

=== added file 'debian/testing/xpcshell-package-tests/test_langpack_load.js'
--- debian/testing/xpcshell-package-tests/test_langpack_load.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/test_langpack_load.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,46 @@
+Cu.import("resource://gre/modules/AddonManager.jsm");
+
+function run_test()
+{
+  let appIni = Services.dirsvc.get("CurProcD", Ci.nsIFile);
+  appIni.append("application.ini");
+
+  let parser = Components.manager.getClassObjectByContractID("@mozilla.org/xpcom/ini-parser-factory;1", Ci.nsIINIParserFactory).createINIParser(appIni);
+
+  createAppInfo(parser.getString("App", "ID"), parser.getString("App", "Name"), parser.getString("App", "Version"), parser.getString("Gecko", "MaxVersion"));
+
+  Cc["@mozilla.org/addons/integration;1"].getService(Ci.nsIObserver).observe(null, "addons-startup", null);
+  do_test_pending();
+
+  let istream = Services.io.newChannelFromURI(Services.io.newFileURI(do_get_file("data/locales.shipped"))).open();
+
+  let line = { value: "" };
+  let locales = {};
+  while (istream.readLine(line)) {
+    if (!line.value.match(/^\s*#.*/)) {
+      locales[line.value.replace(/^([^:]*).*/, "$1")] = false;
+    }
+  }
+
+  AddonManager.getAddonsByTypes(["locale"], function(addons) {
+    let re = /langpack-([a-zA-Z\-]+)@firefox.mozilla.org/;
+
+    addons.forEach(function(addon) {
+      let m = addon.id.match(re);
+      if (!m) {
+        return;
+      }
+
+      if (m[1] in locales && !addon.appDisabled) {
+        locales[m[1]] = true;
+      }
+    });
+
+    Object.keys(locales).forEach(function(locale) {
+      do_print("Checking if the addon manager found a language pack for " + locale);
+      do_check_true(locales[locale]);
+    });
+
+    do_test_finished();
+  });
+}

=== added file 'debian/testing/xpcshell-package-tests/test_locale_matchOS.js'
--- debian/testing/xpcshell-package-tests/test_locale_matchOS.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/test_locale_matchOS.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,39 @@
+gLocales = {
+  "en_US.UTF-8": "en-US",
+  "fr_FR.UTF-8": "fr",
+  "fr_BE.UTF-8": "fr",
+  "pt_BR.UTF-8": "pt-BR",
+  "en_GB.UTF-8": "en-GB",
+  "en_ZM.UTF-8": "en-[A-Z][A-Z]",
+  "es_ES.UTF-8": "es-ES",
+  "es_MX.UTF-8": "es-MX",
+  "es_PY.UTF-8": "es-[A-Z][A-Z]"
+};
+
+function do_test(aLocale, aCallback)
+{
+  do_test_pending();
+  do_print("Starting test for " + aLocale);
+  do_run_test_in_subprocess_with_params("test_locale_matchOS_real.js",
+                                        { "_TEST_SELECTED_LOCALE": gLocales[aLocale] },
+                                        { "LC_ALL": aLocale },
+                                        function(aSuccess) {
+    do_check_true(aSuccess);
+    do_print("Finished test for " + aLocale);
+    aCallback();
+    do_test_finished();
+  });
+}
+
+function run_test()
+{
+  _XPCSHELL_PROCESS = "parent";
+
+  try {
+    do_check_true(Services.prefs.getBoolPref("intl.locale.matchOS"));
+  } catch(e) {
+    do_check_true(false);
+  }
+
+  run_tests_async(Object.keys(gLocales), do_test);
+}

=== added file 'debian/testing/xpcshell-package-tests/test_locale_matchOS_real.js'
--- debian/testing/xpcshell-package-tests/test_locale_matchOS_real.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/test_locale_matchOS_real.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,39 @@
+Cu.import("resource://gre/modules/AddonManager.jsm");
+Cu.import("resource://gre/modules/FileUtils.jsm");
+
+function run_test()
+{
+  do_check_true(!!_TEST_SELECTED_LOCALE);
+  _XPCSHELL_PROCESS = "child-" + Cc["@mozilla.org/process/environment;1"].getService(Ci.nsIEnvironment).get("LC_ALL");
+
+  let appIni = Services.dirsvc.get("CurProcD", Ci.nsIFile);
+  appIni.append("application.ini");
+
+  let parser = Components.manager.getClassObjectByContractID("@mozilla.org/xpcom/ini-parser-factory;1", Ci.nsIINIParserFactory).createINIParser(appIni);
+
+  createAppInfo(parser.getString("App", "ID"), parser.getString("App", "Name"), parser.getString("App", "Version"), parser.getString("Gecko", "MaxVersion"));
+
+  Cc["@mozilla.org/addons/integration;1"].getService(Ci.nsIObserver).observe(null, "addons-startup", null);
+
+  // We've started the addon manager, but need to manually register addon chrome
+  // for non-restartless addons. This is normally handled in
+  // toolkit/xre/nsXREDirProvider.cpp, which is not available to xpcshell. When
+  // we use restartless language packs, this can go away
+  let extensions_ini = Services.dirsvc.get("ProfD", Ci.nsIFile);
+  extensions_ini.append("extensions.ini");
+
+  let re = /langpack-[a-zA-Z\-]+@firefox.mozilla.org.xpi/;
+  parser = Components.manager.getClassObjectByContractID("@mozilla.org/xpcom/ini-parser-factory;1", Ci.nsIINIParserFactory).createINIParser(extensions_ini);
+  let e = parser.getKeys("ExtensionDirs");
+  while (e.hasMore()) {
+    let k = e.getNext();
+    let file = new FileUtils.File(parser.getString("ExtensionDirs", k));
+    if (file.leafName.match(re)) {
+      Components.manager.addBootstrappedManifestLocation(file);
+    }
+  }
+
+  let re = new RegExp(_TEST_SELECTED_LOCALE);
+  let selected = Cc["@mozilla.org/chrome/chrome-registry;1"].getService(Ci.nsIXULChromeRegistry).getSelectedLocale("global");
+  do_check_eq(selected.match(re), selected);
+}

=== added file 'debian/testing/xpcshell-package-tests/test_searchplugins_valid.js'
--- debian/testing/xpcshell-package-tests/test_searchplugins_valid.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/test_searchplugins_valid.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,30 @@
+function do_test(aLocale, aCallback)
+{
+  do_test_pending();
+  do_print("Starting test for " + aLocale);
+  do_run_test_in_subprocess_with_params("test_searchplugins_valid_real.js",
+                                        { "_SEARCHPLUGIN_TEST_LOCALE": aLocale },
+                                        null, function(aSuccess) {
+    do_check_true(aSuccess);
+    do_print("Finished test for " + aLocale);
+    aCallback();
+    do_test_finished();
+  });
+}
+
+function run_test()
+{
+  _XPCSHELL_PROCESS = "parent";
+
+  let istream = Services.io.newChannelFromURI(Services.io.newFileURI(do_get_file("data/locales.shipped"))).open();
+
+  let line = { value: "" };
+  let tests = [];
+  while (istream.readLine(line)) {
+    if (!line.value.match(/^\s*#.*/)) {
+      tests.push(line.value.replace(/^([^:]*).*/, "$1"));
+    }
+  }
+
+  run_tests_async(tests, do_test);
+}

=== added file 'debian/testing/xpcshell-package-tests/test_searchplugins_valid_real.js'
--- debian/testing/xpcshell-package-tests/test_searchplugins_valid_real.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/test_searchplugins_valid_real.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,36 @@
+function run_test()
+{
+  do_check_true(!!_SEARCHPLUGIN_TEST_LOCALE);
+  _XPCSHELL_PROCESS = "child-" + _SEARCHPLUGIN_TEST_LOCALE;
+
+  //Services.prefs.setBoolPref("browser.search.log", true);
+  Services.prefs.setCharPref("general.useragent.locale", _SEARCHPLUGIN_TEST_LOCALE);
+  createAppInfo("xpcshell@tests.mozilla.org", "XPCShell", "1", "1");
+
+  let expected = 0;
+
+  let locations = Services.dirsvc.get("SrchPluginsDL", Ci.nsISimpleEnumerator);
+
+  while (locations.hasMoreElements()) {
+    let location = locations.getNext().QueryInterface(Ci.nsIFile);
+    let entries = location.directoryEntries;
+    while (entries.hasMoreElements()) {
+      entries.getNext();
+      expected++;
+    }
+  }
+
+  do_test_pending();
+
+  Services.search.init({
+    onInitComplete: function(aStatus) {
+      do_check_true(Components.isSuccessCode(aStatus));
+
+      // Check that all of the files in the searchplugin directories
+      // are valid search plugins
+      do_check_eq(Services.search.getEngines().length, expected);
+
+      do_test_finished();
+    }
+  });
+}

=== added file 'debian/testing/xpcshell-package-tests/test_ubuntu_searchplugins.js'
--- debian/testing/xpcshell-package-tests/test_ubuntu_searchplugins.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/test_ubuntu_searchplugins.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,30 @@
+function do_test(aLocale, aCallback)
+{
+  do_test_pending();
+  do_print("Starting test for " + aLocale);
+  do_run_test_in_subprocess_with_params("test_ubuntu_searchplugins_real.js",
+                                        { "_SEARCHPLUGIN_TEST_LOCALE": aLocale },
+                                        null, function(aSuccess) {
+    do_check_true(aSuccess);
+    do_print("Finished test for " + aLocale);
+    aCallback();
+    do_test_finished();
+  });
+}
+
+function run_test()
+{
+  _XPCSHELL_PROCESS = "parent";
+
+  let istream = Services.io.newChannelFromURI(Services.io.newFileURI(do_get_file("data/locales.shipped"))).open();
+
+  let line = { value: "" };
+  let tests = [];
+  while (istream.readLine(line)) {
+    if (!line.value.match(/^\s*#.*/)) {
+      tests.push(line.value.replace(/^([^:]*).*/, "$1"));
+    }
+  }
+
+  run_tests_async(tests, do_test);
+}

=== added file 'debian/testing/xpcshell-package-tests/test_ubuntu_searchplugins_real.js'
--- debian/testing/xpcshell-package-tests/test_ubuntu_searchplugins_real.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/test_ubuntu_searchplugins_real.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,259 @@
+const TEST_MATRIX = {
+//  Locale      Amazon?   Baidu?    DDG?    Google?
+    "en-US":  [ true,     false,    true,   true ],
+    "af":     [ true,     false,    true,   true ],
+    "ar":     [ true,     false,    true,   true ],
+    "as":     [ true,     false,    true,   true ],
+    "ast":    [ false,    false,    true,   true ],
+    "be":     [ false,    false,    true,   true ],
+    "bg":     [ true,     false,    true,   true ],
+    "bn-BD":  [ false,    false,    true,   true ],
+    "bn-IN":  [ true,     false,    true,   true ],
+    "br":     [ true,     false,    true,   true ],
+    "bs":     [ false,    false,    true,   true ],
+    "ca":     [ false,    false,    true,   true ],
+    "cs":     [ false,    false,    true,   true ],
+    "csb":    [ false,    false,    true,   true ],
+    "cy":     [ true,     false,    true,   true ],
+    "da":     [ true,     false,    true,   true ],
+    "de":     [ true,     false,    true,   true ],
+    "el":     [ true,     false,    true,   true ],
+    "en-GB":  [ true,     false,    true,   true ],
+    "en-ZA":  [ true,     false,    true,   true ],
+    "eo":     [ true,     false,    true,   true ],
+    "es-AR":  [ true,     false,    true,   true ],
+    "es-CL":  [ false,    false,    true,   true ],
+    "es-ES":  [ false,    false,    true,   true ],
+    "es-MX":  [ false,    false,    true,   true ],
+    "et":     [ false,    false,    true,   true ],
+    "eu":     [ true,     false,    true,   true ],
+    "fa":     [ true,     false,    true,   true ],
+    "fi":     [ false,    false,    true,   true ],
+    "fr":     [ true,     false,    true,   true ],
+    "fy-NL":  [ false,    false,    true,   true ],
+    "ga-IE":  [ true,     false,    true,   true ],
+    "gd":     [ true,     false,    true,   true ],
+    "gl":     [ true,     false,    true,   true ],
+    "gu-IN":  [ false,    false,    true,   true ],
+    "he":     [ false,    false,    true,   true ],
+    "hi-IN":  [ false,    false,    true,   true ],
+    "hr":     [ true,     false,    true,   true ],
+    "hu":     [ false,    false,    true,   true ],
+    "hy-AM":  [ true,     false,    true,   true ],
+    "id":     [ false,    false,    true,   true ],
+    "is":     [ true,     false,    true,   true ],
+    "it":     [ true,     false,    true,   true ],
+    "ja":     [ true,     false,    true,   true ],
+    "kk":     [ false,    false,    true,   true ],
+    "km":     [ true,     false,    true,   true ],
+    "kn":     [ true,     false,    true,   true ],
+    "ko":     [ false,    false,    true,   true ],
+    "ku":     [ true,     false,    true,   true ],
+    "lg":     [ true,     false,    true,   true ],
+    "lt":     [ true,     false,    true,   true ],
+    "lv":     [ false,    false,    true,   true ],
+    "mai":    [ false,    false,    true,   true ],
+    "mk":     [ true,     false,    true,   true ],
+    "ml":     [ false,    false,    true,   true ],
+    "mn":     [ false,    false,    true,   true ],
+    "mr":     [ true,     false,    true,   true ],
+    "nb-NO":  [ true,     false,    true,   true ],
+    "nl":     [ false,    false,    true,   true ],
+    "nn-NO":  [ true,     false,    true,   true ],
+    "nso":    [ true,     false,    true,   true ],
+    "or":     [ true,     false,    true,   true ],
+    "pa-IN":  [ false,    false,    true,   true ],
+    "pl":     [ false,    false,    true,   true ],
+    "pt-BR":  [ false,    false,    true,   true ],
+    "pt-PT":  [ true,     false,    true,   true ],
+    "ro":     [ true,     false,    true,   true ],
+    "ru":     [ false,    false,    true,   true ],
+    "si":     [ true,     false,    true,   true ],
+    "sk":     [ false,    false,    true,   true ],
+    "sl":     [ false,    false,    true,   true ],
+    "sq":     [ true,     false,    true,   true ],
+    "sr":     [ true,     false,    true,   true ],
+    "sv-SE":  [ false,    false,    true,   true ],
+    "sw":     [ true,     false,    true,   true ],
+    "ta":     [ false,    false,    true,   true ],
+    "te":     [ true,     false,    true,   true ],
+    "th":     [ true,     false,    true,   true ],
+    "tr":     [ true,     false,    true,   true ],
+    "uk":     [ false,    false,    true,   true ],
+    "vi":     [ false,    false,    true,   true ],
+    "zh-CN":  [ true,     true,     true,   true ],
+    "zh-TW":  [ false,    false,    true,   true ],
+    "zu":     [ true,     false,    true,   true ]
+};
+
+const PLUGIN_AMAZON = 0;
+const PLUGIN_BAIDU = 1;
+const PLUGIN_DDG = 2;
+const PLUGIN_GOOGLE = 3;
+
+if (Services.prefs.getCharPref("app.update.channel") == "nightly") {
+  TEST_MATRIX["bs"][PLUGIN_AMAZON] = true;
+}
+
+function get_query_params(aURL)
+{
+  let params = {};
+  aURL.query.split('&').forEach(function(query) {
+    let parts = query.split('=');
+    do_check_eq(parts.length, 2);
+    params[parts[0]] = parts[1];
+  });
+
+  return params;
+}
+
+function test_baidu(aEngine)
+{
+  let url = aEngine.getSubmission("foo").uri.QueryInterface(Ci.nsIURL);
+
+  // We ship the upstream plugin for this one
+  if (url.host == "zhidao.baidu.com") {
+    return false;
+  }
+
+  let params = get_query_params(url);
+
+  let ubuntu = "tn" in params && params["tn"] == "ubuntuu_cb" && "cl" in params && params["cl"] == 3;
+
+  // We only expect to see our Baidu searchplugin
+  do_check_true(ubuntu);
+
+  return ubuntu;
+}
+
+function test_duckduckgo(aEngine)
+{
+  let url = aEngine.getSubmission("foo").uri.QueryInterface(Ci.nsIURL);
+
+  let params = get_query_params(url);
+  let ubuntu = "t" in params && params["t"] == "canonical";
+
+  // We only expect to see our DDG searchplugin
+  do_check_true(ubuntu);
+
+  return ubuntu;
+}
+
+function test_amazon(aEngine)
+{
+  let url = aEngine.getSubmission("foo").uri.QueryInterface(Ci.nsIURL);
+
+  let params = get_query_params(url);
+  let ubuntu = "tag" in params && params["tag"] == "wwwcanoniccom-20";
+
+  // We only expect to see our Amazon searchplugin
+  do_check_true(ubuntu);
+
+  return ubuntu;
+}
+
+function test_google(aEngine)
+{
+  let wanted = {
+    "gl": {
+      "en-GB": "uk",
+      "en-ZA": "za"
+    },
+    "hl": {
+      "ku": "en",
+      "ja": "ja"
+    }    
+  };
+
+  function check_extra_params() {
+    for (let param in wanted) {
+      do_check_eq(params[param], wanted[param][_SEARCHPLUGIN_TEST_LOCALE]);
+    }
+  }
+
+  do_check_eq(Services.io.newURI(aEngine.searchForm, null, null).scheme, "https");
+
+  let url = aEngine.getSubmission("foo").uri.QueryInterface(Ci.nsIURL);
+  // Verify we are using a secure URL
+  do_check_eq(url.scheme, "https");
+
+  let params = get_query_params(url);
+
+  let ubuntu = "client" in params && params["client"] == "ubuntu" && "channel" in params && params["channel"] == "fs";
+
+  // We only expect to see our Google searchplugin
+  do_check_true(ubuntu);
+
+  check_extra_params();
+
+  url = aEngine.getSubmission("foo", "application/x-suggestions+json").uri.QueryInterface(Ci.nsIURL);
+  // Verify we are using a secure URL for suggestions
+  do_check_eq(url.scheme, "https");
+
+  params = get_query_params(url);
+
+  // "client=ubuntu" fails for suggestions
+  do_check_eq(params["client"], "firefox");
+
+  check_extra_params();
+
+  return ubuntu;
+}
+
+function run_test()
+{
+  do_check_true(!!_SEARCHPLUGIN_TEST_LOCALE);
+  _XPCSHELL_PROCESS = "child-" + _SEARCHPLUGIN_TEST_LOCALE;
+
+  //Services.prefs.setBoolPref("browser.search.log", true);
+  Services.prefs.setCharPref("general.useragent.locale", _SEARCHPLUGIN_TEST_LOCALE);
+  createAppInfo("xpcshell@tests.mozilla.org", "XPCShell", "1", "1");
+
+  let found_Google = false;
+  let found_Amazon = false;
+  let found_DDG = false;
+  let found_Baidu = false;
+
+  do_check_true(_SEARCHPLUGIN_TEST_LOCALE in TEST_MATRIX);
+
+  let want_Amazon = TEST_MATRIX[_SEARCHPLUGIN_TEST_LOCALE][PLUGIN_AMAZON];
+  let want_Baidu = TEST_MATRIX[_SEARCHPLUGIN_TEST_LOCALE][PLUGIN_BAIDU];
+  let want_DDG = TEST_MATRIX[_SEARCHPLUGIN_TEST_LOCALE][PLUGIN_DDG];
+  let want_Google = TEST_MATRIX[_SEARCHPLUGIN_TEST_LOCALE][PLUGIN_GOOGLE];
+
+  do_test_pending();
+
+  Services.search.init({
+    onInitComplete: function(aStatus) {
+      do_check_true(Components.isSuccessCode(aStatus));
+
+      Services.search.getEngines().forEach(function(engine) {
+        let host = engine.getSubmission("foo").uri.host;
+        if (host.match(/\.google\./)) {
+          let is_ours = test_google(engine);
+          do_check_true(!(is_ours && found_Google));
+          found_Google = is_ours || found_Google;
+        } else if (host.match(/\.amazon\./)) {
+          let is_ours = test_amazon(engine);
+          do_check_true(!(is_ours && found_Amazon));
+          found_Amazon = is_ours || found_Amazon;
+        } else if (host.match(/duckduckgo\./)) {
+          let is_ours = test_duckduckgo(engine);
+          do_check_true(!(is_ours && found_DDG));
+          found_DDG = is_ours || found_DDG;
+        } else if (host.match(/baidu\./)) {
+          let is_ours = test_baidu(engine);
+          do_check_true(!(is_ours && found_Baidu));
+          found_Baidu = is_ours || found_Baidu;
+        }
+      });
+
+      do_check_true(!((found_Amazon && !want_Amazon) || (!found_Amazon && want_Amazon)));
+      do_check_true(!((found_Baidu && !want_Baidu) || (!found_Baidu && want_Baidu)));
+      do_check_true(!((found_DDG && !want_DDG) || (!found_DDG && want_DDG)));
+      do_check_true(!((found_Google && !want_Google) || (!found_Google && want_Google)));
+
+      do_test_finished();
+    }
+  });
+}

=== added file 'debian/testing/xpcshell-package-tests/test_ubuntu_useragent.js'
--- debian/testing/xpcshell-package-tests/test_ubuntu_useragent.js	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/test_ubuntu_useragent.js	2013-02-20 09:17:36 +0000
@@ -0,0 +1,7 @@
+function run_test()
+{
+  createAppInfo("xpcshell@tests.mozilla.org", "XPCShell", "1", "1");
+
+  let ua = Services.io.newChannel("http://foo", null, null).QueryInterface(Ci.nsIHttpChannel).getRequestHeader("User-Agent");
+  do_check_eq(ua, ua.match(/^Mozilla\/5\.0 \(X11; Ubuntu; Linux [^;]*; rv:[0-9\.]*\) Gecko\/20121202 Firefox\/[0-9\.]*/));
+}

=== added file 'debian/testing/xpcshell-package-tests/xpcshell.ini'
--- debian/testing/xpcshell-package-tests/xpcshell.ini	1970-01-01 00:00:00 +0000
+++ debian/testing/xpcshell-package-tests/xpcshell.ini	2013-02-20 09:17:36 +0000
@@ -0,0 +1,10 @@
+[DEFAULT]
+head = head_package_tests.js
+tail =
+
+[test_searchplugins_valid.js]
+[test_ubuntu_searchplugins.js]
+[test_locale_matchOS.js]
+[test_ubuntu_useragent.js]
+[test_langpack_load.js]
+[test_langpack_chrome.js]

=== added directory 'debian/tests'
=== added file 'debian/tests/control'
--- debian/tests/control	1970-01-01 00:00:00 +0000
+++ debian/tests/control	2013-02-20 09:17:36 +0000
@@ -0,0 +1,2 @@
+Tests: xpcshell-tests xpcshell-package-tests jstestbrowser reftest crashtest mochitest
+Depends: @, libc-bin, make, notify-osd, metacity, language-pack-en-base, language-pack-es-base, language-pack-fr-base, language-pack-pt-base, fonts-arabeyes, fonts-kacst, fonts-takao-mincho, fonts-takao-gothic, ttf-wqy-zenhei, fonts-arphic-uming, ttf-arphic-ukai, fonts-nanum, fonts-nanum-coding, fonts-unfonts-core

=== added file 'debian/tests/crashtest'
--- debian/tests/crashtest	1970-01-01 00:00:00 +0000
+++ debian/tests/crashtest	2013-02-20 09:17:36 +0000
@@ -0,0 +1,8 @@
+#!/bin/sh
+
+TESTSUITE_DIR=/$($(dirname $0)/../rules echo-MOZ_TESTDIR 2>/dev/null)
+
+export LC_ALL=en_US.UTF-8
+mkdir -p $(dirname $0)/_results
+
+$TESTSUITE_DIR/run_reftest --own-display --own-session-bus --xunit-file $(dirname $0)/_results/crashtest.xml --xunit-name "crashtest" $TESTSUITE_DIR/reftest/tests/testing/crashtest/crashtests.list

=== added file 'debian/tests/jstestbrowser'
--- debian/tests/jstestbrowser	1970-01-01 00:00:00 +0000
+++ debian/tests/jstestbrowser	2013-02-20 09:17:36 +0000
@@ -0,0 +1,11 @@
+#!/bin/sh
+
+TESTSUITE_DIR=/$($(dirname $0)/../rules echo-MOZ_TESTDIR 2>/dev/null)
+
+export LC_ALL=en_US.UTF-8
+mkdir -p $(dirname $0)/_results
+
+# Required for js/src/trace-tests/sunspider/check-date-format-tofte.js
+export TZ=:/usr/share/zoneinfo/posix/US/Pacific
+
+$TESTSUITE_DIR/run_reftest --own-display --own-session-bus --xunit-file $(dirname $0)/_results/jstestbrowser.xml --xunit-name "jstestbrowser" --tests-root-dir $TESTSUITE_DIR/jsreftest/tests --extra-profile-file=$TESTSUITE_DIR/jsreftest/tests/user.js $TESTSUITE_DIR/jsreftest/tests/jstests.list

=== added file 'debian/tests/mochitest'
--- debian/tests/mochitest	1970-01-01 00:00:00 +0000
+++ debian/tests/mochitest	2013-02-20 09:17:36 +0000
@@ -0,0 +1,31 @@
+#!/bin/sh
+
+TESTSUITE_DIR=/$($(dirname $0)/../rules echo-MOZ_TESTDIR 2>/dev/null)
+
+export LC_ALL=en_US.UTF-8
+mkdir -p $(dirname $0)/_results
+
+echo "*************************"
+echo "* Running browser tests *"
+echo "*************************"
+$TESTSUITE_DIR/run_mochitest --own-display --own-session-bus --xunit-file $(dirname $0)/_results/mochitest-browser-chrome.xml --browser-chrome
+
+echo "***********************"
+echo "* Running plain tests *"
+echo "***********************"
+$TESTSUITE_DIR/run_mochitest --own-display --own-session-bus --xunit-file $(dirname $0)/_results/mochitest-plain.xml
+
+echo "************************"
+echo "* Running chrome tests *"
+echo "************************"
+$TESTSUITE_DIR/run_mochitest --own-display --own-session-bus --xunit-file $(dirname $0)/_results/mochitest-chrome.xml --chrome
+
+echo "**********************"
+echo "* Running a11y tests *"
+echo "**********************"
+$TESTSUITE_DIR/run_mochitest --own-display --own-session-bus --xunit-file $(dirname $0)/_results/mochitest-a11y.xml --a11y
+
+echo "****************************"
+echo "* Running ipcplugins tests *"
+echo "****************************"
+$TESTSUITE_DIR/run_mochitest --own-display --own-session-bus --xunit-file $(dirname $0)/_results/mochitest-ipcplugins.xml --xunit-name "mochitest.ipcplugins" --setpref=dom.ipc.plugins.enabled=false --test-path=dom/plugins/test

=== added file 'debian/tests/reftest'
--- debian/tests/reftest	1970-01-01 00:00:00 +0000
+++ debian/tests/reftest	2013-02-20 09:17:36 +0000
@@ -0,0 +1,8 @@
+#!/bin/sh
+
+TESTSUITE_DIR=/$($(dirname $0)/../rules echo-MOZ_TESTDIR 2>/dev/null)
+
+export LC_ALL=en_US.UTF-8
+mkdir -p $(dirname $0)/_results
+
+$TESTSUITE_DIR/run_reftest --own-display --own-session-bus --xunit-file $(dirname $0)/_results/reftest.xml --xunit-name "reftest" $TESTSUITE_DIR/reftest/tests/layout/reftests/reftest.list

=== added file 'debian/tests/xpcshell-package-tests'
--- debian/tests/xpcshell-package-tests	1970-01-01 00:00:00 +0000
+++ debian/tests/xpcshell-package-tests	2013-02-20 09:17:36 +0000
@@ -0,0 +1,8 @@
+#!/bin/sh
+
+TESTSUITE_DIR=/$($(dirname $0)/../rules echo-MOZ_TESTDIR 2>/dev/null)
+
+export LC_ALL=en_US.UTF-8
+mkdir -p $(dirname $0)/_results
+
+$TESTSUITE_DIR/run_xpcshell_tests --own-display --own-session-bus --xunit-file $(dirname $0)/_results/xpcshell-package-tests.xml --xunit-suite-name "xpcshell.package" --manifest $TESTSUITE_DIR/xpcshell/package-tests/xpcshell.ini

=== added file 'debian/tests/xpcshell-tests'
--- debian/tests/xpcshell-tests	1970-01-01 00:00:00 +0000
+++ debian/tests/xpcshell-tests	2013-02-20 09:17:36 +0000
@@ -0,0 +1,8 @@
+#!/bin/sh
+
+TESTSUITE_DIR=/$($(dirname $0)/../rules echo-MOZ_TESTDIR 2>/dev/null)
+
+export LC_ALL=en_US.UTF-8
+mkdir -p $(dirname $0)/_results
+
+$TESTSUITE_DIR/run_xpcshell_tests --own-display --own-session-bus --xunit-file $(dirname $0)/_results/xpcshell-tests.xml --xunit-suite-name "xpcshell" --manifest $TESTSUITE_DIR/xpcshell/tests/xpcshell.ini

